/* Interhack   Multi-player Rougelike game (based on Nethack)
   Copyright (C) 1996-2000  Damian Bentley

   See license.txt for details. If you do not have a copy of the license,
   please email bendchon@mehta.anu.edu.au */

#ifndef _branch_h_
#define _branch_h_

#include "align.h"
#include "level.h"
#include "string.h"

typedef enum E_BranchType {
    normalBranch, mazeBranch, mineBranch, sewerBranch, templateBranch
} EBranchType;

class CBranch {
public:
    CBranch(CBranch *, CBranch *, char *, int);
    ~CBranch();
    void create();
    CLevel * getLevel(int);
    CLevel * getBranchLevel1(int);
    int getRand(char *);
    int getNum(char *);
    CBranch * getParent() { return parent; };
    int getLocation() { return location; };
    CLevel * get(string);
    string getName() { return name; };
private:
    CBranch * next;
    CBranch * branches;
    CLevel * levels;
    CBranch * parent;
    string name;
    char id[3];
    EBranchType branchType;
    aligntyp alignment;
    bool hellish;
    int depth;
    int location;
    EEntryType entryType;
    bool noDown;
protected:
};

#endif
