/* Interhack   Multi-player Rougelike game (based on Nethack)
   Copyright (C) 1996-2000  Damian Bentley

   See license.txt for details. If you do not have a copy of the license,
   please email bendchon@mehta.anu.edu.au */

#ifndef _cmonlist_h_
#define _cmonlist_h_

#include "system.h"
#include "string.h"
#include "location.h"
#include "color.h"

class CClientMonster {
public:
    CClientMonster(CClientMonster *n, string s, ID id, string sn, char t,
        CLocation loc, int color) {
        next = n; test = s; IID = id; SName = sn; 
        CSpecies = t; xy = loc; IColor = color; };

    ~CClientMonster() { if (next != NULL) delete next; next = NULL; };
    void update(string s, ID id, string sn, char t, CLocation loc) {
        test = s; IID = id; SName = sn; CSpecies = t; xy = loc;
        if (test == "null") CSpecies = '0'; };
    void update(CLocation loc) { xy = loc; };

    string getName() { return SName; };

    int getID() { return IID; };

    char getSpecies() { return CSpecies; };

    CClientMonster * find(CLocation l) {
        if (l == xy) return this;
        if (next != NULL) return next->find(l);
        return NULL; };
    int getColor() { return IColor; };

    CClientMonster * next;
    string test;
    ID IID;
    string SName;
    char CSpecies;
    CLocation xy;
    int IColor;
	
private:
    
protected:
};

class CClientMonsterList {

    /* Read an monster list from a socket connection */
    friend CSock& operator>> (CSock& s, CClientMonsterList& m) {
        ID id; string str; string strn;
        char t;
        CLocation xy;
        int count;
        int color;

        s >> count;
        for (int i = 0 ; i < count; i++) {
            s >> str; s >> id; s >> strn; s >> t; s >> xy; s >> color;
            m.head = new CClientMonster(m.head, str, id, strn,
                  t, xy, color);
            m.size++;
        }
        return s; };

public:
    CClientMonsterList() {head = NULL;};
    ~CClientMonsterList() { if (head != NULL) delete head; head = NULL; };
    int getSize() { return size; };

    CClientMonster * find(CLocation l) {
        if (head != NULL) return head->find(l);
        return NULL; };

    /* Find a minster of type ID */
    CClientMonster * find(ID monst) {
        for (current = head; current != NULL; current = current->next)
            if (current->IID == monst)
                return current;
        return NULL;
    };

    void removeAll() { if (head != NULL) delete head; head = NULL; size = 0; };
    
    void remove(ID i) {
        CClientMonster * temp = find(i);
        if (temp == NULL) return;
        if (temp == head) {
            head = temp->next;
            temp->next = NULL;
            delete temp;
            temp = NULL;
        } else
            for (current = head; current != NULL; current = current->next)
                if (current->next == temp) {
                    current->next = temp->next;
                    temp->next = NULL;
                    delete temp;
                    temp = NULL;
                    return;
                }
    };

private:
    int size;
    CClientMonster * head;
    CClientMonster * current; //for find only
protected:
};

#endif
