/* Interhack   Multi-player Rougelike game (based on Nethack)
   Copyright (C) 1996-2000  Damian Bentley

   See license.txt for details. If you do not have a copy of the license,
   please email bendchon@mehta.anu.edu.au */

#include "cplist.h"

CClientPlayer * cplist[MAXPLAYERS];

CSock& operator>> (CSock& s, CClientPlayerList& l) {
    for (int i = 0; i < MAXPLAYERS; i++)
        if (cplist[i] != NULL) { delete cplist[i]; cplist[i] = NULL; }
    s >> l.size;
    for (int i = 0; i < l.size; i++) {
        int id, lvl, type;
        string name, flags, dgn;
        char sym;
        CLocation xy;
        /* For some reasons the following two lines if done in the normal
           method (>> id >> name >> type) produced a segmentation fault
           when compiled with the -O2 option. Change it to this and it
           works fine. Possibly something wrong with socket code? */
        s >> id; s >> name; s >> type; s >> dgn;
        s >> lvl; s >> flags; s >> xy; s >> sym;
        cplist[id] = new CClientPlayer(name, type, id, dgn, lvl, flags, sym);
        cplist[id]->constructLine();
    }
    return s;
};

static const char * beginptr = "Name(c) lvl flags\0";
static const char * endptr = "(end)\0";

char ** CClientPlayerList::menu() {
    int index = 0;
    lines[index++] = (char *)beginptr;
    for (int i = 0; i < MAXPLAYERS; i++)
        if (cplist[i] != NULL) lines[index++] = cplist[i]->menu();
    lines[index++] = (char *)endptr;
    lines[index] = (char *)NULL;
    return lines;
};
