/* Interhack   Multi-player Rougelike game (based on Nethack)
   Copyright (C) 1996-2000  Damian Bentley

   See license.txt for details. If you do not have a copy of the license,
   please email bendchon@mehta.anu.edu.au */

#include "hack.h"
#include "vision.h"

/* Remove an accessory from the player - we do not actually remove the
   object here, we only do that when told by the server */
void CHack::remove_accessory() {
    int kin, count = 0;
    string tempstr = "What do you want to take off? [";
    CClientObject * tempobj = NULL;
    if (amulet != NULL) {
        tempstr += amulet->letter; tempobj = amulet; count++; }
    if (left_ring != NULL) {
        tempstr += left_ring->letter; tempobj = left_ring; count++; }
    if (right_ring != NULL) {
        tempstr += right_ring->letter; tempobj = right_ring; count++; }
    tempstr += " or ?*] ";

    if (count == 0) {
        vision.topline("Not wearing any accessories.");
        return;
    } else if (count > 1) {
        do {
            kin = vision.inputch(tempstr);
            if (kin == '\r') { vision.topline("Never mind."); return; }
            tempobj = cpack.find(kin);   
            if (tempobj == NULL)
                vision.inputch("You don't have that object.--More--");
            else if (tempobj != amulet && tempobj != left_ring &&
                     tempobj != right_ring) {
                if (tempobj->otype != Ring &&
                    tempobj->otype != Amulet)
                    vision.topline("That is a silly thing to take off.");
                else
                    vision.topline("You are not wearing that.");
                return;
            }
        } while (tempobj == NULL);
    }

    if (tempobj->cursed == true) {
        vision.topline("You can't.  It seems to be cursed.");
        return;
    }

    *sock << p_takeoff << tempobj->id << p_end;
}

/* Put an accessory on - We do not actually put the accessory on here, we
   do that when told by the server */
void CHack::puton_accessory() {
    int kin;
    CClientObject * tempobj;
    int loc = 0;

    tempobj = cpack.select("put on", Ring, Amulet);
    if (tempobj == NULL) return;

    if (tempobj->otype == Amulet) {
        if (amulet != NULL) {
            vision.topline("You are already wearing an amulet.");
            return;
        }
    } else if (tempobj->otype == Ring) {
        if (right_ring == NULL && left_ring == NULL) {
            do {
                kin = vision.inputch("Which ring-finger, Right or Left? [rl] ");
                if (kin == 'l') loc = BODY_LEFT_RING;
                if (kin == 'r') loc = BODY_RIGHT_RING;
            } while (kin != '\r' && kin != 'r' && kin != 'l');
            if (kin == '\r') {
                vision.topline("Never mind."); return; }
        } else if (right_ring != NULL && left_ring != NULL) {
            vision.topline("There are no more ring-fingers to fill.");
            return;
        } else {
            if (right_ring == NULL)
                loc = BODY_RIGHT_RING;
            else
                loc = BODY_LEFT_RING;
            if (left_ring == tempobj || right_ring == tempobj) {
                vision.topline("You are already wearing that!");
                return;
            }
        }
    }

    *sock << p_puton << tempobj->id;
    if (loc != 0) *sock << loc;
    *sock << p_end;
}
