/* Interhack   Multi-player Rougelike game (based on Nethack)
   Copyright (C) 1996-2000  Damian Bentley

   See license.txt for details. If you do not have a copy of the license,
   please email bendchon@mehta.anu.edu.au */

#include "hack.h"
#include "vision.h"

/* Wear some armor */
void CHack::wear_armor() {
    CClientObject * tempobj;

    /* Construct the prompt */
    tempobj = cpack.select("wear", Armor);
    if (tempobj == NULL) return;

    /* Check for valid input */
    if (tempobj == boots || tempobj == gloves || tempobj == helmet ||
        tempobj == shirt || tempobj == armor || tempobj == cloak ||
        tempobj == shield) {
        vision.topline("You are already wearing that!");
        return;
    }
    EArmorType a = tempobj->atype;
    if (((a == ShirtHawaiian || a == ShirtT) && shirt != NULL) ||
        ((a >= DragonGray && a <= ArmLeatherJacket) && armor != NULL) ||
        ((a >= CloakMummyWrapping && a <= CloakDisplacement) && cloak != NULL) ||
        ((a >= HelmElvenLeather && a <= HelmTelepathy) && helmet != NULL) ||
        ((a >= GloveLeather && a <= GloveDexterity) && gloves != NULL) ||
        ((a >= ShieldSmall && a <= ShieldReflection) && shield != NULL) ||
        ((a >= BootsLow && a <= BootsLevitation) && boots != NULL)) {
        vision.topline("You are already wearing a XXXX.");
        return;
    }
 
    /* Inform the server of the move */
    *sock << p_wear << tempobj->id << p_end;
}

/* Remove some armor */
void CHack::remove_armor() {
    int kin, count = 0;

    /* Construct prompt */
    string tempstr = "What do you want to take off? [";
    CClientObject * tempobj = NULL;
    if (boots != NULL) {
        tempstr += boots->letter; tempobj = boots; count++; }
    if (gloves != NULL) {
        tempstr += gloves->letter; tempobj = gloves; count++; }
    if (helmet != NULL) {
        tempstr += helmet->letter; tempobj = helmet; count++; }
    if (shirt != NULL && armor == NULL && cloak == NULL) {
        tempstr += shirt->letter; tempobj = shirt; count++; }
    if (armor != NULL && cloak == NULL) {
        tempstr += armor->letter; tempobj = armor; count++; }
    if (cloak != NULL) {
        tempstr += cloak->letter; tempobj = cloak; count++; }
    if (shield != NULL) {
        tempstr += shield->letter; tempobj = shield; count++; }
    tempstr += " or ?*] ";

    /* Get users input */
    if (count == 0) {
        vision.topline("Not wearing any armor.");
        return;
    } else if (count > 1) {
        do {
            kin = vision.inputch(tempstr);
            if (kin == '\r') { vision.topline("Never mind."); return; }
            tempobj = cpack.find(kin);   
            if (tempobj == NULL)
                vision.inputch("You don't have that object.--More--");
            else if (tempobj != boots && tempobj != gloves &&
                     tempobj != helmet && tempobj != shirt &&
                     tempobj != armor && tempobj != cloak &&
                     tempobj != shield) {
                if (tempobj->otype != Armor)
                    vision.topline("That is a silly thing to take off.");
                else
                    vision.topline("You are not wearing that.");
                return;
            }
        } while (tempobj == NULL);
    }

    if (tempobj->cursed == true) {
        vision.topline("You can't.  It seems to be cursed.");
        return;
    }

    /* Inform server */
    *sock << p_remove << tempobj->id << p_end;
}
