/* Interhack   Multi-player Rougelike game (based on Nethack)
   Copyright (C) 1996-2000  Damian Bentley

   See license.txt for details. If you do not have a copy of the license,
   please email bendchon@mehta.anu.edu.au */

#ifndef _deffile_h_
#define _deffile_h_

#include <fstream.h>

#include "location.h"

#define DEFFILE         "./dat/dungeon.def"
#define TYPESIZE	32
#define LINESIZE        128
#define FIELDSIZE	32
#define COMMENTCHAR	'#'
#define TYPECHAR	':'
#define SPACE		' '
#define TAB		'\t'
#define ENDLINE		'\0'

class Deffile {
public:
    Deffile();				// Create the class
    ~Deffile();				// Destroy the class
    int start(char *);			// Open the des file
    int finish();			// Close the des file
    char * readline();			// read a line from the des file
    char * linetype();			// returns the line type read
    char * first_field();		// returns the first field
    char * next_field();		// returns the next field
    int read_number();			// returns a number of the current field
    int read_random();			// random number based on (x, y);
    char * read_base();			// base string of "asdf" + (...);
    char * n_field(int);		// returns field n
    CLocation read_location();		// returns a location
private:
    ifstream infile;
    char inbuffer[LINESIZE];
    char thelinetype[TYPESIZE];
    char field[FIELDSIZE];
    char base[FIELDSIZE];
    char * fieldptr;
};

extern Deffile deffile;

#endif
