/* Interhack   Multi-player Rougelike game (based on Nethack)
   Copyright (C) 1996-2000  Damian Bentley

   See license.txt for details. If you do not have a copy of the license,
   please email bendchon@mehta.anu.edu.au */

#include "player.h"
#include "log.h"

/* Dip an object into something else */
int CPlayer::dip() {
    ID tid, pid;
    CObject * tobj = NULL;
    CObject * pobj = NULL;
    CPotion * pot = NULL;

    /* Read in the two object id's, and find the objects */
    *sock >> tid; *sock >> pid;
    tobj = pack.find(tid);
    pobj = pack.find(pid);
    if (tobj == NULL) {
        log << "WARNING: invalid object to dip" << '\n';
        return -1;
    }
    if (pobj == NULL) {
        log << "WARNING: invalid object to dip into" << '\n';
        return -1;
    }
    if (pobj->getObjectType() != Potion) {
        log << "WARNING: player dipping into non-potion" << '\n';
        log << "TODO: player dipping into fountain / sinks" << '\n';
        return -1;
    }

    /* Dip the two objects together */
    log << "TODO: messages etc when dipping objects" << '\n';
    pot = (CPotion *)pobj;
    pot->dip(*tobj);

    return 0;
}
