/* Interhack   Multi-player Rougelike game (based on Nethack)
   Copyright (C) 1996-2000  Damian Bentley

   See license.txt for details. If you do not have a copy of the license,
   please email bendchon@mehta.anu.edu.au */

#include "system.h"
#include "string.h"
#include "vision.h"

static const char * SCommands[] = {
    "quit",
    (const char *)NULL
};

/* Player has pressed '#' for an extended command */
int extendedCommand() {
    string prompt, command;
    int kin, unique, cmd;
    while (1) {
        /* Construct the prompt and wait for input */
        prompt = "# ";
        prompt += command;
        vision.topline(prompt);
        kin = vision.inputch();


        /* Deal with enter and backspace */
        if (kin == '\r') break;
        if (kin == KEY_BACKSPACE) {
            command = "";
            continue;
        }


        /* Now deal with the "intelligent guess of the command" */
        command += (char)kin;
        unique = 0;
        /* Check first 3 characters in prompt */
        for (int n = 0; n < 3; n++)
            if (unique != 1 && command.size() > n) {
                unique = 0;
                for (int i = 0; SCommands[i] != NULL; i++)
                    if (command[n] == SCommands[i][n]) { unique++; cmd = i; };
            }
        if (unique == 1)
            command = (char *)SCommands[cmd];
    }

    /* Deal with the command */
    if (command == "quit") return -1;
    else if (command == "?") vision.displayFile("./dat/sextend");
    else if (command.size() > 0) {
        command += ": unknown extended command.";
        vision.topline(command);
    } else
        vision.topline("");

    return 0;
}
