/* Interhack   Multi-player Rougelike game (based on Nethack)
   Copyright (C) 1996-2000  Damian Bentley

   See license.txt for details. If you do not have a copy of the license,
   please email bendchon@mehta.anu.edu.au */

#ifndef _hack_h_
#define _hack_h_

#include "clevel.h"
#include "cplist.h"
#include "options.h"
#include "tcpip.h"
#include "attrib.h"

void read_command_line(int, char**, bool amServer = false);

class CHack {
public:
    CHack() {
        sock = NULL;
        myid = -1;
        waiting = false;
        inWizMode = false;
        helmet = gloves = boots = shirt = armor = cloak = shield = NULL;
        pri_weapon = sec_weapon = NULL;
        left_ring = right_ring = amulet = blindfold = NULL; };
    ~CHack() {
        if (sock != NULL) delete sock; sock = NULL; };
    int client_main(bool);
    void login();
    int character_type();

    int incomming_data();
    int keypress(int);

    Direction getDirection();

    void update();
    void players_update();
    void players_refresh();
    void updateObject();
    void dropedObject();

    /* These are functions spawned off into other files */
    void remove_accessory();
    void puton_accessory();
    void wield();
    void wear_armor();
    void remove_armor();

    int extendedCommand();
    int dip();

private:
    CSock * sock;
    CLocation xy;
    CLocation oxy;
    CClientPlayerList cplayerlist;
    CClientObjectList cpack;
    CClientLevel level;
    CAttributes attr;
    string myname;
    int myid;
    bool waiting;
    bool inWizMode;
    COptions options;

    /* These only ever point to objects, they should never _be_ objects */
    CClientObject * helmet, * gloves, * boots,
                  * shirt, * armor, * cloak, *shield;
    CClientObject * pri_weapon, * sec_weapon;
    CClientObject * left_ring, * right_ring;
    CClientObject * blindfold;
    CClientObject * amulet;
protected:
};

extern CHack hack;

#endif
