/* Interhack   Multi-player Rougelike game (based on Nethack)
   Copyright (C) 1996-2000  Damian Bentley

   See license.txt for details. If you do not have a copy of the license,
   please email bendchon@mehta.anu.edu.au */

#include "location.h"

const CLocation& CLocation::operator= (const CLocation& rhs) {
    x = rhs.x;
    y = rhs.y;
    return *this;
}

bool CLocation::operator== (const CLocation& rhs) {
    if (x == rhs.x && y == rhs.y)
        return true;
    return false;
}

bool CLocation::operator!= (const CLocation& rhs) {
    if (x != rhs.x || y != rhs.y)
        return true;
    return false;
}

const CLocation& CLocation::operator+= (const CLocation& rhs) {
    x += rhs.x;
    y += rhs.y;
    return *this;
}

const CLocation CLocation::operator+ (const CLocation& rhs) {
    return CLocation(*this) += rhs;
}

const CLocation& CLocation::operator-= (const CLocation& rhs) {
    x -= rhs.x;
    y -= rhs.y;
    return *this;
}

const CLocation CLocation::operator- (const CLocation& rhs) {
    return CLocation(*this) -= rhs;
}

int CLocation::operator% (const CLocation& rhs) {
    return (int)(sqrt(((x-rhs.x)*(x-rhs.x)) + ((y-rhs.y)*(y-rhs.y))));
}
