/* Interhack   Multi-player Rougelike game (based on Nethack)
   Copyright (C) 1996-2000  Damian Bentley

   See license.txt for details. If you do not have a copy of the license,
   please email bendchon@mehta.anu.edu.au */

#ifndef _location_h_
#define _location_h_

#include "sock.h"

class CLocation {
    friend CSock& operator<< (CSock& s, CLocation l) {
        s << (int)l.x << (int)l.y;
        return s; };
    friend CSock& operator>> (CSock& s, CLocation& l) {
        int tempx, tempy;
        s >> (int &)tempx >> (int &)tempy;
        l.set(tempx, tempy);
        return s; };
public:
    // constructors
    CLocation() { x = y = -1; };
    CLocation(int a, int b) { x = a; y = b; };

    // set either x, y or both
    void set(int a, int b) { x = a; y = b; };

    // operators for assignment, comparison, add, subtract, and distance
    const CLocation& operator= (const CLocation& rhs);
    bool operator== (const CLocation& rhs);
    bool operator!= (const CLocation& rhs);
    const CLocation& operator+= (const CLocation& rhs);
    const CLocation operator+ (const CLocation& rhs);
    const CLocation& operator-= (const CLocation& rhs);
    const CLocation operator- (const CLocation& rhs);
    int operator% (const CLocation& rhs);

    /* We now use direct access - much faster */
    int x, y;
private:
protected:
};

#endif
