/*	SCCS Id: @(#)mondata.h	3.3	1999/08/14	*/
/* Copyright (c) 1989 Mike Threepoint				  */
/* NetHack may be freely redistributed.  See license for details. */

#ifndef MONDATA_H
#define MONDATA_H

#define verysmall(mtmp)		((mtmp)->msize < MZ_SMALL)
#define bigmonst(mtmp)		((mtmp)->msize >= MZ_LARGE)

#define pm_resistance(mtmp,typ)	(((mtmp)->mresists & (typ)) != 0)

#define resists_fire(mtmp)	(((mtmp)->mintrinsics & MR_FIRE) != 0)
#define resists_cold(mtmp)	(((mtmp)->mintrinsics & MR_COLD) != 0)
#define resists_sleep(mtmp)	(((mtmp)->mintrinsics & MR_SLEEP) != 0)
#define resists_disint(mtmp)	(((mtmp)->mintrinsics & MR_DISINT) != 0)
#define resists_elec(mtmp)	(((mtmp)->mintrinsics & MR_ELEC) != 0)
#define resists_poison(mtmp)	(((mtmp)->mintrinsics & MR_POISON) != 0)
#define resists_acid(mtmp)	(((mtmp)->mintrinsics & MR_ACID) != 0)
#define resists_ston(mtmp)	(((mtmp)->mintrinsics & MR_STONE) != 0)

#define is_flyer(mtmp)		(((mtmp)->IM1 & M1_FLY) != 0L)
#define is_floater(mtmp)		((mtmp)->CSpecies == S_EYE)
#define is_clinger(mtmp)		(((mtmp)->IM1 & M1_CLING) != 0L)
#define is_swimmer(mtmp)		(((mtmp)->IM1 & M1_SWIM) != 0L)
#define breathless(mtmp)		(((mtmp)->IM1 & M1_BREATHLESS) != 0L)
#define amphibious(mtmp)		(((mtmp)->IM1 & (M1_AMPHIBIOUS | M1_BREATHLESS)) != 0L)
#define passes_walls(mtmp)	(((mtmp)->IM1 & M1_WALLWALK) != 0L)
#define amorphous(mtmp)		(((mtmp)->IM1 & M1_AMORPHOUS) != 0L)
#define noncorporeal(mtmp)	((mtmp)->CSpecies == S_GHOST)
#define tunnels(mtmp)		(((mtmp)->IM1 & M1_TUNNEL) != 0L)
#define needspick(mtmp)		(((mtmp)->IM1 & M1_NEEDPICK) != 0L)
#define hides_under(mtmp)	(((mtmp)->IM1 & M1_CONCEAL) != 0L)
#define is_hider(mtmp)		(((mtmp)->IM1 & M1_HIDE) != 0L)
#define haseyes(mtmp)		(((mtmp)->IM1 & M1_NOEYES) == 0L)
#define nohands(mtmp)		(((mtmp)->IM1 & M1_NOHANDS) != 0L)
#define nolimbs(mtmp)		(((mtmp)->IM1 & M1_NOLIMBS) == M1_NOLIMBS)
#define notake(mtmp)		(((mtmp)->IM1 & M1_NOTAKE) != 0L)
#define has_head(mtmp)		(((mtmp)->IM1 & M1_NOHEAD) == 0L)
#define is_whirly(mtmp)		((mtmp)->CSpecies == S_VORTEX || \
				 (mtmp->INumber == PM_AIR_ELEMENTAL))
#define unsolid(mtmp)		(((mtmp)->IM1 & M1_UNSOLID) != 0L)
#define mindless(mtmp)		(((mtmp)->IM1 & M1_MINDLESS) != 0L)
#define humanoid(mtmp)		(((mtmp)->IM1 & M1_HUMANOID) != 0L)
#define is_animal(mtmp)		(((mtmp)->IM1 & M1_ANIMAL) != 0L)
#define slithy(mtmp)		(((mtmp)->IM1 & M1_SLITHY) != 0L)
#define is_meaty(mtmp)		(!amorphous(mtmp) && \
				 (mtmp)->CSpecies != S_BLOB && \
				 (mtmp)->CSpecies != S_JELLY && \
				 (mtmp)->CSpecies != S_FUNGUS)
#define is_wooden(mtmp)		((mtmp) == &mons[PM_WOOD_GOLEM])
#define thick_skinned(mtmp)	(((mtmp)->IM1 & M1_THICK_HIDE) != 0L)
#define lays_eggs(mtmp)		(((mtmp)->IM1 & M1_OVIPAROUS) != 0L)
#define regenerates(mtmp)	(((mtmp)->IM1 & M1_REGEN) != 0L)
#define perceives(mtmp)		(((mtmp)->IM1 & M1_SEE_INVIS) != 0L)
#define can_teleport(mtmp)	(((mtmp)->IM1 & M1_TPORT) != 0L)
#define control_teleport(mtmp)	(((mtmp)->IM1 & M1_TPORT_CNTRL) != 0L)
#define telepathic(mtmp)		((mtmp) == &mons[PM_FLOATING_EYE] || \
				 (mtmp) == &mons[PM_MIND_FLAYER] || \
				 (mtmp) == &mons[PM_MASTER_MIND_FLAYER])
#define is_armed(mtmp)		attacktype(mtmp, AT_WEAP)
#define acidic(mtmp)		(((mtmp)->IM1 & M1_ACID) != 0L)
#define poisonous(mtmp)		(((mtmp)->IM1 & M1_POIS) != 0L)
#define carnivorous(mtmp)	(((mtmp)->IM1 & M1_CARNIVORE) != 0L)
#define herbivorous(mtmp)	(((mtmp)->IM1 & M1_HERBIVORE) != 0L)
#define metallivorous(mtmp)	(((mtmp)->IM1 & M1_METALLIVORE) != 0L)
#define polyok(mtmp)		(((mtmp)->IM2 & M2_NOPOLY) == 0L)
#define is_undead(mtmp)		(((mtmp)->IM2 & M2_UNDEAD) != 0L)
#define is_were(mtmp)		(((mtmp)->IM2 & M2_WERE) != 0L)
#define is_elf(mtmp)		(((mtmp)->IM2 & M2_ELF) != 0L)
#define is_dwarf(mtmp)		(((mtmp)->IM2 & M2_DWARF) != 0L)
#define is_gnome(mtmp)		(((mtmp)->IM2 & M2_GNOME) != 0L)
#define is_orc(mtmp)		(((mtmp)->IM2 & M2_ORC) != 0L)
#define is_human(mtmp)		(((mtmp)->IM2 & M2_HUMAN) != 0L)
#define your_race(mtmp)		(((mtmp)->IM2 & urace.selfmask) != 0L)
#define is_bat(mtmp)		((mtmp) == &mons[PM_BAT] || \
				 (mtmp) == &mons[PM_GIANT_BAT] || \
				 (mtmp) == &mons[PM_VAMPIRE_BAT])
#define is_bird(mtmp)		((mtmp)->CSpecies == S_BAT && !is_bat(mtmp))
#define is_giant(mtmp)		(((mtmp)->IM2 & M2_GIANT) != 0L)
#define is_golem(mtmp)		((mtmp)->CSpecies == S_GOLEM)
#define is_domestic(mtmp)	(((mtmp)->IM2 & M2_DOMESTIC) != 0L)
#define is_demon(mtmp)		(((mtmp)->IM2 & M2_DEMON) != 0L)
#define is_mercenary(mtmp)	(((mtmp)->IM2 & M2_MERC) != 0L)
#define is_male(mtmp)		(((mtmp)->IM2 & M2_MALE) != 0L)
#define is_female(mtmp)		(((mtmp)->IM2 & M2_FEMALE) != 0L)
#define is_neuter(mtmp)		(((mtmp)->IM2 & M2_NEUTER) != 0L)
#define is_wanderer(mtmp)	(((mtmp)->IM2 & M2_WANDER) != 0L)
#define always_hostile(mtmp)	(((mtmp)->IM2 & M2_HOSTILE) != 0L)
#define always_peaceful(mtmp)	(((mtmp)->IM2 & M2_PEACEFUL) != 0L)
#define race_hostile(mtmp)	(((mtmp)->IM2 & urace.hatemask) != 0L)
#define race_peaceful(mtmp)	(((mtmp)->IM2 & urace.lovemask) != 0L)
#define extra_nasty(mtmp)	(((mtmp)->IM2 & M2_NASTY) != 0L)
#define strongmonst(mtmp)	(((mtmp)->IM2 & M2_STRONG) != 0L)
#define can_breathe(mtmp)	attacktype(mtmp, AT_BREA)
#define cantwield(mtmp)		(nohands(mtmp) || verysmall(mtmp))
#define cantweararm(mtmp)	(breakarm(mtmp) || sliparm(mtmp))
#define throws_rocks(mtmp)	(((mtmp)->IM2 & M2_ROCKTHROW) != 0L)
#define type_is_pname(mtmp)	(((mtmp)->IM2 & M2_PNAME) != 0L)
#define is_lord(mtmp)		(((mtmp)->IM2 & M2_LORD) != 0L)
#define is_prince(mtmp)		(((mtmp)->IM2 & M2_PRINCE) != 0L)
#define is_ndemon(mtmp)		(is_demon(mtmp) && \
				 (((mtmp)->IM2 & (M2_LORD|M2_PRINCE)) == 0L))
#define is_dlord(mtmp)		(is_demon(mtmp) && is_lord(mtmp))
#define is_dprince(mtmp)		(is_demon(mtmp) && is_prince(mtmp))
#define is_minion(mtmp)		((mtmp)->IM2 & M2_MINION)
#define is_lminion(mtmp)		(is_minion(mtmp) && \
				 (mtmp)->IAlignment >= A_COALIGNED)
#define likes_gold(mtmp)		(((mtmp)->IM2 & M2_GREEDY) != 0L)
#define likes_gems(mtmp)		(((mtmp)->IM2 & M2_JEWELS) != 0L)
#define likes_objs(mtmp)		(((mtmp)->IM2 & M2_COLLECT) != 0L || \
				 is_armed(mtmp))
#define likes_magic(mtmp)	(((mtmp)->IM2 & M2_MAGIC) != 0L)
#define is_unicorn(mtmp)		((mtmp)->CSpecies == S_UNICORN && likes_gems(mtmp))
#define is_longworm(mtmp)	(((mtmp) == &mons[PM_BABY_LONG_WORM]) || \
				 ((mtmp) == &mons[PM_LONG_WORM]) || \
				 ((mtmp) == &mons[PM_LONG_WORM_TAIL]))
#define is_covetous(mtmp)	((mtmp->IM3 & M3_COVETOUS))
#define infravision(mtmp)	((mtmp->IM3 & M3_INFRAVISION))
#define infravisible(mtmp)	((mtmp->IM3 & M3_INFRAVISIBLE))
#define is_mplayer(mtmp)		(((mtmp) >= &mons[PM_ARCHEOLOGIST]) && \
				 ((mtmp) <= &mons[PM_WIZARD]))
#define is_rider(mtmp)		((mtmp) == &mons[PM_DEATH] || \
				 (mtmp) == &mons[PM_FAMINE] || \
				 (mtmp) == &mons[PM_PESTILENCE])
#define is_placeholder(mtmp)	((mtmp) == &mons[PM_ORC] || \
				 (mtmp) == &mons[PM_GIANT] || \
				 (mtmp) == &mons[PM_ELF] || \
				 (mtmp) == &mons[PM_HUMAN])
/* this returns the light's range, or 0 if none; if we add more light emitting
   monsters, we'll likely have to add a new light range field to mons[] */
#define emits_light(mtmp)	(((mtmp)->CSpecies == S_LIGHT || \
				  (mtmp) == &mons[PM_FLAMING_SPHERE] || \
				  (mtmp) == &mons[PM_SHOCKING_SPHERE] || \
				  (mtmp) == &mons[PM_FIRE_VORTEX]) ? 1 : \
				 ((mtmp) == &mons[PM_FIRE_ELEMENTAL]) ? 1 : 0)
/*	[note: the light ranges above were reduced to 1 for performance...] */
#define likes_lava(mtmp)		(mtmp == &mons[PM_FIRE_ELEMENTAL] || \
				 mtmp == &mons[PM_SALAMANDER])
#define pm_invisible(mtmp) ((mtmp) == &mons[PM_STALKER] || \
			   (mtmp) == &mons[PM_BLACK_LIGHT])

/* could probably add more */
#define likes_fire(mtmp)		((mtmp) == &mons[PM_FIRE_VORTEX] || \
				  (mtmp) == &mons[PM_FLAMING_SPHERE] || \
				 likes_lava(mtmp))

#define touch_petrifies(mtmp)	((mtmp) == &mons[PM_COCKATRICE] || \
				 (mtmp) == &mons[PM_CHICKATRICE])

#define is_mind_flayer(mtmp)	((mtmp) == &mons[PM_MIND_FLAYER] || \
				 (mtmp) == &mons[PM_MASTER_MIND_FLAYER])

#define nonliving(mtmp)		(is_golem(mtmp) || is_undead(mtmp))

#endif /* MONDATA_H */
