/* Interhack   Multi-player Rougelike game (based on Nethack)
   Copyright (C) 1996-2000  Damian Bentley

   See license.txt for details. If you do not have a copy of the license,
   please email bendchon@mehta.anu.edu.au */

#include "options.h"
#include "vision.h"
#include "string.h"

/* Setup the default options */
COptions::COptions() {
    keypad = TRUE;
    colour = TRUE;
    autoPickup = TRUE;
}

/* Save the default options */
COptions::~COptions() {
}

static char mletter = 'a';

/* Create a menu out of the current option settings */
void COptions::change() {
    char *items[5];
    string str;

    mletter = 'a';
    items[0] = addmenu("Please select an option to change:");
    items[1] = addmenu('a', "keypad", keypad);
    items[2] = addmenu('b', "colour", colour);
    items[3] = addmenu("(end)");
    items[4] = NULL;
    str = vision.multiMenu(items);
    if (str.contains('a')) vision.Keypad((keypad = !keypad));
    if (str.contains('b')) vision.Colour((colour = !colour));

    delete items[0];
    delete items[1];
    delete items[2];
    delete items[3];
}

char * COptions::addmenu(char *str) {
    char *tmp = new char[mystrlen(str)+1];
    mystrncpy(tmp, str, mystrlen(str));
    return tmp;
}

char * COptions::addmenu(char l, char *s, bool b) {
    string str;
    char *tmp;
    str = (char)l;
    str += " - ";
    str += s;
    if (b) str += " [TRUE]"; else str += " [FALSE]";
    tmp = new char[str.size()+1];
    mystrncpy(tmp, str.getStr(), str.size());
    return tmp;
}
