/* Interhack   Multi-player Rougelike game (based on Nethack)
   Copyright (C) 1996-2000  Damian Bentley

   See license.txt for details. If you do not have a copy of the license,
   please email bendchon@mehta.anu.edu.au */

#ifndef _plist_h_
#define _plist_h_

#include "sock.h"
#include "location.h"
#include "player.h"

class CPlayerList {
    friend CSock& operator<< (CSock&, CPlayerList);
public:
    void user_list();
    int already_on(string);
    void talkMsg(string s, int);
    void yellMsg(string s);
    void chatMsg(string s, int);
    void seenMsg(string omsg, string omsgh, string pmsg, int);
    void dpMsg(string, CObject *, int);
    void sendMovement(int);
    bool sameLocation(int, CLocation);
    void sendToAll();
    void sendToAllExclude(int);
    void sendFlags(int);
    void phitm(CPlayer *, MonsterType *);
    CPlayer *assignClosest(CLevel *, CLocation l);
    void updateMonster(CLevel *, MonsterType *);
    void drop(CPlayer *, CObject *);
    void pickup(CPlayer *, CObject *);

    /* Sureal time functions */
    Timeval * sleepTime();
    bool doMove(int);
    void forcedMoves();
    void makeMoves();
    void arrangeTimers();
    void arrangeTimersM();
private:
protected:
};

void initPlayers();

extern CPlayer * plist[MAXPLAYERS];
extern CPlayerList players;

#endif
