/* Interhack   Multi-player Rougelike game (based on Nethack)
   Copyright (C) 1996-2000  Damian Bentley

   See license.txt for details. If you do not have a copy of the license,
   please email bendchon@mehta.anu.edu.au */

#ifndef _sock_h_
#define _sock_h_

#include "protocol.h"
#include "string.h"
#include "system.h"

enum cont {p_end};

#ifndef TRUE
    #define TRUE		1
#endif
#ifndef FALSE
    #define FALSE		0
#endif

class CSock {
    /* These are used to send to the socket */
    friend CSock& operator<< (CSock&, enum cont);
    friend CSock& operator<< (CSock&, string);
    friend CSock& operator<< (CSock&, char);
    friend CSock& operator<< (CSock&, int);
//    friend CSock& operator<< (CSock&, bool);
    friend CSock& operator<< (CSock&, ID);
    friend CSock& operator<< (CSock&, Protocol);

    /* These are used to receive from the socket */
    friend CSock& operator>> (CSock&, string &);
    friend CSock& operator>> (CSock&, char &);
    friend CSock& operator>> (CSock&, int &);
//    friend CSock& operator>> (CSock&, bool &);
    friend CSock& operator>> (CSock&, ID &);
    friend CSock& operator>> (CSock&, Protocol &);
public:
    CSock(int);
    ~CSock();
    int fill_inbuf();
    void reset_buf() { inread = inbuf + 3; };
private:
    unsigned int sending: 1;
    int sockfd;
    char * outbuf, * outptr;
    char * inbuf, * inptr, * inread;
    void send_msg();
};

#endif
