/* Interhack   Multi-player Rougelike game (based on Nethack)
   Copyright (C) 1996-2000  Damian Bentley

   See license.txt for details. If you do not have a copy of the license,
   please email bendchon@mehta.anu.edu.au */

#ifndef _tcpip_h_
#define _tcpip_h_

#include <unistd.h>

#include "system.h"

class CConnection {
public:
    /* Normal run of the mill functions */
    CConnection(int (*)(int,int,char *), int (*)(int),
                int (*)(int));
    ~CConnection();

    /* These are the general connection functions. */
    int c_open(int);
    int c_listen();
    int c_connect(char *, int);
    int c_close();

    /* Kill a particular client connection */
    int c_close_conn(int);

    /* Read input from id into buf. */
    int c_read(int id, char *buf, int size) {
        return read(connection[id].fds, buf, size); }
    /* Write buf to fd. */
    int c_write(int id, char *buf, int size) {
        return write(connection[id].fds, buf, size); }

    void setDemon() { demon = true; };
private:
#ifdef TCPIP
    int c_new_tcpipconn();
#endif
#ifdef SERIAL
    int c_new_serialconn(int);
    int open_serial(char *);
#endif
    int c_sigpipe_ignore();

    struct connection_t {
        int fds;
        char clientname[32];
        Timeval lastdata;
    } connection[MAXPLAYERS];
    int sockfd, csockfd;
    int serialfd0, serialfd1;
    int oldserialfd0, oldserialfd1;
    int maxfd, num_of_connections;
    fd_set read_fds;
    bool demon;

    int (*new_conn)(int, int, char *);
    int (*data_in)(int);
    int (*close_conn)(int);
};

extern CConnection connection;

#endif
