/* Interhack   Multi-player Rougelike game (based on Nethack)
   Copyright (C) 1996-2000  Damian Bentley

   See license.txt for details. If you do not have a copy of the license,
   please email bendchon@mehta.anu.edu.au */

#ifndef _version_h_
#define _version_h_

#define VERSION_SERVER	"Interhack Server, Version 1.0.1, Copyright (C) 1996-2000 Damian Bentley"

#define VERSION_CLIENT	"Interhack Client, Version 1.0.1, Copyright (C) 1996-2000 Damian Bentley"

#define LICENSE		"Interhack, Copyright 1996-2000\r\
\tBy Damian Bentley.\r\
\tSee license.txt for details.\r\
\tPlease report all bugs to bendchon@mehta.anu.edu.au\r"

/*******************************************************************************
BUGFIXES
Version 0.24:
    'Talk' communications are displayed by the client.
    Communications between players are scrolled up to use the second line.
    Communication lines allowed for too long an input, thus when displayed
        they would wrap around, sometimes overlapping the map.
    Magic mapping cheat changed from m to ^M.
    A compile time define was added to make removal of magic mapping cheat
        easier (although the client could still hack the code).
    Players can no longer walk over each other (on server side only).
    The symbols displayed for each player is now correct.
    Server interactive mode works again.
    When multiple players moved, it would move other players! erk!
    Clients check to make sure they are not walking on top of each other.
    Players are displayed as the correct symbol on their own screen.
    Players can no longer see other players move around the screen.
    Stairs are now displayed from a distance, rather than a ' '.
    When quiting from character selection in server interactive mode,
        the exit no no longer creates a mess of the screen.
    Non-wizard mode now works in server interactive mode.
    When entering los with another player, that player is now displayed.
    Phantom images of players are no longer left after they have moved.
    Normal Level generation no longer generates coridors off the map.
    When players enter the game they are now displayed.
    When player leave the game a phantom symbol is no longer left behind.
Version 0.25:
    Weight of > 1 object was same as weight of 1 object.
    File display in help changed to 24 lines maximum.
    On some 'slower' displays, the vision would freeze, leaving the cursor
        floating. Still happens with the menu display, but far better now.
    Player list on server would only show total players if < 1.
    Template level numbers are now calculated.
    tower3 in dat/tower.des had two lines missing spaces on the end.
Version 0.26:
    Server prompt now should always return to the correct location.
    Returning to server interactive mode during login now only requires
        one keypress.
    Client login screen io is displayed correctly (no floating prompt).
    When changing dungeon levels, players are added / remove from other
        players screens, and the player lists are updated.
    Client / server output no longer freezes if there is too much to update.
    Vision is working (no holes are left such as walls).
    Dropping an object on the client side now takes place.
    The description of a dropped object is no longer "...drop a - 2 yellow...".
    Dropped objects colour no longer change levels colour.
    Objects on one level no longer accumulate onto the next level.
    Objects on a level are now sent to the client.
    Data base keyword searching now works.
    Objects are placed at random on the level.
    When interacting with objects, appropriate lists can be obtained.
Version 0.27:
    Monsters displayed as ' ' are now displayed as correct symbol.
    Phantom monsters and players no longer occur.
    Repeated logins by the server resulted in multiple packs.
    Dozens and dozens of bugs (far too many to list).
    Initial objects sent to player identified.
    Monster move always occurs (assuming moveCount++ takes place).
Version 0.28:
    Y2K bug in the log file timestamp fixed.
Version 1.0.0:
    removed -s from optimised compile, resulting in core dumps
    fixed man memory bugs including:
        using delete [] rather than delete
        memory leaks (resulting in ~2 Megs memory loss)
    Many fixes in object descriptions
********************************************************************************
CHANGES / ADDITIONS:
Version 0.24:
    Support for Saddles, Saddle Bags, and Bridles
    Basic classes for traps (special type of CObject)
Version 0.25:
    Player lists extensively modified (send/received) to make them similar
        to object and monster lists. Result: smaller faster and better code.
    Level send/receive modified to make them similar to other lists. Again
        the result is smaller, faster and better code.
    Objects are sent to the client, and the inventory can be displayed.
    Potion code updated to support new potions in Nethack 3.3.0.
    A trial improvement to the vision code: rather than sending xy co-ords
        with all refreshed screen locations, only the first in a line will
        now be sent. With updates of large areas a significant speed increase.
    Sureal time intergrated into the player classes and finished.
    Players can traverse the dungeon now.
    Drinking of potions and many object functions added.
Version 0.26:
    Colour now possible (uses nethack color.h file).
    Vision and i/o now done using curses based library, no keyboard.* or help.*.
    Monsters can now be seen, and attacked by players (they do not move).
    Monsters can be killed by players.
Version 0.27:
    Monster movement is now in place, but monsters do not attack.
    Potion colors are displayed.
    Players can now pickup and drop objects, with everything working.
    Accessories can be put on or taken off.
    Anything can be wielded as a weapon.
    hack.cc slashed into several files, and new class CHack created.
Version 1.0.0:
    Directory structure changed for release, some data files moved.
    Primary and seconday weapons enabled.
    All objects were updated to be those in Nethack 3.3.0.
    Started using Memory Supervision System to detect memory problems
    Support for serial port null-modem connections
    Player attributes added, including support for ac and hp
    Quit changed to version 3.3.0 of Nethack
    Server support for saving the game status, and entering demon mode
    Sorted inventory menus
********************************************************************************
KNOWN BUGS:
    When the server is in interractive mode, and is killed by the server
        (eg for walking through a wall) keyboard is not restored correctly?
    Map templates are not completely read from file
    Client allows eating of anything
    Data base keyword searching does not deal with * and ~
    Colour of everything needs checking (including objects) and completing
    Monster movement is dodgy (but heck it works!)
********************************************************************************
THINGS TO DO:
    The coridors need to be far more random
    The full details of players are not displayed on the player listings
    Players are not saved or loaded
    It would be nice if idle time was displayed by the server player list
    Sureal time needs to be completed (forced moves, dynamic timers)
    Players need to push each other out of the way when coming down stairs
    Messages need to be sent to players when a new player logs in / exits
    Adding of level objects to the level (fountains, thrones, doors)
    Player stats (including hp) need to be created, and sent to player
    Vision needs a complete re-write
    Optimize the monster movement code - too slow
    Make all data members public, remove get / set functions (faster code)
    Edit / Finish the documentation in the /dat directory
    Add support for modems
*/

#endif
