/* Interhack   Multi-player Rougelike game (based on Nethack)
   Copyright (C) 1996-2000  Damian Bentley

   See license.txt for details. If you do not have a copy of the license,
   please email bendchon@mehta.anu.edu.au */

#include "monster.h"
#include "monsym.h"
#include "monflag.h"
#include "monattk.h"
#include "color.h"
#include "align.h"

MonsterType::MonsterType() {
     player = NULL;
     movement = 0;
     pMoveCount = 0;
     IID = 0;
     INumber = 0;
     CSpecies = '0';
     mhp = mhpmax = 0;
     SName = ' ';
     ILevel = 0;
     ISpeed = 0;
     IAC = 0;
     IMR = 0;
     IAlignment = 0;
     //IAttarea[] = {0,0,0,0,0,0};
     //IAtttype[] = {0,0,0,0,0,0};
     //IAttnum[] = {0,0,0,0,0,0};
     //IAttdam[] = {0,0,0,0,0,0};
     IWeight = 0;
     INutrition = 0;
     IPixel = 0;
     ISound = 0;
     ISize = 0;
     IResist = 0;
     IIntrinsics = 0;
     IConvey = 0;
     IM1 = 0;
     IM2 = 0;
     IM3 = 0;
     IClass = 0;
     IColor = 0;
     IGenerate = 0;
     xy.set(1,1);

	 rotation = 0;
	 MoveCycle = 0;
	 MonPrevMove[0].x = -1;
	 MonPrevMove[1].x = -1;
	 MonPrevMove[2].x = -1;
	 MonPrevMove[3].x = -1;

	 StraightMove = 0;
	 DefaultDir = 0;

	 DirQueue[0] = -1;

	 underwater = 0;
    is_swimmer = 0;
    invis = 0;
    cham = 0;
    mcan = 0;
    foundyou = 0;
    cansee = 0;
    trapped = 0;
	sleeping = 0;
	canmove = 0;
	frozen = 0;

   multi = 0;
   mconf = 0;
   conflict = 0;
   protection_from_shape_changers = 0;
   hallucination = 0;
   mundetected = 0;
   mspec_used = 0;
   visible = 0;
}



//The adding of mosters
DefMonster Monsters;

DefMonster::DefMonster()
{
    currentnum = 0;
    attorder = 0;
}

//The new add monster function
/*
 *	Entry Format:		(from permonst.h)
 *
 *	name, symbol (S_* defines),
 *	difficulty level, move rate, armor class, magic resistance,
 *	alignment, creation/geno flags (G_* defines),
 *	6 * attack structs ( type , damage-type, # dice, # sides ),
 *	weight (WT_* defines), nutritional value, extension length,
 *	sounds made (MS_* defines), physical size (MZ_* defines),
 *	resistances, resistances conferred (both MR_* defines),
 *	3 * flag bitmaps (M1_*, M2_*, and M3_* defines respectively)
 *	symbol color (C(x) macro)
 */
int DefMonster::AddMonster(string Name, char Species, int func1,
int Generate, int func2, int func3, int MC1, int MC2, int M1,
    int M2, int M3, int Color)
{
    DefaultMon[currentnum].INumber = currentnum;
    DefaultMon[currentnum].CSpecies = Species;
    DefaultMon[currentnum].SName = Name;
    DefaultMon[currentnum].IResist= MC1;
    DefaultMon[currentnum].IConvey = MC2;
    DefaultMon[currentnum].IM1 = M1;
    DefaultMon[currentnum].IM2 = M2;
    DefaultMon[currentnum].IM3 = M3;
    DefaultMon[currentnum].IColor = Color;
    DefaultMon[currentnum].IGenerate = Generate;
    currentnum++;
    if (func1 && func2 && func3) return 1;
    else return 0;
}

int DefMonster::GetRMonster(char mclass, int MinLevel, int MaxLevel)
{
    int MonsterNum[30];
    int monlist =0;
    int finalmonst;
    for (int z=0;z<MAXMONSTERS;z++)
    {
        if(DefaultMon[z].CSpecies == mclass)
        {
            if(DefaultMon[z].ILevel >= MinLevel && DefaultMon[z].ILevel <= MaxLevel)
            {
                MonsterNum[monlist] = z;
                monlist++;
            }
        }
    }
    finalmonst = rn2(monlist);
    return MonsterNum[finalmonst];
}


//Change this once a string class is included.  for some reason it doesnt
//comapre string's correctly

int DefMonster::GetMonster(string mname)
{
	for(int z=0;z<MAXMONSTERS;z++)
   {
    if(DefaultMon[z].SName == mname) return z;
   }
   return -1;
}


//for any random monster
int DefMonster::RMonster()
{
    return rn2(currentnum);
}

//LEVEL, for stats of a monster
int DefMonster::LVL(int lvl,int mov, int ac, int mr, int aln)
{
	 DefaultMon[currentnum].ILevel = lvl;
    DefaultMon[currentnum].ISpeed = mov;
    DefaultMon[currentnum].IAC = ac;
    DefaultMon[currentnum].IMR = mr;
    DefaultMon[currentnum].IAlignment = aln;
    return 1;
}

//ATTACKS, main definition of the 6 ATTACK functions
int DefMonster::A(int A1,int A2,int A3,int A4,int A5,int A6)
{
    if(A1 && A2 && A3 && A4 && A5 && A6) return 1;
    return 0;
}

//ATTACK, the stats for each attack of a monster
int DefMonster::ATTK(int at, int ad, int n, int d)
{
    DefaultMon[currentnum].IAttarea[attorder] = at;
    DefaultMon[currentnum].IAtttype[attorder] = ad;
    DefaultMon[currentnum].IAttnum[attorder] = n;
    DefaultMon[currentnum].IAttdam[attorder] = d;
    attorder++;
    if (attorder == 6) attorder = 0;
	return 1;
}

//SIZE, variables the pertain to a monsters size and weight
int DefMonster::SIZ(int wt, int nut, int pxl, int snd, int siz)
{
    DefaultMon[currentnum].IWeight = wt;
    DefaultMon[currentnum].INutrition = nut;
    DefaultMon[currentnum].IPixel = pxl;
    DefaultMon[currentnum].ISound = snd;
    DefaultMon[currentnum].ISize = siz;
	 return 1;
}

void initMonsters(void)
{

/*
 *	Rule #1:	monsters of a given class are contiguous in the
 *			mons[] array.
 *
 *	Rule #2:	monsters of a given class are presented in ascending
 *			order of strength.
 *
 *	Rule #3:	monster frequency is included in the geno mask;
 *			the frequency can be from 0 to 7.  0's will also
 *			be skipped during generation.
 *
 *	Rule #4:	monster subclasses (e.g. giants) should be kept
 *			together, unless it violates Rule 2.  NOGEN monsters
 *			won't violate Rule 2.
 *
 * Guidelines for color assignment:
 *
 *	* Use the same color for all `growth stages' of a monster (ex.
 *	  little dog/big dog, baby naga/full-grown naga.
 *
 *	* Use colors given in names wherever possible. If the class has `real'
 *	  members with strong color associations, use those.
 *
 *	* Favor `cool' colors for cold-resistent monsters, `warm' ones for
 *	  fire-resistent ones.
 *
 *	* Try to reserve purple (magenta) for powerful `ruler' monsters (queen
 *	  bee, kobold lord, &c.).
 *
 *	* Subject to all these constraints, try to use color to make as many
 *	  distinctions as the / command (that is, within a monster letter
 *	  distinct names should map to distinct colors).
 *
 * The aim in assigning colors is to be consistent enough so a player can
 * become `intuitive' about them, deducing some or all of these rules
 * unconsciously. Use your common sense.
 */

/*
 * ants
 */
    Monsters.AddMonster("giant ant", S_ANT,
	Monsters.LVL(2, 18, 3, 0, 0), (G_GENO|G_SGROUP|3),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(10, 10, 0, MS_SILENT, MZ_TINY), 0, 0,
	M1_ANIMAL|M1_NOHANDS|M1_OVIPAROUS|M1_CARNIVORE,
	M2_HOSTILE, 0, CLR_BROWN);

    Monsters.AddMonster("killer bee", S_ANT,
	Monsters.LVL(1, 18, -1, 0, 0), (G_GENO|G_LGROUP|2),
	Monsters.A(Monsters.ATTK(AT_STNG, AD_DRST, 1, 3),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1, 5, 0, MS_BUZZ, MZ_TINY), MR_POISON, MR_POISON,
	M1_ANIMAL|M1_FLY|M1_NOHANDS|M1_POIS,
	M2_HOSTILE|M2_FEMALE, 0, CLR_YELLOW);

    Monsters.AddMonster("soldier ant", S_ANT,
	Monsters.LVL(3, 18, 3, 0, 0), (G_GENO|G_SGROUP|2),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 2, 4), Monsters.ATTK(AT_STNG, AD_DRST, 3, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(20, 5, 0, MS_SILENT, MZ_TINY), MR_POISON, MR_POISON,
	M1_ANIMAL|M1_NOHANDS|M1_OVIPAROUS|M1_POIS|M1_CARNIVORE,
	M2_HOSTILE, 0, CLR_BLUE);

    Monsters.AddMonster("fire ant", S_ANT,
	Monsters.LVL(3, 18, 3, 10, 0), (G_GENO|G_SGROUP|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 2, 4), Monsters.ATTK(AT_BITE, AD_FIRE, 2, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(30, 10, 0, MS_SILENT, MZ_TINY), MR_FIRE, MR_FIRE,
	M1_ANIMAL|M1_NOHANDS|M1_OVIPAROUS|M1_CARNIVORE,
	M2_HOSTILE, M3_INFRAVISIBLE, CLR_RED);

    Monsters.AddMonster("giant beetle", S_ANT,
	Monsters.LVL(5, 6, 4, 0, 0), (G_GENO|3),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 3, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(10, 10, 0, MS_SILENT, MZ_LARGE), MR_POISON, MR_POISON,
	M1_ANIMAL|M1_NOHANDS|M1_POIS|M1_CARNIVORE,
	M2_HOSTILE, 0, CLR_BLACK);

    Monsters.AddMonster("queen bee", S_ANT,
	Monsters.LVL(9, 24, -4, 0, 0), (G_GENO|G_NOGEN),
	Monsters.A(Monsters.ATTK(AT_STNG, AD_DRST, 1, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1, 5, 0, MS_BUZZ, MZ_TINY), MR_POISON, MR_POISON,
	M1_ANIMAL|M1_FLY|M1_NOHANDS|M1_OVIPAROUS|M1_POIS,
	M2_HOSTILE|M2_FEMALE|M2_PRINCE, 0, HI_LORD);

/*
 * blobs
 */
    Monsters.AddMonster("acid blob", S_BLOB,
	Monsters.LVL(1, 3, 8, 0, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_NONE, AD_ACID, 1, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(30, 10, 0, MS_SILENT, MZ_TINY),
	MR_SLEEP|MR_POISON|MR_ACID|MR_STONE, MR_STONE,
	M1_BREATHLESS|M1_AMORPHOUS|M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|
	  M1_MINDLESS|M1_ACID,
	M2_WANDER|M2_NEUTER, 0, CLR_GREEN);

    Monsters.AddMonster("quivering blob", S_BLOB,
	Monsters.LVL(5, 1, 8, 0, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_TUCH, AD_PHYS, 1, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(200, 100, 0, MS_SILENT, MZ_SMALL),
	MR_SLEEP|MR_POISON, MR_POISON,
	M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|M1_MINDLESS,
	M2_WANDER|M2_HOSTILE|M2_NEUTER, 0, CLR_WHITE);

    Monsters.AddMonster("gelatinous cube", S_BLOB,
	Monsters.LVL(6, 6, 8, 0, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_TUCH, AD_PLYS, 2, 4), Monsters.ATTK(AT_NONE, AD_PLYS, 1, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(600, 150, 0, MS_SILENT, MZ_LARGE),
	MR_FIRE|MR_COLD|MR_ELEC|MR_SLEEP|MR_POISON|MR_ACID|MR_STONE,
	MR_FIRE|MR_COLD|MR_ELEC|MR_SLEEP,
	M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|M1_MINDLESS|M1_OMNIVORE|M1_ACID,
	M2_WANDER|M2_HOSTILE|M2_NEUTER, 0, CLR_CYAN);

/*
 * cockatrice
 */
    Monsters.AddMonster("chickatrice", S_COCKATRICE,
	Monsters.LVL(4, 4, 8, 30, 0), (G_GENO|G_SGROUP|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 2), Monsters.ATTK(AT_TUCH, AD_STON, 0, 0),
	  Monsters.ATTK(AT_NONE, AD_STON, 0, 0), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(10, 10, 0, MS_HISS, MZ_TINY),
	MR_POISON|MR_STONE, MR_POISON|MR_STONE,
	M1_ANIMAL|M1_NOHANDS, M2_HOSTILE, M3_INFRAVISIBLE, CLR_BROWN);

    Monsters.AddMonster("cockatrice", S_COCKATRICE,
	Monsters.LVL(5, 6, 6, 30, 0), (G_GENO|5),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 3), Monsters.ATTK(AT_TUCH, AD_STON, 0, 0),
	  Monsters.ATTK(AT_NONE, AD_STON, 0, 0), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(30, 30, 0, MS_HISS, MZ_SMALL),
	MR_POISON|MR_STONE, MR_POISON|MR_STONE,
	M1_ANIMAL|M1_NOHANDS|M1_OVIPAROUS, M2_HOSTILE, M3_INFRAVISIBLE,
	CLR_YELLOW);

    Monsters.AddMonster("pyrolisk", S_COCKATRICE,
	Monsters.LVL(6, 6, 6, 30, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_GAZE, AD_FIRE, 2, 6), NO_ATTK,
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(30, 30, 0, MS_HISS, MZ_SMALL),
	MR_POISON|MR_FIRE, MR_POISON|MR_FIRE,
	M1_ANIMAL|M1_NOHANDS|M1_OVIPAROUS, M2_HOSTILE, M3_INFRAVISIBLE,
	CLR_RED);

/*
 * dogs & other canines
 */
    Monsters.AddMonster("jackal", S_DOG,
	Monsters.LVL(0, 12, 7, 0, 0), (G_GENO|G_SGROUP|3),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 2),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(300, 250, 0, MS_BARK, MZ_SMALL), 0, 0,
	M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE, M2_HOSTILE, M3_INFRAVISIBLE,
	CLR_BROWN);

    Monsters.AddMonster("fox", S_DOG,
	Monsters.LVL(0, 15, 7, 0, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 3), NO_ATTK, NO_ATTK,
	  NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(300, 250, 0, MS_BARK, MZ_SMALL), 0, 0,
	M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE, M2_HOSTILE, M3_INFRAVISIBLE,
	CLR_RED);

    Monsters.AddMonster("coyote", S_DOG,
	Monsters.LVL(1, 12, 7, 0, 0), (G_GENO|G_SGROUP|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 4), NO_ATTK, NO_ATTK,
	  NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(300, 250, 0, MS_BARK, MZ_SMALL), 0, 0,
	M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE, M2_HOSTILE, M3_INFRAVISIBLE,
	CLR_BROWN);

    Monsters.AddMonster("werejackal", S_DOG,
	Monsters.LVL(2, 12, 7, 10, -7), (G_NOGEN|G_NOCORPSE),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_WERE, 1, 4), NO_ATTK, NO_ATTK,
	  NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(300, 250, 0, MS_BARK, MZ_SMALL), MR_POISON, 0,
	M1_NOHANDS|M1_POIS|M1_REGEN|M1_CARNIVORE,
	M2_NOPOLY|M2_WERE|M2_HOSTILE, M3_INFRAVISIBLE, CLR_BROWN);

    Monsters.AddMonster("little dog", S_DOG,
	Monsters.LVL(2, 18, 6, 0, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(150, 150, 0, MS_BARK, MZ_SMALL), 0, 0,
	M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE, M2_DOMESTIC, M3_INFRAVISIBLE,
	HI_DOMESTIC);

    Monsters.AddMonster("dog", S_DOG,
	Monsters.LVL(4, 16, 5, 0, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1 ,6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(400, 200, 0, MS_BARK, MZ_MEDIUM), 0, 0,
	M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE, M2_DOMESTIC, M3_INFRAVISIBLE,
	HI_DOMESTIC);

    Monsters.AddMonster("large dog", S_DOG,
	Monsters.LVL(6, 15, 4, 0, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 2, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(800, 250, 0, MS_BARK, MZ_MEDIUM), 0, 0,
	M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE,
	M2_STRONG|M2_DOMESTIC, M3_INFRAVISIBLE, HI_DOMESTIC);

    Monsters.AddMonster("dingo", S_DOG,
	Monsters.LVL(4, 16, 5, 0, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1 ,6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(400, 200, 0, MS_BARK, MZ_MEDIUM), 0, 0,
	M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE, M2_HOSTILE, M3_INFRAVISIBLE,
	CLR_YELLOW);

    Monsters.AddMonster("wolf", S_DOG,
	Monsters.LVL(5, 12, 4, 0, 0), (G_GENO|G_SGROUP|2),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 2, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(500, 250, 0, MS_BARK, MZ_SMALL), 0, 0,
	M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE, M2_HOSTILE, M3_INFRAVISIBLE,
	CLR_BROWN);

    Monsters.AddMonster("werewolf", S_DOG,
	Monsters.LVL(5, 12, 4, 20, -7), (G_NOGEN|G_NOCORPSE),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_WERE, 2, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(500, 250, 0, MS_BARK, MZ_MEDIUM), MR_POISON, 0,
	M1_NOHANDS|M1_POIS|M1_REGEN|M1_CARNIVORE,
	M2_NOPOLY|M2_WERE|M2_HOSTILE, M3_INFRAVISIBLE, CLR_BROWN);

    Monsters.AddMonster("warg", S_DOG,
	Monsters.LVL(7, 12, 4, 0, -5), (G_GENO|G_SGROUP|2),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 2, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(850, 350, 0, MS_BARK, MZ_MEDIUM), 0, 0,
	M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE, M2_HOSTILE, M3_INFRAVISIBLE,
	CLR_BROWN);

    Monsters.AddMonster("winter wolf cub", S_DOG,
	Monsters.LVL(5, 12, 4, 0, -5), (G_NOHELL|G_GENO|G_SGROUP|2),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 8), Monsters.ATTK(AT_BREA, AD_COLD, 1, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(250, 200, 0, MS_BARK, MZ_SMALL), MR_COLD, MR_COLD,
	M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE, M2_HOSTILE, 0, CLR_CYAN);

    Monsters.AddMonster("winter wolf", S_DOG,
	Monsters.LVL(7, 12, 4, 20, 0), (G_NOHELL|G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 2, 6), Monsters.ATTK(AT_BREA, AD_COLD, 2, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(700, 300, 0, MS_BARK, MZ_LARGE), MR_COLD, MR_COLD,
	M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE,
	M2_HOSTILE|M2_STRONG, 0, CLR_CYAN);

    Monsters.AddMonster("hell hound pup", S_DOG,
	Monsters.LVL(7, 12, 4, 20, -5), (G_HELL|G_GENO|G_SGROUP|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 2, 6), Monsters.ATTK(AT_BREA, AD_FIRE, 2, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(200, 200, 0, MS_BARK, MZ_SMALL), MR_FIRE, MR_FIRE,
	M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE, M2_HOSTILE, M3_INFRAVISIBLE,
	CLR_RED);

    Monsters.AddMonster("hell hound", S_DOG,
	Monsters.LVL(12, 14, 2, 20, 0), (G_HELL|G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 3, 6), Monsters.ATTK(AT_BREA, AD_FIRE, 3, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(600, 300, 0, MS_BARK, MZ_MEDIUM), MR_FIRE, MR_FIRE,
	M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE, M2_HOSTILE|M2_STRONG,
	M3_INFRAVISIBLE, CLR_RED);

#ifdef CHARON
    Monsters.AddMonster("Cerberus", S_DOG,
	Monsters.LVL(12, 10, 2, 20, -7), (G_HELL|G_UNIQ|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 3, 6), Monsters.ATTK(AT_BITE, AD_PHYS, 3, 6),
	  Monsters.ATTK(AT_BITE, AD_PHYS, 3, 6), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1000, 350, 0, MS_BARK, MZ_LARGE), MR_FIRE, MR_FIRE,
	M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE,
	M2_NOPOLY|M2_HOSTILE|M2_STRONG|M2_PNAME|M2_MALE, M3_INFRAVISIBLE,
	CLR_RED);

#endif
/*
 * eyes
 */
    Monsters.AddMonster("gas spore", S_EYE,
	Monsters.LVL(1, 3, 10, 0, 0), (G_NOCORPSE|G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BOOM, AD_PHYS, 4, 6), NO_ATTK, NO_ATTK,
	  NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(10, 10, 0, MS_SILENT, MZ_SMALL), 0, 0,
	M1_FLY|M1_NOLIMBS|M1_NOHEAD|M1_MINDLESS,
	M2_HOSTILE|M2_NEUTER, 0, CLR_GRAY);

    Monsters.AddMonster("floating eye", S_EYE,
	Monsters.LVL(2, 1, 9, 10, 0), (G_GENO|5),
	Monsters.A(Monsters.ATTK(AT_NONE, AD_PLYS, 0,70),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(10, 10, 0, MS_SILENT, MZ_SMALL), 0, 0,
	M1_FLY|M1_AMPHIBIOUS|M1_NOLIMBS|M1_NOHEAD|M1_NOTAKE,
	M2_HOSTILE|M2_NEUTER, M3_INFRAVISIBLE, CLR_BLUE);

    Monsters.AddMonster("freezing sphere", S_EYE,
	Monsters.LVL(6, 13, 4, 0, 0), (G_NOHELL|G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_EXPL, AD_COLD, 4, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(10, 10, 0, MS_SILENT, MZ_SMALL), MR_COLD, MR_COLD,
	M1_FLY|M1_NOLIMBS|M1_NOHEAD|M1_MINDLESS|M1_NOTAKE,
	M2_HOSTILE|M2_NEUTER, 0, CLR_WHITE);

    Monsters.AddMonster("flaming sphere", S_EYE,
	Monsters.LVL(6, 13, 4, 0, 0), (G_NOCORPSE|G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_EXPL, AD_FIRE, 4, 6), NO_ATTK, NO_ATTK,
	    NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(10, 10, 0, MS_SILENT, MZ_SMALL), MR_FIRE, MR_FIRE,
	M1_FLY|M1_NOLIMBS|M1_NOHEAD|M1_MINDLESS,
	M2_HOSTILE|M2_NEUTER, M3_INFRAVISIBLE, CLR_RED);

    Monsters.AddMonster("shocking sphere", S_EYE,
	Monsters.LVL(6, 13, 4, 0, 0), (G_NOCORPSE|G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_EXPL, AD_ELEC, 4, 6), NO_ATTK, NO_ATTK,
	  NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(10, 10, 0, MS_SILENT, MZ_SMALL), MR_ELEC, MR_ELEC,
	M1_FLY|M1_NOLIMBS|M1_NOHEAD|M1_MINDLESS,
	M2_HOSTILE|M2_NEUTER, M3_INFRAVISIBLE, HI_ZAP);

#if 0		/* not yet implemented */
    Monsters.AddMonster("beholder", S_EYE,
	Monsters.LVL(6, 3, 4, 0, -10), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_GAZE, AD_SLOW, 0, 0), Monsters.ATTK(AT_GAZE, AD_SLEE, 2,25),
	  Monsters.ATTK(AT_GAZE, AD_DISN, 0, 0), Monsters.ATTK(AT_GAZE, AD_STON, 0, 0),
	  Monsters.ATTK(AT_GAZE, AD_CNCL, 2, 4), Monsters.ATTK(AT_BITE, AD_PHYS, 2, 4)),
	Monsters.SIZ(10, 10, 0, MS_SILENT, MZ_SMALL), MR_COLD, 0,
	M1_FLY|M1_BREATHLESS|M1_NOLIMBS|M1_NOHEAD|M1_MINDLESS,
	M2_NOPOLY|M2_HOSTILE|M2_NEUTER, M3_INFRAVISIBLE, CLR_BROWN);

#endif
/*
 * felines
 */
    Monsters.AddMonster("kitten", S_FELINE,
	Monsters.LVL(2, 18, 6, 0, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(150, 150, 0, MS_MEW, MZ_SMALL), 0, 0,
	M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE,
	M2_WANDER|M2_DOMESTIC, M3_INFRAVISIBLE, HI_DOMESTIC);

    Monsters.AddMonster("housecat", S_FELINE,
	Monsters.LVL(4, 16, 5, 0, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(200, 200, 0, MS_MEW, MZ_SMALL), 0, 0,
	M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE, M2_DOMESTIC, M3_INFRAVISIBLE,
	HI_DOMESTIC);

    Monsters.AddMonster("jaguar", S_FELINE,
	Monsters.LVL(4, 15, 6, 0, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4),
	  Monsters.ATTK(AT_BITE, AD_PHYS, 1, 8), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(600, 300, 0, MS_GROWL, MZ_LARGE), 0, 0,
	M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE, M2_HOSTILE, M3_INFRAVISIBLE,
	CLR_BROWN);

    Monsters.AddMonster("lynx", S_FELINE,
	Monsters.LVL(5, 15, 6, 0, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_COLD, 1, 4), Monsters.ATTK(AT_CLAW, AD_COLD, 1, 4),
	  Monsters.ATTK(AT_BITE, AD_PHYS, 1, 10), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(600, 300, 0, MS_GROWL, MZ_LARGE), 0, 0,
	M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE,M2_HOSTILE, M3_INFRAVISIBLE,
	CLR_CYAN);

    Monsters.AddMonster("panther", S_FELINE,
	Monsters.LVL(5, 15, 6, 0, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 6), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 6),
	  Monsters.ATTK(AT_BITE, AD_PHYS, 1, 10), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(600, 300, 0, MS_GROWL, MZ_LARGE), 0, 0,
	M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE,M2_HOSTILE, M3_INFRAVISIBLE,
	CLR_BLACK);

    Monsters.AddMonster("large cat", S_FELINE,
	Monsters.LVL(6, 15, 4, 0, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 2, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(250, 250, 0, MS_MEW, MZ_SMALL), 0, 0,
	M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE,
	M2_STRONG|M2_DOMESTIC, M3_INFRAVISIBLE, HI_DOMESTIC);

    Monsters.AddMonster("tiger", S_FELINE,
	Monsters.LVL(6, 12, 6, 0, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 2, 4), Monsters.ATTK(AT_CLAW, AD_PHYS, 2, 4),
	  Monsters.ATTK(AT_BITE, AD_PHYS, 1,10), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(600, 300, 0, MS_GROWL, MZ_LARGE), 0, 0,
	M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE, M2_HOSTILE, M3_INFRAVISIBLE,
	CLR_YELLOW);

/*
 * gremlins and gargoyles
 */
    Monsters.AddMonster("gremlin", S_GREMLIN,
	Monsters.LVL(5, 12, 2, 25, -9), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 6), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 6),
	  Monsters.ATTK(AT_BITE, AD_PHYS, 1, 4), Monsters.ATTK(AT_CLAW, AD_CURS, 0, 0),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(100, 20, 0, MS_LAUGH, MZ_SMALL), MR_POISON, MR_POISON,
	M1_SWIM|M1_HUMANOID|M1_POIS, M2_STALK, M3_INFRAVISIBLE, CLR_GREEN);

    Monsters.AddMonster("gargoyle", S_GREMLIN,
	Monsters.LVL(6, 10, -4, 0, -9), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 2, 6), Monsters.ATTK(AT_CLAW, AD_PHYS, 2, 6),
	  Monsters.ATTK(AT_BITE, AD_PHYS, 2, 4), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1000, 200, 0, MS_GRUNT, MZ_HUMAN), MR_STONE, MR_STONE,
	M1_HUMANOID|M1_THICK_HIDE|M1_BREATHLESS,
	M2_HOSTILE|M2_STRONG, 0, CLR_BROWN);

    Monsters.AddMonster("winged gargoyle", S_GREMLIN,
	Monsters.LVL(9, 15, -2, 0, -12), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 3, 6), Monsters.ATTK(AT_CLAW, AD_PHYS, 3, 6),
	  Monsters.ATTK(AT_BITE, AD_PHYS, 3, 4), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1200, 300, 0, MS_GRUNT, MZ_HUMAN), MR_STONE, MR_STONE,
	M1_FLY|M1_HUMANOID|M1_THICK_HIDE|M1_BREATHLESS|M1_OVIPAROUS,
	M2_LORD|M2_HOSTILE|M2_STRONG|M2_MAGIC, 0, HI_LORD);

/*
 * humanoids
 */
    Monsters.AddMonster("hobbit", S_HUMANOID,
	Monsters.LVL(1, 9, 10, 0, 6), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(500, 200, 0, MS_HUMANOID, MZ_SMALL), 0, 0,
	M1_HUMANOID|M1_OMNIVORE, M2_COLLECT, M3_INFRAVISIBLE|M3_INFRAVISION,
	CLR_GREEN);

    Monsters.AddMonster("dwarf", S_HUMANOID,
	Monsters.LVL(2, 6, 10, 10, 4), (G_GENO|3),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(900, 300, 0, MS_HUMANOID, MZ_HUMAN), 0, 0,
	M1_TUNNEL|M1_NEEDPICK|M1_HUMANOID|M1_OMNIVORE,
	M2_DWARF|M2_STRONG|M2_GREEDY|M2_JEWELS|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_RED);

    Monsters.AddMonster("bugbear", S_HUMANOID,
	Monsters.LVL(3, 9, 5, 0, -6), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1250, 250, 0, MS_GROWL, MZ_LARGE), 0, 0,
	M1_HUMANOID|M1_OMNIVORE, M2_STRONG|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_BROWN);

    Monsters.AddMonster("dwarf lord", S_HUMANOID,
	Monsters.LVL(4, 6, 10, 10, 5), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4), Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(900, 300, 0, MS_HUMANOID, MZ_HUMAN), 0, 0,
	M1_TUNNEL|M1_NEEDPICK|M1_HUMANOID|M1_OMNIVORE,
	M2_DWARF|M2_STRONG|M2_LORD|M2_MALE|M2_GREEDY|M2_JEWELS|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_BLUE);

    Monsters.AddMonster("dwarf king", S_HUMANOID,
	Monsters.LVL(6, 6, 10, 20, 6), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 6), Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(900, 300, 0, MS_HUMANOID, MZ_HUMAN), 0, 0,
	M1_TUNNEL|M1_NEEDPICK|M1_HUMANOID|M1_OMNIVORE,
	M2_DWARF|M2_STRONG|M2_PRINCE|M2_MALE|M2_GREEDY|M2_JEWELS|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, HI_LORD);

    Monsters.AddMonster("mind flayer", S_HUMANOID,
	Monsters.LVL(9, 12, 5, 90, -8), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 4), Monsters.ATTK(AT_TENT, AD_DRIN, 2, 1),
	  Monsters.ATTK(AT_TENT, AD_DRIN, 2, 1), Monsters.ATTK(AT_TENT, AD_DRIN, 2, 1),
	  Monsters.ATTK(AT_TENT, AD_DRIN, 2, 1), NO_ATTK),
	Monsters.SIZ(1450, 400, 0, MS_HISS, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_FLY|M1_SEE_INVIS|M1_OMNIVORE,
	M2_HOSTILE|M2_NASTY|M2_GREEDY|M2_JEWELS|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_MAGENTA);

    Monsters.AddMonster("master mind flayer", S_HUMANOID,
	Monsters.LVL(13, 12, 0, 90, -8), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 8), Monsters.ATTK(AT_TENT, AD_DRIN, 2, 1),
	  Monsters.ATTK(AT_TENT, AD_DRIN, 2, 1), Monsters.ATTK(AT_TENT, AD_DRIN, 2, 1),
	  Monsters.ATTK(AT_TENT, AD_DRIN, 2, 1), NO_ATTK),
	Monsters.SIZ(1450, 400, 0, MS_HISS, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_FLY|M1_SEE_INVIS|M1_OMNIVORE,
	M2_HOSTILE|M2_NASTY|M2_GREEDY|M2_JEWELS|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_MAGENTA);

/*
 * imps & other minor demons/devils
 */
    Monsters.AddMonster("manes", S_IMP,
	Monsters.LVL(1, 3, 7, 0, -7), (G_GENO|G_LGROUP|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 3), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 3),
	  Monsters.ATTK(AT_BITE, AD_PHYS, 1, 4), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(100, 100, 0, MS_SILENT, MZ_SMALL), MR_SLEEP|MR_POISON, 0,
	M1_POIS, M2_HOSTILE|M2_STALK, M3_INFRAVISIBLE|M3_INFRAVISION, CLR_RED);

    Monsters.AddMonster("homunculus", S_IMP,
	Monsters.LVL(2, 12, 6, 10, -7), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_SLEE, 1, 3),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(60, 100, 0, MS_SILENT, MZ_TINY),
	MR_SLEEP|MR_POISON, MR_SLEEP|MR_POISON,
	M1_FLY|M1_POIS, M2_STALK, M3_INFRAVISIBLE|M3_INFRAVISION, CLR_GREEN);

    Monsters.AddMonster("imp", S_IMP,
	Monsters.LVL(3, 12, 2, 20, -7), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(20, 10, 0, MS_CUSS, MZ_TINY), 0, 0,
	M1_REGEN, M2_WANDER|M2_STALK, M3_INFRAVISIBLE|M3_INFRAVISION, CLR_RED);

    Monsters.AddMonster("lemure", S_IMP,
	Monsters.LVL(3, 3, 7, 0, -7), (G_HELL|G_GENO|G_LGROUP|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 3),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(150, 100, 0, MS_SILENT, MZ_MEDIUM),
	MR_SLEEP|MR_POISON, MR_SLEEP, M1_POIS|M1_REGEN,
	M2_HOSTILE|M2_WANDER|M2_STALK|M2_NEUTER,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_BROWN);

    Monsters.AddMonster("quasit", S_IMP,
	Monsters.LVL(3, 15, 2, 20, -7), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_DRDX, 1, 2), Monsters.ATTK(AT_CLAW, AD_DRDX, 1, 2),
	  Monsters.ATTK(AT_BITE, AD_PHYS, 1, 4), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(200, 200, 0, MS_SILENT, MZ_SMALL), MR_POISON, MR_POISON,
	M1_REGEN, M2_STALK, M3_INFRAVISIBLE|M3_INFRAVISION, CLR_BLUE);

    Monsters.AddMonster("tengu", S_IMP,
	Monsters.LVL(6, 13, 5, 30, 7), (G_GENO|3),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 7),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(300, 200, 0, MS_SQAWK, MZ_SMALL), MR_POISON, MR_POISON,
	M1_TPORT|M1_TPORT_CNTRL, M2_STALK, M3_INFRAVISIBLE|M3_INFRAVISION,
	CLR_CYAN);

/*
 * jellies
 */
    Monsters.AddMonster("blue jelly", S_JELLY,
	Monsters.LVL(4, 0, 8, 10, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_NONE, AD_COLD, 0, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(50, 20, 0, MS_SILENT, MZ_MEDIUM),
	MR_COLD|MR_POISON, MR_COLD|MR_POISON,
	M1_BREATHLESS|M1_AMORPHOUS|M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|M1_MINDLESS
	  |M1_NOTAKE,
	M2_HOSTILE|M2_NEUTER, 0, CLR_BLUE);

    Monsters.AddMonster("spotted jelly", S_JELLY,
	Monsters.LVL(5, 0, 8, 10, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_NONE, AD_ACID, 0, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(50, 20, 0, MS_SILENT, MZ_MEDIUM), MR_ACID|MR_STONE, 0,
	M1_BREATHLESS|M1_AMORPHOUS|M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|
	  M1_MINDLESS|M1_ACID|M1_NOTAKE,
	M2_HOSTILE|M2_NEUTER, 0, CLR_GREEN);

    Monsters.AddMonster("ochre jelly", S_JELLY,
	Monsters.LVL(6, 3, 8, 20, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_ENGL, AD_ACID, 3, 6), Monsters.ATTK(AT_NONE, AD_ACID, 3, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(50, 20, 0, MS_SILENT, MZ_MEDIUM), MR_ACID|MR_STONE, 0,
	M1_BREATHLESS|M1_AMORPHOUS|M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|
	  M1_MINDLESS|M1_ACID|M1_NOTAKE,
	M2_HOSTILE|M2_NEUTER, 0, CLR_BROWN);

/*
 * kobolds
 */
    Monsters.AddMonster("kobold", S_KOBOLD,
	Monsters.LVL(0, 6, 10, 0, -2), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(400, 100, 0, MS_ORC, MZ_SMALL), MR_POISON, 0,
	M1_HUMANOID|M1_POIS|M1_OMNIVORE, M2_HOSTILE|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_BROWN);

    Monsters.AddMonster("large kobold", S_KOBOLD,
	Monsters.LVL(1, 6, 10, 0, -3), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(450, 150, 0, MS_ORC, MZ_SMALL), MR_POISON, 0,
	M1_HUMANOID|M1_POIS|M1_OMNIVORE, M2_HOSTILE|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_RED);

    Monsters.AddMonster("kobold lord", S_KOBOLD,
	Monsters.LVL(2, 6, 10, 0, -4), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(500, 200, 0, MS_ORC, MZ_SMALL), MR_POISON, 0,
	M1_HUMANOID|M1_POIS|M1_OMNIVORE,
	M2_HOSTILE|M2_LORD|M2_MALE|M2_COLLECT, M3_INFRAVISIBLE|M3_INFRAVISION,
	HI_LORD);

    Monsters.AddMonster("kobold shaman", S_KOBOLD,
	Monsters.LVL(2, 6, 6, 10, -4), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_MAGC, AD_SPEL, 0, 0),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(450, 150, 0, MS_ORC, MZ_SMALL), MR_POISON, 0,
	M1_HUMANOID|M1_POIS|M1_OMNIVORE, M2_HOSTILE|M2_MAGIC,
	M3_INFRAVISIBLE|M3_INFRAVISION, HI_ZAP);

/*
 * leprechauns
 */
    Monsters.AddMonster("leprechaun", S_LEPRECHAUN,
	Monsters.LVL(5, 15, 8, 20, 0), (G_GENO|4),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_SGLD, 1, 2),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(60, 30, 0, MS_LAUGH, MZ_TINY), 0, 0,
	M1_HUMANOID|M1_TPORT, M2_HOSTILE|M2_GREEDY, M3_INFRAVISIBLE, CLR_GREEN);

/*
 * mimics
 */
    Monsters.AddMonster("small mimic", S_MIMIC,
	Monsters.LVL(7, 3, 7, 0, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 3, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(300, 200, 0, MS_SILENT, MZ_MEDIUM), MR_ACID, 0,
	M1_BREATHLESS|M1_AMORPHOUS|M1_HIDE|M1_ANIMAL|M1_NOEYES|
	  M1_NOHEAD|M1_NOLIMBS|M1_THICK_HIDE|M1_CARNIVORE,
	M2_HOSTILE, 0, CLR_BROWN);

    Monsters.AddMonster("large mimic", S_MIMIC,
	Monsters.LVL(8, 3, 7, 10, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_STCK, 3, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(600, 400, 0, MS_SILENT, MZ_LARGE), MR_ACID, 0,
	M1_CLING|M1_BREATHLESS|M1_AMORPHOUS|M1_HIDE|M1_ANIMAL|M1_NOEYES|
	  M1_NOHEAD|M1_NOLIMBS|M1_THICK_HIDE|M1_CARNIVORE,
	M2_HOSTILE|M2_STRONG, 0, CLR_RED);

    Monsters.AddMonster("giant mimic", S_MIMIC,
	Monsters.LVL(9, 3, 7, 20, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_STCK, 3, 6), Monsters.ATTK(AT_CLAW, AD_STCK, 3, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(800, 500, 0, MS_SILENT, MZ_LARGE), MR_ACID, 0,
	M1_CLING|M1_BREATHLESS|M1_AMORPHOUS|M1_HIDE|M1_ANIMAL|M1_NOEYES|
	  M1_NOHEAD|M1_NOLIMBS|M1_THICK_HIDE|M1_CARNIVORE,
	M2_HOSTILE|M2_STRONG, 0, HI_LORD);

/*
 * nymphs
 */
    Monsters.AddMonster("wood nymph", S_NYMPH,
	Monsters.LVL(3, 12, 9, 20, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_SITM, 0, 0), Monsters.ATTK(AT_CLAW, AD_SEDU, 0, 0),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(600, 300, 0, MS_SEDUCE, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_TPORT, M2_HOSTILE|M2_FEMALE|M2_COLLECT, M3_INFRAVISIBLE,
	CLR_GREEN);

    Monsters.AddMonster("water nymph", S_NYMPH,
	Monsters.LVL(3, 12, 9, 20, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_SITM, 0, 0), Monsters.ATTK(AT_CLAW, AD_SEDU, 0, 0),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(600, 300, 0, MS_SEDUCE, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_TPORT|M1_SWIM,
	M2_HOSTILE|M2_FEMALE|M2_COLLECT, M3_INFRAVISIBLE, CLR_BLUE);

    Monsters.AddMonster("mountain nymph", S_NYMPH,
	Monsters.LVL(3, 12, 9, 20, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_SITM, 0, 0), Monsters.ATTK(AT_CLAW, AD_SEDU, 0, 0),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(600, 300, 0, MS_SEDUCE, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_TPORT, M2_HOSTILE|M2_FEMALE|M2_COLLECT,
	M3_INFRAVISIBLE, CLR_BROWN);

/*
 * orcs
 */
    Monsters.AddMonster("goblin", S_ORC,
	Monsters.LVL(0, 6, 10, 0, -3), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(400, 100, 0, MS_ORC, MZ_SMALL), 0, 0,
	M1_HUMANOID|M1_OMNIVORE, M2_ORC|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_GRAY);

    Monsters.AddMonster("hobgoblin", S_ORC,
	Monsters.LVL(1, 9, 10, 0, -4), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1000, 200, 0, MS_ORC, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE, M2_ORC|M2_STRONG|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_BROWN);

	/* plain "orc" for zombie corpses only; not created at random
	 */
    Monsters.AddMonster("orc", S_ORC,
	Monsters.LVL(1, 9, 10, 0, -3), (G_GENO|G_NOGEN|G_LGROUP),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(850, 150, 0, MS_ORC, MZ_HUMAN), 0, 0, M1_HUMANOID|M1_OMNIVORE,
	M2_ORC|M2_STRONG|M2_GREEDY|M2_JEWELS|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_RED);

    Monsters.AddMonster("hill orc", S_ORC,
	Monsters.LVL(2, 9, 10, 0, -4), (G_GENO|G_LGROUP|2),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1000, 200, 0, MS_ORC, MZ_HUMAN), 0, 0, M1_HUMANOID|M1_OMNIVORE,
	M2_ORC|M2_STRONG|M2_GREEDY|M2_JEWELS|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_YELLOW);

    Monsters.AddMonster("Mordor orc", S_ORC,
	Monsters.LVL(3, 5, 10, 0, -5), (G_GENO|G_LGROUP|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1200, 200, 0, MS_ORC, MZ_HUMAN), 0, 0, M1_HUMANOID|M1_OMNIVORE,
	M2_ORC|M2_STRONG|M2_GREEDY|M2_JEWELS|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_BLUE);

    Monsters.AddMonster("Uruk-hai", S_ORC,
	Monsters.LVL(3, 7, 10, 0, -4), (G_GENO|G_LGROUP|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1300, 300, 0, MS_ORC, MZ_HUMAN), 0, 0, M1_HUMANOID|M1_OMNIVORE,
	M2_ORC|M2_STRONG|M2_GREEDY|M2_JEWELS|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_BLACK);

    Monsters.AddMonster("orc shaman", S_ORC,
	Monsters.LVL(3, 9, 5, 10, -5), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_MAGC, AD_SPEL, 0, 0),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1000, 300, 0, MS_ORC, MZ_HUMAN), 0, 0, M1_HUMANOID|M1_OMNIVORE,
	M2_ORC|M2_STRONG|M2_GREEDY|M2_JEWELS|M2_MAGIC,
	M3_INFRAVISIBLE|M3_INFRAVISION, HI_ZAP);

    Monsters.AddMonster("orc-captain", S_ORC,
	Monsters.LVL(5, 5, 10, 0, -5), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4), Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1350, 350, 0, MS_ORC, MZ_HUMAN), 0, 0, M1_HUMANOID|M1_OMNIVORE,
	M2_ORC|M2_STRONG|M2_GREEDY|M2_JEWELS|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, HI_LORD);

/*
 * piercers
 */
    Monsters.AddMonster("rock piercer", S_PIERCER,
	Monsters.LVL(3, 1, 3, 0, 0), (G_GENO|4),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 2, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(200, 200, 0, MS_SILENT, MZ_SMALL), 0, 0,
	M1_CLING|M1_HIDE|M1_ANIMAL|M1_NOEYES|M1_NOLIMBS|M1_CARNIVORE|M1_NOTAKE,
	M2_HOSTILE, 0, CLR_GRAY);

    Monsters.AddMonster("iron piercer", S_PIERCER,
	Monsters.LVL(5, 1, 0, 0, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 3, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(400, 300, 0, MS_SILENT, MZ_MEDIUM), 0, 0,
	M1_CLING|M1_HIDE|M1_ANIMAL|M1_NOEYES|M1_NOLIMBS|M1_CARNIVORE|M1_NOTAKE,
	M2_HOSTILE, 0, CLR_CYAN);

    Monsters.AddMonster("glass piercer", S_PIERCER,
	Monsters.LVL(7, 1, 0, 0, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 4, 6), NO_ATTK, NO_ATTK,
	  NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(400, 300, 0, MS_SILENT, MZ_MEDIUM), 0, 0,
	M1_CLING|M1_HIDE|M1_ANIMAL|M1_NOEYES|M1_NOLIMBS|M1_CARNIVORE|M1_NOTAKE,
	M2_HOSTILE, 0, CLR_WHITE);

/*
 * quadrupeds
 */
    Monsters.AddMonster("rothe", S_QUADRUPED,
	Monsters.LVL(2, 9, 7, 0, 0), (G_GENO|G_SGROUP|4),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 3), Monsters.ATTK(AT_BITE, AD_PHYS, 1, 3),
	  Monsters.ATTK(AT_BITE, AD_PHYS, 1, 8), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(400, 100, 0, MS_SILENT, MZ_LARGE), 0, 0,
	M1_ANIMAL|M1_NOHANDS|M1_OMNIVORE, M2_HOSTILE, M3_INFRAVISIBLE,
	CLR_BROWN);

    Monsters.AddMonster("mumak", S_QUADRUPED,
	Monsters.LVL(5, 9, 0, 0, -2), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BUTT, AD_PHYS, 4,12), Monsters.ATTK(AT_BITE, AD_PHYS, 2, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(2500, 500, 0, MS_ROAR, MZ_LARGE), 0, 0,
	M1_ANIMAL|M1_THICK_HIDE|M1_NOHANDS|M1_HERBIVORE,
	M2_HOSTILE|M2_STRONG, M3_INFRAVISIBLE, CLR_GRAY);

    Monsters.AddMonster("leocrotta", S_QUADRUPED,
	Monsters.LVL(6, 18, 4, 10, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 2, 6), Monsters.ATTK(AT_BITE, AD_PHYS, 2, 6),
	  Monsters.ATTK(AT_CLAW, AD_PHYS, 2, 6), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1200, 500, 0, MS_IMITATE, MZ_LARGE), 0, 0,
	M1_ANIMAL|M1_NOHANDS|M1_OMNIVORE, M2_HOSTILE|M2_STRONG,
	M3_INFRAVISIBLE, CLR_RED);

    Monsters.AddMonster("wumpus", S_QUADRUPED,
	Monsters.LVL(8, 3, 2, 10, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 3, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(2500, 500, 0, MS_BURBLE, MZ_LARGE), 0, 0,
	M1_CLING|M1_ANIMAL|M1_NOHANDS|M1_OMNIVORE,
	M2_HOSTILE|M2_STRONG, M3_INFRAVISIBLE, CLR_CYAN);

    Monsters.AddMonster("titanothere", S_QUADRUPED,
	Monsters.LVL(12, 12, 6, 0, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 2, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(2650, 650, 0, MS_SILENT, MZ_LARGE), 0, 0,
	M1_ANIMAL|M1_THICK_HIDE|M1_NOHANDS|M1_HERBIVORE,
	M2_HOSTILE|M2_STRONG, M3_INFRAVISIBLE, CLR_GRAY);

    Monsters.AddMonster("baluchitherium", S_QUADRUPED,
	Monsters.LVL(14, 12, 5, 0, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 5, 4), Monsters.ATTK(AT_CLAW, AD_PHYS, 5, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(3800, 800, 0, MS_SILENT, MZ_LARGE), 0, 0,
	M1_ANIMAL|M1_THICK_HIDE|M1_NOHANDS|M1_HERBIVORE,
	M2_HOSTILE|M2_STRONG, M3_INFRAVISIBLE, CLR_GRAY);

    Monsters.AddMonster("mastodon", S_QUADRUPED,
	Monsters.LVL(20, 12, 5, 0, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BUTT, AD_PHYS, 4, 8), Monsters.ATTK(AT_BUTT, AD_PHYS, 4, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(3800, 800, 0, MS_SILENT, MZ_LARGE), 0, 0,
	M1_ANIMAL|M1_THICK_HIDE|M1_NOHANDS|M1_HERBIVORE,
	M2_HOSTILE|M2_STRONG, M3_INFRAVISIBLE, CLR_BLACK);

/*
 * rodents
 */
    Monsters.AddMonster("sewer rat", S_RODENT,
	Monsters.LVL(0, 12, 7, 0, 0), (G_GENO|G_SGROUP|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 3),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(20, 12, 0, MS_SQEEK, MZ_TINY), 0, 0,
	M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE, M2_HOSTILE, M3_INFRAVISIBLE,
	CLR_BROWN);

    Monsters.AddMonster("giant rat", S_RODENT,
	Monsters.LVL(1, 10, 7, 0, 0), (G_GENO|G_SGROUP|2),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 3),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(30, 30, 0, MS_SQEEK, MZ_TINY), 0, 0,
	M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE, M2_HOSTILE, M3_INFRAVISIBLE,
	CLR_BROWN);

    Monsters.AddMonster("rabid rat", S_RODENT,
	Monsters.LVL(2, 12, 6, 0, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_DRCO, 2, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(30, 5, 0, MS_SQEEK, MZ_TINY), MR_POISON, 0,
	M1_ANIMAL|M1_NOHANDS|M1_POIS|M1_CARNIVORE, M2_HOSTILE, M3_INFRAVISIBLE,
	CLR_BROWN);

    Monsters.AddMonster("wererat", S_RODENT,
	Monsters.LVL(2, 12, 6, 10, -7), (G_NOGEN|G_NOCORPSE),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_WERE, 1, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(40, 30, 0, MS_SQEEK, MZ_TINY), MR_POISON, 0,
	M1_NOHANDS|M1_POIS|M1_REGEN|M1_CARNIVORE,
	M2_NOPOLY|M2_WERE|M2_HOSTILE, M3_INFRAVISIBLE, CLR_BROWN);

    Monsters.AddMonster("rock mole", S_RODENT,
	Monsters.LVL(3, 3, 0, 20, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(30, 30, 0, MS_SILENT, MZ_SMALL), 0, 0,
	M1_TUNNEL|M1_ANIMAL|M1_NOHANDS|M1_METALLIVORE,
	M2_HOSTILE|M2_GREEDY|M2_JEWELS|M2_COLLECT, M3_INFRAVISIBLE, CLR_GRAY);

	Monsters.AddMonster("woodchuck", S_RODENT,
	Monsters.LVL(3, 3, 0, 20, 0), (G_NOGEN|G_GENO),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(30, 30, 0, MS_SILENT, MZ_SMALL), 0, 0,
	M1_TUNNEL/*LOGGING*/|M1_ANIMAL|M1_NOHANDS|M1_SWIM,
		/* In reality, they tunnel instead of cutting lumber.  Oh, well. */
	M2_WANDER|M2_HOSTILE, M3_INFRAVISIBLE, CLR_BROWN);

/*
 * spiders & scorpions
 */
    Monsters.AddMonster("cave spider", S_SPIDER,
	Monsters.LVL(1, 12, 3, 0, 0), (G_GENO|G_SGROUP|2),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 2),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(50, 50, 0, MS_SILENT, MZ_TINY), MR_POISON, MR_POISON,
	M1_CONCEAL|M1_ANIMAL|M1_NOHANDS|M1_OVIPAROUS|M1_CARNIVORE,
	M2_HOSTILE, 0, CLR_GRAY);

    Monsters.AddMonster("centipede", S_SPIDER,
	Monsters.LVL(2, 4, 3, 0, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_DRST, 1, 3), NO_ATTK, NO_ATTK,
	  NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(50, 50, 0, MS_SILENT, MZ_TINY), MR_POISON, MR_POISON,
	M1_CONCEAL|M1_ANIMAL|M1_NOHANDS|M1_OVIPAROUS|M1_CARNIVORE,
	M2_HOSTILE, 0, CLR_YELLOW);

    Monsters.AddMonster("giant spider", S_SPIDER,
	Monsters.LVL(5, 15, 4, 0, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_DRST, 2, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(100, 100, 0, MS_SILENT, MZ_LARGE), MR_POISON, MR_POISON,
	M1_ANIMAL|M1_NOHANDS|M1_OVIPAROUS|M1_POIS|M1_CARNIVORE,
	M2_HOSTILE|M2_STRONG, 0, CLR_MAGENTA);

    Monsters.AddMonster("scorpion", S_SPIDER,
	Monsters.LVL(5, 15, 3, 0, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 2), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 2),
	  Monsters.ATTK(AT_STNG, AD_DRST, 1, 4), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(50, 100, 0, MS_SILENT, MZ_SMALL), MR_POISON, MR_POISON,
	M1_CONCEAL|M1_ANIMAL|M1_NOHANDS|M1_OVIPAROUS|M1_POIS|M1_CARNIVORE,
	M2_HOSTILE, 0, CLR_RED);

/*
 * trappers, lurkers, &c
 */
    Monsters.AddMonster("lurker above", S_TRAPPER,
	Monsters.LVL(10, 3, 3, 0, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_ENGL, AD_DGST, 1, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(800, 350, 0, MS_SILENT, MZ_HUGE), 0, 0,
	M1_HIDE|M1_FLY|M1_ANIMAL|M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|M1_CARNIVORE,
	M2_HOSTILE|M2_STALK|M2_STRONG, 0, CLR_GRAY);

    Monsters.AddMonster("trapper", S_TRAPPER,
	Monsters.LVL(12, 3, 3, 0, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_ENGL, AD_DGST, 1,10),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(800, 350, 0, MS_SILENT, MZ_HUGE), 0, 0,
	M1_HIDE|M1_ANIMAL|M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|M1_CARNIVORE,
	M2_HOSTILE|M2_STALK|M2_STRONG, 0, CLR_GREEN);

/*
 * unicorns and horses
 */
    Monsters.AddMonster("white unicorn", S_UNICORN,
	Monsters.LVL(4, 24, 2, 70, 7), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_BUTT, AD_PHYS, 1,12), Monsters.ATTK(AT_KICK, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1300, 300, 0, MS_NEIGH, MZ_LARGE), MR_POISON, MR_POISON,
	M1_NOHANDS|M1_HERBIVORE, M2_WANDER|M2_STRONG|M2_JEWELS,
	M3_INFRAVISIBLE, CLR_WHITE);

    Monsters.AddMonster("gray unicorn", S_UNICORN,
	Monsters.LVL(4, 24, 2, 70, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BUTT, AD_PHYS, 1,12), Monsters.ATTK(AT_KICK, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1300, 300, 0, MS_NEIGH, MZ_LARGE), MR_POISON, MR_POISON,
	M1_NOHANDS|M1_HERBIVORE, M2_WANDER|M2_STRONG|M2_JEWELS,
	M3_INFRAVISIBLE, CLR_GRAY);

    Monsters.AddMonster("black unicorn", S_UNICORN,
	Monsters.LVL(4, 24, 2, 70, -7), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BUTT, AD_PHYS, 1,12), Monsters.ATTK(AT_KICK, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1300, 300, 0, MS_NEIGH, MZ_LARGE), MR_POISON, MR_POISON,
	M1_NOHANDS|M1_HERBIVORE, M2_WANDER|M2_STRONG|M2_JEWELS,
	M3_INFRAVISIBLE, CLR_BLACK);

    Monsters.AddMonster("pony", S_UNICORN,
	Monsters.LVL(3, 16, 6, 0, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_KICK, AD_PHYS, 1, 6), Monsters.ATTK(AT_BITE, AD_PHYS, 1, 2),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1300, 250, 0, MS_NEIGH, MZ_MEDIUM), 0, 0,
	M1_ANIMAL|M1_NOHANDS|M1_HERBIVORE, M2_WANDER|M2_STRONG|M2_DOMESTIC,
	M3_INFRAVISIBLE, CLR_BROWN);

    Monsters.AddMonster("horse", S_UNICORN,
	Monsters.LVL(5, 20, 5, 0, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_KICK, AD_PHYS, 1, 8), Monsters.ATTK(AT_BITE, AD_PHYS, 1, 3),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1500, 300, 0, MS_NEIGH, MZ_LARGE), 0, 0,
	M1_ANIMAL|M1_NOHANDS|M1_HERBIVORE, M2_WANDER|M2_STRONG|M2_DOMESTIC,
	M3_INFRAVISIBLE, CLR_BROWN);

    Monsters.AddMonster("warhorse", S_UNICORN,
	Monsters.LVL(7, 24, 4, 0, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_KICK, AD_PHYS, 1, 10), Monsters.ATTK(AT_BITE, AD_PHYS, 1, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1800, 350, 0, MS_NEIGH, MZ_LARGE), 0, 0,
	M1_ANIMAL|M1_NOHANDS|M1_HERBIVORE, M2_WANDER|M2_STRONG|M2_DOMESTIC,
	M3_INFRAVISIBLE, CLR_BROWN);

/*
 * vortices
 */
    Monsters.AddMonster("fog cloud", S_VORTEX,
	Monsters.LVL(3, 1, 0, 0, 0), (G_GENO|G_NOCORPSE|2),
	Monsters.A(Monsters.ATTK(AT_ENGL, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(0, 0, 0, MS_SILENT, MZ_HUGE), MR_SLEEP|MR_POISON|MR_STONE, 0,
	M1_FLY|M1_BREATHLESS|M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|M1_MINDLESS|
	  M1_AMORPHOUS|M1_UNSOLID,
	M2_HOSTILE|M2_NEUTER, 0, CLR_GRAY);

    Monsters.AddMonster("dust vortex", S_VORTEX,
	Monsters.LVL(4, 20, 2, 30, 0), (G_GENO|G_NOCORPSE|2),
	Monsters.A(Monsters.ATTK(AT_ENGL, AD_BLND, 2, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(0, 0, 0, MS_SILENT, MZ_HUGE), MR_SLEEP|MR_POISON|MR_STONE, 0,
	M1_FLY|M1_BREATHLESS|M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|M1_MINDLESS,
	M2_HOSTILE|M2_NEUTER, 0, CLR_BROWN);

    Monsters.AddMonster("ice vortex", S_VORTEX,
	Monsters.LVL(5, 20, 2, 30, 0), (G_NOHELL|G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_ENGL, AD_COLD, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(0, 0, 0, MS_SILENT, MZ_HUGE),
	MR_COLD|MR_SLEEP|MR_POISON|MR_STONE, 0,
	M1_FLY|M1_BREATHLESS|M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|M1_MINDLESS,
	M2_HOSTILE|M2_NEUTER, 0, CLR_CYAN);

    Monsters.AddMonster("energy vortex", S_VORTEX,
	Monsters.LVL(6, 20, 2, 30, 0), (G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_ENGL, AD_ELEC, 1, 6), Monsters.ATTK(AT_ENGL, AD_DREN, 0, 0),
	  Monsters.ATTK(AT_NONE, AD_ELEC, 0, 4), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(0, 0, 0, MS_SILENT, MZ_HUGE),
	MR_ELEC|MR_SLEEP|MR_DISINT|MR_POISON|MR_STONE, 0,
	M1_FLY|M1_BREATHLESS|M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|M1_MINDLESS|
	  M1_UNSOLID,
	M2_HOSTILE|M2_NEUTER, 0, HI_ZAP);

    Monsters.AddMonster("steam vortex", S_VORTEX,
	Monsters.LVL(7, 22, 2, 30, 0), (G_HELL|G_GENO|G_NOCORPSE|2),
	Monsters.A(Monsters.ATTK(AT_ENGL, AD_FIRE, 1, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(0, 0, 0, MS_SILENT, MZ_HUGE),
	MR_FIRE|MR_SLEEP|MR_POISON|MR_STONE, 0,
	M1_FLY|M1_BREATHLESS|M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|M1_MINDLESS|
	  M1_UNSOLID,
	M2_HOSTILE|M2_NEUTER, M3_INFRAVISIBLE, CLR_BLUE);

    Monsters.AddMonster("fire vortex", S_VORTEX,
	Monsters.LVL(8, 22, 2, 30, 0), (G_HELL|G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_ENGL, AD_FIRE, 1,10), Monsters.ATTK(AT_NONE, AD_FIRE, 0, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(0, 0, 0, MS_SILENT, MZ_HUGE),
	MR_FIRE|MR_SLEEP|MR_POISON|MR_STONE, 0,
	M1_FLY|M1_BREATHLESS|M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|M1_MINDLESS|
	  M1_UNSOLID,
	M2_HOSTILE|M2_NEUTER, M3_INFRAVISIBLE, CLR_YELLOW);

/*
 * worms
 */
    Monsters.AddMonster("baby long worm", S_WORM,
	Monsters.LVL(8, 3, 5, 0, 0), G_GENO,
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(600, 250, 0, MS_SILENT, MZ_LARGE), 0, 0,
	M1_ANIMAL|M1_SLITHY|M1_NOLIMBS|M1_CARNIVORE|M1_NOTAKE,
	M2_HOSTILE, 0, CLR_BROWN);

    Monsters.AddMonster("baby purple worm", S_WORM,
	Monsters.LVL(8, 3, 5, 0, 0), G_GENO,
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(600, 250, 0, MS_SILENT, MZ_LARGE), 0, 0,
	M1_ANIMAL|M1_SLITHY|M1_NOLIMBS|M1_CARNIVORE, M2_HOSTILE,
	0, CLR_MAGENTA);

    Monsters.AddMonster("long worm", S_WORM,
	Monsters.LVL(8, 3, 5, 10, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1500, 500, 0, MS_SILENT, MZ_GIGANTIC), 0, 0,
	M1_ANIMAL|M1_SLITHY|M1_NOLIMBS|M1_OVIPAROUS|M1_CARNIVORE|M1_NOTAKE,
	M2_HOSTILE|M2_STRONG|M2_NASTY, 0, CLR_BROWN);

    Monsters.AddMonster("purple worm", S_WORM,
	Monsters.LVL(15, 9, 6, 20, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 2, 8), Monsters.ATTK(AT_ENGL, AD_DGST, 1,10),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(2700, 700, 0, MS_SILENT, MZ_GIGANTIC), 0, 0,
	M1_ANIMAL|M1_SLITHY|M1_NOLIMBS|M1_OVIPAROUS|M1_CARNIVORE,
	M2_HOSTILE|M2_STRONG|M2_NASTY, 0, CLR_MAGENTA);

/*
 * xan, &c
 */
    Monsters.AddMonster("grid bug", S_XAN,
	Monsters.LVL(0, 12, 9, 0, 0), (G_GENO|G_SGROUP|G_NOCORPSE|3),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_ELEC, 1, 1),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(15, 10, 0, MS_BUZZ, MZ_TINY), MR_ELEC|MR_POISON, 0,
	M1_ANIMAL, M2_HOSTILE, M3_INFRAVISIBLE, CLR_MAGENTA);

    Monsters.AddMonster("xan", S_XAN,
	Monsters.LVL(7, 18, -4, 0, 0), (G_GENO|3),
	Monsters.A(Monsters.ATTK(AT_STNG, AD_LEGS, 1, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(300, 300, 0, MS_BUZZ, MZ_TINY), MR_POISON, MR_POISON,
	M1_FLY|M1_ANIMAL|M1_NOHANDS|M1_POIS, M2_HOSTILE, M3_INFRAVISIBLE,
	CLR_RED);

/*
 * lights
 */
    Monsters.AddMonster("yellow light", S_LIGHT,
	Monsters.LVL(3, 15, 0, 0, 0), (G_NOCORPSE|G_GENO|4),
	Monsters.A(Monsters.ATTK(AT_EXPL, AD_BLND, 10,20),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(0, 0, 0, MS_SILENT, MZ_SMALL),
	MR_FIRE|MR_COLD|MR_ELEC|MR_DISINT|MR_SLEEP|MR_POISON|MR_ACID|
	  MR_STONE, 0,
	M1_FLY|M1_BREATHLESS|M1_AMORPHOUS|M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|
	  M1_MINDLESS|M1_UNSOLID|M1_NOTAKE,
	M2_HOSTILE|M2_NEUTER, M3_INFRAVISIBLE, CLR_YELLOW);

    Monsters.AddMonster("black light", S_LIGHT,
	Monsters.LVL(5, 15, 0, 0, 0), (G_NOCORPSE|G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_EXPL, AD_HALU, 10,12),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(0, 0, 0, MS_SILENT, MZ_SMALL),
	MR_FIRE|MR_COLD|MR_ELEC|MR_DISINT|MR_SLEEP|MR_POISON|MR_ACID|
	  MR_STONE, 0,
	M1_FLY|M1_BREATHLESS|M1_AMORPHOUS|M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|
	  M1_MINDLESS|M1_UNSOLID|M1_SEE_INVIS|M1_NOTAKE,
	M2_HOSTILE|M2_NEUTER, 0, CLR_BLACK);

/*
 * zruty
 */
    Monsters.AddMonster("zruty", S_ZRUTY,
	Monsters.LVL(9, 8, 3, 0, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 3, 4), Monsters.ATTK(AT_CLAW, AD_PHYS, 3, 4),
	  Monsters.ATTK(AT_BITE, AD_PHYS, 3, 6), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1200, 600, 0, MS_SILENT, MZ_LARGE), 0, 0,
	M1_ANIMAL|M1_HUMANOID|M1_CARNIVORE,
	M2_HOSTILE|M2_STRONG, M3_INFRAVISIBLE, CLR_BROWN);

/*
 * Angels and other lawful minions
 */
    Monsters.AddMonster("couatl", S_ANGEL,
	Monsters.LVL(8, 10, 5, 30, 7), (G_NOHELL|G_SGROUP|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_DRST, 2, 4), Monsters.ATTK(AT_BITE, AD_PHYS, 1, 3),
	  Monsters.ATTK(AT_HUGS, AD_WRAP, 2, 4), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(900, 400, 0, MS_HISS, MZ_LARGE), MR_POISON, 0,
	M1_FLY|M1_POIS,
	M2_MINION|M2_STALK|M2_STRONG|M2_NASTY, M3_INFRAVISIBLE|M3_INFRAVISION,
	CLR_GREEN);

    Monsters.AddMonster("Aleax", S_ANGEL,
	Monsters.LVL(10, 8, 0, 30, 7), (G_NOHELL|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6), Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  Monsters.ATTK(AT_KICK, AD_PHYS, 1, 4), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_IMITATE, MZ_HUMAN),
	MR_COLD|MR_ELEC|MR_SLEEP|MR_POISON, 0,
	M1_HUMANOID|M1_SEE_INVIS,
	M2_MINION|M2_STALK|M2_NASTY|M2_COLLECT, M3_INFRAVISIBLE|M3_INFRAVISION,
	CLR_YELLOW);

    Monsters.AddMonster("Angel", S_ANGEL,
	Monsters.LVL(14, 10, -4, 55, 12), (G_NOHELL|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4),
	  Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6), Monsters.ATTK(AT_MAGC, AD_MAGM, 2, 6),
	  NO_ATTK, NO_ATTK),
   //FIXME
	//Monsters.SIZ(WT_HUMAN, 400, sizeof(struct epri), MS_CUSS, MZ_HUMAN),
   Monsters.SIZ(WT_HUMAN, 400, 1, MS_CUSS, MZ_HUMAN),
	MR_COLD|MR_ELEC|MR_SLEEP|MR_POISON, 0,
	M1_HUMANOID|M1_SEE_INVIS,
	M2_NOPOLY|M2_MINION|M2_STALK|M2_STRONG|M2_NASTY|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_WHITE);

    Monsters.AddMonster("ki-rin", S_ANGEL,
	Monsters.LVL(16, 18, -5, 90, 15), (G_NOHELL|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_KICK, AD_PHYS, 2, 4), Monsters.ATTK(AT_KICK, AD_BLND, 2, 4),
	  Monsters.ATTK(AT_BUTT, AD_PHYS, 3, 6), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_NEIGH, MZ_LARGE), 0, 0,
	M1_FLY|M1_SEE_INVIS,
	M2_NOPOLY|M2_MINION|M2_STALK|M2_STRONG|M2_NASTY|M2_LORD,
	M3_INFRAVISIBLE|M3_INFRAVISION, HI_GOLD);

    Monsters.AddMonster("Archon", S_ANGEL,
	Monsters.LVL(19, 16, -6, 80, 15), (G_NOHELL|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4), Monsters.ATTK(AT_GAZE, AD_BLND, 2, 6),
	  Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 8),
	  Monsters.ATTK(AT_MAGC, AD_SPEL, 4, 6), NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_CUSS, MZ_LARGE),
	MR_FIRE|MR_COLD|MR_ELEC|MR_SLEEP|MR_POISON, 0,
	M1_FLY|M1_HUMANOID|M1_SEE_INVIS|M1_REGEN,
	M2_NOPOLY|M2_MINION|M2_STALK|M2_STRONG|M2_NASTY|M2_LORD|
	  M2_COLLECT|M2_MAGIC,
	M3_INFRAVISIBLE|M3_INFRAVISION, HI_LORD);

/*
 * Bats
 */
    Monsters.AddMonster("bat", S_BAT,
	Monsters.LVL(0, 22, 8, 0, 0), (G_GENO|G_SGROUP|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(20, 20, 0, MS_SQEEK, MZ_TINY), 0, 0,
	M1_FLY|M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE, M2_WANDER, M3_INFRAVISIBLE,
	CLR_BROWN);

    Monsters.AddMonster("giant bat", S_BAT,
	Monsters.LVL(2, 22, 7, 0, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(30, 30, 0, MS_SQEEK, MZ_MEDIUM), 0, 0,
	M1_FLY|M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE,
	M2_WANDER|M2_HOSTILE, M3_INFRAVISIBLE, CLR_RED);

    Monsters.AddMonster("raven", S_BAT,
	Monsters.LVL(4, 20, 6, 0, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 6), Monsters.ATTK(AT_CLAW, AD_BLND, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(40, 20, 0, MS_SQAWK, MZ_MEDIUM), 0, 0,
	M1_FLY|M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE,
	M2_WANDER|M2_HOSTILE, M3_INFRAVISIBLE, CLR_BLACK);

    Monsters.AddMonster("vampire bat", S_BAT,
	Monsters.LVL(5, 20, 6, 0, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 6), Monsters.ATTK(AT_BITE, AD_DRST, 0, 0),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(30, 20, 0, MS_SQEEK, MZ_TINY), MR_SLEEP|MR_POISON, 0,
	M1_FLY|M1_BREATHLESS|M1_ANIMAL|M1_NOHANDS|M1_POIS|M1_REGEN,
	M2_UNDEAD|M2_HOSTILE, M3_INFRAVISIBLE, CLR_BLACK);

/*
 * Centaurs
 */
    Monsters.AddMonster("plains centaur", S_CENTAUR,
	Monsters.LVL(4, 18, 4, 0, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6), Monsters.ATTK(AT_KICK, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(2500, 500, 0, MS_HUMANOID, MZ_LARGE), 0, 0,
	M1_HUMANOID|M1_OMNIVORE, M2_STRONG|M2_GREEDY|M2_COLLECT,
	M3_INFRAVISIBLE, CLR_BROWN);

    Monsters.AddMonster("forest centaur", S_CENTAUR,
	Monsters.LVL(5, 18, 3, 10, -1), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 8), Monsters.ATTK(AT_KICK, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(2550, 600, 0, MS_HUMANOID, MZ_LARGE), 0, 0,
	M1_HUMANOID|M1_OMNIVORE, M2_STRONG|M2_GREEDY|M2_COLLECT,
	M3_INFRAVISIBLE, CLR_GREEN);

    Monsters.AddMonster("mountain centaur", S_CENTAUR,
	Monsters.LVL(6, 20, 2, 10, -3), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1,10), Monsters.ATTK(AT_KICK, AD_PHYS, 1, 6),
	  Monsters.ATTK(AT_KICK, AD_PHYS, 1, 6), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(2550, 500, 0, MS_HUMANOID, MZ_LARGE), 0, 0,
	M1_HUMANOID|M1_OMNIVORE, M2_STRONG|M2_GREEDY|M2_COLLECT,
	M3_INFRAVISIBLE, CLR_CYAN);

/*
 * Dragons
 */
	/* The order of the dragons is VERY IMPORTANT.  Quite a few
	 * pieces of code depend on gray being first and yellow being last.
	 * The code also depends on the *order* being the same as that for
	 * dragon scale mail and dragon scales in objects.c.  Baby dragons
	 * cannot confer intrinsics, to avoid polyself/egg abuse.
	 *
	 * As reptiles, dragons are cold-blooded and thus aren't seen
	 * with infravision.  Red dragons are the exception.
	 */
    Monsters.AddMonster("baby gray dragon", S_DRAGON,
	Monsters.LVL(12, 9, 2, 10, 0), G_GENO,
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 2, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1500, 500, 0, MS_ROAR, MZ_HUGE), 0, 0,
	M1_FLY|M1_THICK_HIDE|M1_NOHANDS|M1_CARNIVORE,
	M2_HOSTILE|M2_STRONG|M2_GREEDY|M2_JEWELS, M3_INFRAVISIBLE, CLR_GRAY);

    Monsters.AddMonster("baby silver dragon", S_DRAGON,
	Monsters.LVL(12, 9, 2, 40, 0), G_GENO,
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 2, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1500, 500, 0, MS_ROAR, MZ_HUGE), 0, 0,
	M1_FLY|M1_THICK_HIDE|M1_NOHANDS|M1_CARNIVORE,
	M2_HOSTILE|M2_STRONG|M2_GREEDY|M2_JEWELS, 0, CLR_BRIGHT_CYAN);

#if 0	/* DEFERRED */
    Monsters.AddMonster("baby shimmering dragon", S_DRAGON,
	Monsters.LVL(12, 9, 2, 10, 0), G_GENO,
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 2, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1500, 500, 0, MS_ROAR, MZ_HUGE), 0, 0,
	M1_FLY|M1_THICK_HIDE|M1_NOHANDS|M1_CARNIVORE,
	M2_HOSTILE|M2_STRONG|M2_GREEDY|M2_JEWELS, 0, CLR_CYAN);

#endif
    Monsters.AddMonster("baby red dragon", S_DRAGON,
	Monsters.LVL(12, 9, 2, 10, 0), G_GENO,
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 2, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1500, 500, 0, MS_ROAR, MZ_HUGE), MR_FIRE, 0,
	M1_FLY|M1_THICK_HIDE|M1_NOHANDS|M1_CARNIVORE,
	M2_HOSTILE|M2_STRONG|M2_GREEDY|M2_JEWELS, M3_INFRAVISIBLE, CLR_RED);

    Monsters.AddMonster("baby white dragon", S_DRAGON,
	Monsters.LVL(12, 9, 2, 10, 0), G_GENO,
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 2, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1500, 500, 0, MS_ROAR, MZ_HUGE), MR_COLD, 0,
	M1_FLY|M1_THICK_HIDE|M1_NOHANDS|M1_CARNIVORE,
	M2_HOSTILE|M2_STRONG|M2_GREEDY|M2_JEWELS, 0, CLR_WHITE);

    Monsters.AddMonster("baby orange dragon", S_DRAGON,
	Monsters.LVL(12, 9, 2, 10, 0), G_GENO,
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 2, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1500, 500, 0, MS_ROAR, MZ_HUGE), MR_SLEEP, 0,
	M1_FLY|M1_THICK_HIDE|M1_NOHANDS|M1_CARNIVORE,
	M2_HOSTILE|M2_STRONG|M2_GREEDY|M2_JEWELS, 0, CLR_ORANGE);

    Monsters.AddMonster("baby black dragon", S_DRAGON,
	Monsters.LVL(12, 9, 2, 10, 0), G_GENO,
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 2, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1500, 500, 0, MS_ROAR, MZ_HUGE), MR_DISINT, 0,
	M1_FLY|M1_THICK_HIDE|M1_NOHANDS|M1_CARNIVORE,
	M2_HOSTILE|M2_STRONG|M2_GREEDY|M2_JEWELS, 0, CLR_BLACK);

    Monsters.AddMonster("baby blue dragon", S_DRAGON,
	Monsters.LVL(12, 9, 2, 10, 0), G_GENO,
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 2, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1500, 500, 0, MS_ROAR, MZ_HUGE), MR_ELEC, 0,
	M1_FLY|M1_THICK_HIDE|M1_NOHANDS|M1_CARNIVORE,
	M2_HOSTILE|M2_STRONG|M2_GREEDY|M2_JEWELS, 0, CLR_BLUE);

    Monsters.AddMonster("baby green dragon", S_DRAGON,
	Monsters.LVL(12, 9, 2, 10, 0), G_GENO,
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 2, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1500, 500, 0, MS_ROAR, MZ_HUGE), MR_POISON, 0,
	M1_FLY|M1_THICK_HIDE|M1_NOHANDS|M1_CARNIVORE|M1_POIS,
	M2_HOSTILE|M2_STRONG|M2_GREEDY|M2_JEWELS, 0, CLR_GREEN);

    Monsters.AddMonster("baby yellow dragon", S_DRAGON,
	Monsters.LVL(12, 9, 2, 10, 0), G_GENO,
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 2, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1500, 500, 0, MS_ROAR, MZ_HUGE), MR_ACID|MR_STONE, 0,
	M1_FLY|M1_THICK_HIDE|M1_NOHANDS|M1_CARNIVORE|M1_ACID,
	M2_HOSTILE|M2_STRONG|M2_GREEDY|M2_JEWELS, 0, CLR_YELLOW);

    Monsters.AddMonster("gray dragon", S_DRAGON,
	Monsters.LVL(15, 9, -1, 20, 4), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BREA, AD_MAGM, 4, 6), Monsters.ATTK(AT_BITE, AD_PHYS, 3, 8),
	  Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_DRAGON, 1500, 0, MS_ROAR, MZ_GIGANTIC), 0, 0,
	M1_FLY|M1_THICK_HIDE|M1_NOHANDS|M1_SEE_INVIS|M1_OVIPAROUS|
	  M1_CARNIVORE,
	M2_HOSTILE|M2_STRONG|M2_NASTY|M2_GREEDY|M2_JEWELS|M2_MAGIC, 0, CLR_GRAY);

    Monsters.AddMonster("silver dragon", S_DRAGON,
	Monsters.LVL(15, 9, -1, 95, 4), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BREA, AD_COLD, 4, 6), Monsters.ATTK(AT_BITE, AD_PHYS, 3, 8),
	  Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_DRAGON, 1500, 0, MS_ROAR, MZ_GIGANTIC), MR_COLD, 0,
	M1_FLY|M1_THICK_HIDE|M1_NOHANDS|M1_SEE_INVIS|M1_OVIPAROUS|
	  M1_CARNIVORE,
	M2_HOSTILE|M2_STRONG|M2_NASTY|M2_GREEDY|M2_JEWELS|M2_MAGIC,
	0, CLR_BRIGHT_CYAN);

#if 0	/* DEFERRED */
    Monsters.AddMonster("shimmering dragon", S_DRAGON,
	Monsters.LVL(15, 9, -1, 20, 4), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BREA, AD_MAGM, 4, 6), Monsters.ATTK(AT_BITE, AD_PHYS, 3, 8),
	  Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_DRAGON, 1500, 0, MS_ROAR, MZ_GIGANTIC), 0, 0,
	M1_FLY|M1_THICK_HIDE|M1_NOHANDS|M1_SEE_INVIS|M1_OVIPAROUS|
	  M1_CARNIVORE,
	M2_HOSTILE|M2_STRONG|M2_NASTY|M2_GREEDY|M2_JEWELS|M2_MAGIC,
	0, CLR_CYAN);

#endif
    Monsters.AddMonster("red dragon", S_DRAGON,
	Monsters.LVL(15, 9, -1, 20, -4), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BREA, AD_FIRE, 6, 6), Monsters.ATTK(AT_BITE, AD_PHYS, 3, 8),
	  Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_DRAGON, 1500, 0, MS_ROAR, MZ_GIGANTIC), MR_FIRE, MR_FIRE,
	M1_FLY|M1_THICK_HIDE|M1_NOHANDS|M1_SEE_INVIS|M1_OVIPAROUS|
	  M1_CARNIVORE,
	M2_HOSTILE|M2_STRONG|M2_NASTY|M2_GREEDY|M2_JEWELS|M2_MAGIC,
	M3_INFRAVISIBLE, CLR_RED);

    Monsters.AddMonster("white dragon", S_DRAGON,
	Monsters.LVL(15, 9, -1, 20, -5), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BREA, AD_COLD, 4, 6), Monsters.ATTK(AT_BITE, AD_PHYS, 3, 8),
	  Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_DRAGON, 1500, 0, MS_ROAR, MZ_GIGANTIC), MR_COLD, MR_COLD,
	M1_FLY|M1_THICK_HIDE|M1_NOHANDS|M1_SEE_INVIS|M1_OVIPAROUS|
	  M1_CARNIVORE,
	M2_HOSTILE|M2_STRONG|M2_NASTY|M2_GREEDY|M2_JEWELS|M2_MAGIC, 0, CLR_WHITE);

    Monsters.AddMonster("orange dragon", S_DRAGON,
	Monsters.LVL(15, 9, -1, 20, 5), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BREA, AD_SLEE, 4,25), Monsters.ATTK(AT_BITE, AD_PHYS, 3, 8),
	  Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_DRAGON, 1500, 0, MS_ROAR, MZ_GIGANTIC), MR_SLEEP, MR_SLEEP,
	M1_FLY|M1_THICK_HIDE|M1_NOHANDS|M1_SEE_INVIS|M1_OVIPAROUS|
	  M1_CARNIVORE,
	M2_HOSTILE|M2_STRONG|M2_NASTY|M2_GREEDY|M2_JEWELS|M2_MAGIC,
	0, CLR_ORANGE);

    Monsters.AddMonster("black dragon", S_DRAGON,
	Monsters.LVL(15, 9, -1, 20, -6), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BREA, AD_DISN, 4,10), Monsters.ATTK(AT_BITE, AD_PHYS, 3, 8),
	  Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_DRAGON, 1500, 0, MS_ROAR, MZ_GIGANTIC), MR_DISINT, MR_DISINT,
	M1_FLY|M1_THICK_HIDE|M1_NOHANDS|M1_SEE_INVIS|M1_OVIPAROUS|
	  M1_CARNIVORE,
	M2_HOSTILE|M2_STRONG|M2_NASTY|M2_GREEDY|M2_JEWELS|M2_MAGIC, 0, CLR_BLACK);

    Monsters.AddMonster("blue dragon", S_DRAGON,
	Monsters.LVL(15, 9, -1, 20, -7), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BREA, AD_ELEC, 4, 6), Monsters.ATTK(AT_BITE, AD_PHYS, 3, 8),
	  Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_DRAGON, 1500, 0, MS_ROAR, MZ_GIGANTIC), MR_ELEC, MR_ELEC,
	M1_FLY|M1_THICK_HIDE|M1_NOHANDS|M1_SEE_INVIS|M1_OVIPAROUS|
	  M1_CARNIVORE,
	M2_HOSTILE|M2_STRONG|M2_NASTY|M2_GREEDY|M2_JEWELS|M2_MAGIC, 0, CLR_BLUE);

    Monsters.AddMonster("green dragon", S_DRAGON,
	Monsters.LVL(15, 9, -1, 20, 6), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BREA, AD_DRST, 4, 6), Monsters.ATTK(AT_BITE, AD_PHYS, 3, 8),
	  Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_DRAGON, 1500, 0, MS_ROAR, MZ_GIGANTIC), MR_POISON, MR_POISON,
	M1_FLY|M1_THICK_HIDE|M1_NOHANDS|M1_SEE_INVIS|M1_OVIPAROUS|
	  M1_CARNIVORE|M1_POIS,
	M2_HOSTILE|M2_STRONG|M2_NASTY|M2_GREEDY|M2_JEWELS|M2_MAGIC, 0, CLR_GREEN);

    Monsters.AddMonster("yellow dragon", S_DRAGON,
	Monsters.LVL(15, 9, -1, 20, 7), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BREA, AD_ACID, 4, 6), Monsters.ATTK(AT_BITE, AD_PHYS, 3, 8),
	  Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_DRAGON, 1500, 0, MS_ROAR, MZ_GIGANTIC),
	MR_ACID|MR_STONE, MR_STONE,
	M1_FLY|M1_THICK_HIDE|M1_NOHANDS|M1_SEE_INVIS|M1_OVIPAROUS|
	  M1_CARNIVORE|M1_ACID,
	M2_HOSTILE|M2_STRONG|M2_NASTY|M2_GREEDY|M2_JEWELS|M2_MAGIC,
	0, CLR_YELLOW);

/*
 * Elementals
 */
    Monsters.AddMonster("stalker", S_ELEMENTAL,
	Monsters.LVL(8, 12, 3, 0, 0), (G_GENO|3),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 4, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(900, 400, 0, MS_SILENT, MZ_LARGE), 0, 0,
	M1_ANIMAL|M1_FLY|M1_SEE_INVIS,
	M2_WANDER|M2_STALK|M2_HOSTILE|M2_STRONG, M3_INFRAVISION, CLR_WHITE);

    Monsters.AddMonster("air elemental", S_ELEMENTAL,
	Monsters.LVL(8, 36, 2, 30, 0), (G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_ENGL, AD_PHYS, 2,10),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(0, 0, 0, MS_SILENT, MZ_HUGE), MR_POISON|MR_STONE, 0,
	M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|M1_MINDLESS|M1_UNSOLID|M1_FLY,
	M2_STRONG|M2_NEUTER, 0, CLR_CYAN);

    Monsters.AddMonster("fire elemental", S_ELEMENTAL,
	Monsters.LVL(8, 12, 2, 30, 0), (G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_FIRE, 3, 6), Monsters.ATTK(AT_NONE, AD_FIRE, 0, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(0, 0, 0, MS_SILENT, MZ_HUGE), MR_FIRE|MR_POISON|MR_STONE, 0,
	M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|M1_MINDLESS|M1_UNSOLID|M1_FLY|M1_NOTAKE,
	M2_STRONG|M2_NEUTER, M3_INFRAVISIBLE, CLR_YELLOW);

    Monsters.AddMonster("earth elemental", S_ELEMENTAL,
	Monsters.LVL(8, 6, 2, 30, 0), (G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 4, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(2500, 0, 0, MS_SILENT, MZ_HUGE),
	MR_FIRE|MR_COLD|MR_POISON|MR_STONE, 0,
	M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|M1_MINDLESS|M1_BREATHLESS|
	  M1_WALLWALK|M1_THICK_HIDE,
	M2_STRONG|M2_NEUTER, 0, CLR_BROWN);

    Monsters.AddMonster("water elemental", S_ELEMENTAL,
	Monsters.LVL(8, 6, 2, 30, 0), (G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 5, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(2500, 0, 0, MS_SILENT, MZ_HUGE), MR_POISON|MR_STONE, 0,
	M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|M1_MINDLESS|M1_AMPHIBIOUS|M1_SWIM,
	M2_STRONG|M2_NEUTER, 0, CLR_BLUE);

/*
 * Fungi
 */
    Monsters.AddMonster("lichen", S_FUNGUS,
	Monsters.LVL(0, 1, 9, 0, 0), (G_GENO|4),
	Monsters.A(Monsters.ATTK(AT_TUCH, AD_STCK, 0, 0),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(20, 200, 0, MS_SILENT, MZ_SMALL), 0, 0,
	M1_BREATHLESS|M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|M1_MINDLESS|M1_NOTAKE,
	M2_HOSTILE|M2_NEUTER, 0, CLR_BRIGHT_GREEN);

    Monsters.AddMonster("brown mold", S_FUNGUS,
	Monsters.LVL(1, 0, 9, 0, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_NONE, AD_COLD, 0, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(50, 30, 0, MS_SILENT, MZ_SMALL),
	MR_COLD|MR_POISON, MR_COLD|MR_POISON,
	M1_BREATHLESS|M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|M1_MINDLESS|M1_NOTAKE,
	M2_HOSTILE|M2_NEUTER, 0, CLR_BROWN);

    Monsters.AddMonster("yellow mold", S_FUNGUS,
	Monsters.LVL(1, 0, 9, 0, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_NONE, AD_STUN, 0, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(50, 30, 0, MS_SILENT, MZ_SMALL), MR_POISON, MR_POISON,
	M1_BREATHLESS|M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|M1_MINDLESS|M1_POIS|M1_NOTAKE,
	M2_HOSTILE|M2_NEUTER, 0, CLR_YELLOW);

    Monsters.AddMonster("green mold", S_FUNGUS,
	Monsters.LVL(1, 0, 9, 0, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_NONE, AD_ACID, 0, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(50, 30, 0, MS_SILENT, MZ_SMALL), MR_ACID|MR_STONE, MR_STONE,
	M1_BREATHLESS|M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|M1_MINDLESS|M1_ACID|M1_NOTAKE,
	M2_HOSTILE|M2_NEUTER, 0, CLR_GREEN);

    Monsters.AddMonster("red mold", S_FUNGUS,
	Monsters.LVL(1, 0, 9, 0, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_NONE, AD_FIRE, 0, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(50, 30, 0, MS_SILENT, MZ_SMALL),
	MR_FIRE|MR_POISON, MR_FIRE|MR_POISON,
	M1_BREATHLESS|M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|M1_MINDLESS|M1_NOTAKE,
	M2_HOSTILE|M2_NEUTER, M3_INFRAVISIBLE, CLR_RED);

    Monsters.AddMonster("shrieker", S_FUNGUS,
	Monsters.LVL(3, 1, 7, 0, 0), (G_GENO|1),
	Monsters.A(NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(100, 100, 0, MS_SHRIEK, MZ_SMALL), MR_POISON, MR_POISON,
	M1_BREATHLESS|M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|M1_MINDLESS|M1_NOTAKE,
	M2_HOSTILE|M2_NEUTER, 0, CLR_MAGENTA);

    Monsters.AddMonster("violet fungus", S_FUNGUS,
	Monsters.LVL(3, 1, 7, 0, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_TUCH, AD_PHYS, 1, 4), Monsters.ATTK(AT_TUCH, AD_STCK, 0, 0),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(100, 100, 0, MS_SILENT, MZ_SMALL), MR_POISON, MR_POISON,
	M1_BREATHLESS|M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|M1_MINDLESS|M1_NOTAKE,
	M2_HOSTILE|M2_NEUTER, 0, CLR_MAGENTA);

/*
 * Gnomes
 */
    Monsters.AddMonster("gnome", S_GNOME,
	Monsters.LVL(1, 6, 10, 4, 0), (G_GENO|G_SGROUP|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(650, 100, 0, MS_ORC, MZ_SMALL), 0, 0,
	M1_HUMANOID|M1_OMNIVORE, M2_GNOME|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_BROWN);

    Monsters.AddMonster("gnome lord", S_GNOME,
	Monsters.LVL(3, 8, 10, 4, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(700, 120, 0, MS_ORC, MZ_SMALL), 0, 0,
	M1_HUMANOID|M1_OMNIVORE, M2_GNOME|M2_LORD|M2_MALE|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_BLUE);

    Monsters.AddMonster("gnomish wizard", S_GNOME,
	Monsters.LVL(3, 10, 4, 10, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_MAGC, AD_SPEL, 0, 0),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(700, 120, 0, MS_ORC, MZ_SMALL), 0, 0,
	M1_HUMANOID|M1_OMNIVORE, M2_GNOME|M2_MAGIC,
	M3_INFRAVISIBLE|M3_INFRAVISION, HI_ZAP);

    Monsters.AddMonster("gnome king", S_GNOME,
	Monsters.LVL(5, 10, 10, 20, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(750, 150, 0, MS_ORC, MZ_SMALL), 0, 0,
	M1_HUMANOID|M1_OMNIVORE, M2_GNOME|M2_PRINCE|M2_MALE|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, HI_LORD);

/*
 * giant Humanoids
 */
    Monsters.AddMonster("giant", S_GIANT,
	Monsters.LVL(6, 6, 0, 0, 2), (G_GENO|G_NOGEN|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2,10),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(2250, 750, 0, MS_BOAST, MZ_HUGE), 0, 0,
	M1_HUMANOID|M1_CARNIVORE,
	M2_GIANT|M2_STRONG|M2_ROCKTHROW|M2_NASTY|M2_COLLECT|M2_JEWELS,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_RED);

    Monsters.AddMonster("stone giant", S_GIANT,
	Monsters.LVL(6, 6, 0, 0, 2), (G_GENO|G_SGROUP|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2,10),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(2250, 750, 0, MS_BOAST, MZ_HUGE), 0, 0,
	M1_HUMANOID|M1_CARNIVORE,
	M2_GIANT|M2_STRONG|M2_ROCKTHROW|M2_NASTY|M2_COLLECT|M2_JEWELS,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_GRAY);

    Monsters.AddMonster("hill giant", S_GIANT,
	Monsters.LVL(8, 10, 6, 0, -2), (G_GENO|G_SGROUP|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(2200, 700, 0, MS_BOAST, MZ_HUGE), 0, 0,
	M1_HUMANOID|M1_CARNIVORE,
	M2_GIANT|M2_STRONG|M2_ROCKTHROW|M2_NASTY|M2_COLLECT|M2_JEWELS,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_CYAN);

    Monsters.AddMonster("fire giant", S_GIANT,
	Monsters.LVL(9, 12, 4, 5, 2), (G_GENO|G_SGROUP|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2,10),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(2250, 750, 0, MS_BOAST, MZ_HUGE), MR_FIRE, MR_FIRE,
	M1_HUMANOID|M1_CARNIVORE,
	M2_GIANT|M2_STRONG|M2_ROCKTHROW|M2_NASTY|M2_COLLECT|M2_JEWELS,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_YELLOW);

    Monsters.AddMonster("frost giant", S_GIANT,
	Monsters.LVL(10, 12, 3, 10, -3), (G_NOHELL|G_GENO|G_SGROUP|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2,12),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(2250, 750, 0, MS_BOAST, MZ_HUGE), MR_COLD, MR_COLD,
	M1_HUMANOID|M1_CARNIVORE,
	M2_GIANT|M2_STRONG|M2_ROCKTHROW|M2_NASTY|M2_COLLECT|M2_JEWELS,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_WHITE);

    Monsters.AddMonster("storm giant", S_GIANT,
	Monsters.LVL(16, 12, 3, 10, -3), (G_GENO|G_SGROUP|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 12),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(2250, 750, 0, MS_SILENT, MZ_HUGE), MR_ELEC, MR_ELEC,
	M1_HUMANOID|M1_CARNIVORE,
	M2_GIANT|M2_STRONG|M2_ROCKTHROW|M2_NASTY|M2_COLLECT|M2_JEWELS,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_BLUE);

    Monsters.AddMonster("ettin", S_GIANT,
	Monsters.LVL(10, 12, 3, 0, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 8), Monsters.ATTK(AT_WEAP, AD_PHYS, 3, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1700, 500, 0, MS_GRUNT, MZ_HUGE), 0, 0,
	M1_ANIMAL|M1_HUMANOID|M1_CARNIVORE,
	M2_HOSTILE|M2_STRONG|M2_NASTY|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_BROWN);

    Monsters.AddMonster("titan", S_GIANT,
	Monsters.LVL(16, 18, -3, 70, 9), (1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 8), Monsters.ATTK(AT_MAGC, AD_SPEL, 0, 0),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(2300, 900, 0, MS_SPELL, MZ_HUGE), 0, 0,
	M1_FLY|M1_HUMANOID|M1_OMNIVORE,
	M2_STRONG|M2_ROCKTHROW|M2_NASTY|M2_COLLECT|M2_MAGIC,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_MAGENTA);

    Monsters.AddMonster("minotaur", S_GIANT,
	Monsters.LVL(15, 15, 6, 0, 0), (G_GENO|G_NOGEN),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 3,10), Monsters.ATTK(AT_CLAW, AD_PHYS, 3,10),
	  Monsters.ATTK(AT_BUTT, AD_PHYS, 2, 8), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1500, 700, 0, MS_SILENT, MZ_LARGE), 0, 0,
	M1_ANIMAL|M1_HUMANOID|M1_CARNIVORE,
	M2_HOSTILE|M2_STRONG|M2_NASTY, M3_INFRAVISIBLE|M3_INFRAVISION,
	CLR_BROWN);

/* 'I' is a visual marker for all invisible monsters and must be unused */
/*
 * Jabberwock
 */
    Monsters.AddMonster("jabberwock", S_JABBERWOCK,
	Monsters.LVL(15, 12, -2, 50, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 2,10), Monsters.ATTK(AT_BITE, AD_PHYS, 2,10),
	  Monsters.ATTK(AT_CLAW, AD_PHYS, 2,10), Monsters.ATTK(AT_CLAW, AD_PHYS, 2,10),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(1300, 600, 0, MS_BURBLE, MZ_LARGE), 0, 0,
	M1_ANIMAL|M1_FLY|M1_CARNIVORE,
	M2_HOSTILE|M2_STRONG|M2_NASTY|M2_COLLECT, M3_INFRAVISIBLE, CLR_ORANGE);

#if 0	/* DEFERRED */
    Monsters.AddMonster("vorpal jabberwock", S_JABBERWOCK,
	Monsters.LVL(20, 12, -2, 50, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 3, 10), Monsters.ATTK(AT_BITE, AD_PHYS, 3, 10),
	  Monsters.ATTK(AT_CLAW, AD_PHYS, 3, 10), Monsters.ATTK(AT_CLAW, AD_PHYS, 3, 10),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(1300, 600, 0, MS_BURBLE, MZ_LARGE), 0, 0,
	M1_ANIMAL|M1_FLY|M1_CARNIVORE,
	M2_HOSTILE|M2_STRONG|M2_NASTY|M2_COLLECT, M3_INFRAVISIBLE, HI_LORD);

#endif
//#ifdef KOPS
/*
 * Kops
 */
    Monsters.AddMonster("Keystone Kop", S_KOP,
	Monsters.LVL(1, 6, 10, 10, 9), (G_GENO|G_LGROUP|G_NOGEN),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 200, 0, MS_ARREST, MZ_HUMAN), 0, 0, M1_HUMANOID,
	M2_HUMAN|M2_WANDER|M2_HOSTILE|M2_MALE|M2_COLLECT, M3_INFRAVISIBLE,
	CLR_BLUE);

    Monsters.AddMonster("Kop Sergeant", S_KOP,
	Monsters.LVL(2, 8, 10, 10, 10), (G_GENO|G_SGROUP|G_NOGEN),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 200, 0, MS_ARREST, MZ_HUMAN), 0, 0, M1_HUMANOID,
	M2_HUMAN|M2_WANDER|M2_HOSTILE|M2_STRONG|M2_MALE|M2_COLLECT,
	M3_INFRAVISIBLE, CLR_BLUE);

    Monsters.AddMonster("Kop Lieutenant", S_KOP,
	Monsters.LVL(3, 10, 10, 20, 11), (G_GENO|G_NOGEN),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 200, 0, MS_ARREST, MZ_HUMAN), 0, 0, M1_HUMANOID,
	M2_HUMAN|M2_WANDER|M2_HOSTILE|M2_STRONG|M2_MALE|M2_COLLECT,
	M3_INFRAVISIBLE, CLR_CYAN);

    Monsters.AddMonster("Kop Kaptain", S_KOP,
	Monsters.LVL(4, 12, 10, 20, 12), (G_GENO|G_NOGEN),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 200, 0, MS_ARREST, MZ_HUMAN), 0, 0, M1_HUMANOID,
	M2_HUMAN|M2_WANDER|M2_HOSTILE|M2_STRONG|M2_MALE|M2_COLLECT,
	M3_INFRAVISIBLE, HI_LORD);

//#endif
/*
 * Liches
 */
    Monsters.AddMonster("lich", S_LICH,
	Monsters.LVL(11, 6, 0, 30, -9), (G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_TUCH, AD_COLD, 1,10), Monsters.ATTK(AT_MAGC, AD_SPEL, 0, 0),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1200, 100, 0, MS_MUMBLE, MZ_HUMAN),
	MR_COLD|MR_SLEEP|MR_POISON, MR_COLD,
	M1_BREATHLESS|M1_HUMANOID|M1_POIS|M1_REGEN,
	M2_UNDEAD|M2_HOSTILE|M2_MAGIC, M3_INFRAVISION, CLR_BROWN);

    Monsters.AddMonster("demilich", S_LICH,
	Monsters.LVL(14, 9, -2, 60, -12), (G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_TUCH, AD_COLD, 3, 4), Monsters.ATTK(AT_MAGC, AD_SPEL, 0, 0),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1200, 100, 0, MS_MUMBLE, MZ_HUMAN),
	MR_COLD|MR_SLEEP|MR_POISON, MR_COLD,
	M1_BREATHLESS|M1_HUMANOID|M1_POIS|M1_REGEN,
	M2_UNDEAD|M2_HOSTILE|M2_MAGIC, M3_INFRAVISION, CLR_RED);

    Monsters.AddMonster("master lich", S_LICH,
	Monsters.LVL(17, 9, -4, 90, -15), (G_HELL|G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_TUCH, AD_COLD, 3, 6), Monsters.ATTK(AT_MAGC, AD_SPEL, 0, 0),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1200, 100, 0, MS_MUMBLE, MZ_HUMAN),
	MR_FIRE|MR_COLD|MR_SLEEP|MR_POISON, MR_FIRE|MR_COLD,
	M1_BREATHLESS|M1_HUMANOID|M1_POIS|M1_REGEN,
	M2_UNDEAD|M2_HOSTILE|M2_MAGIC, M3_WANTSBOOK|M3_INFRAVISION, HI_LORD);

    Monsters.AddMonster("arch-lich", S_LICH,
	Monsters.LVL(25, 9, -6, 90, -15), (G_HELL|G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_TUCH, AD_COLD, 5, 6), Monsters.ATTK(AT_MAGC, AD_SPEL, 0, 0),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1200, 100, 0, MS_MUMBLE, MZ_HUMAN),
	MR_FIRE|MR_COLD|MR_SLEEP|MR_ELEC|MR_POISON, MR_FIRE|MR_COLD,
	M1_BREATHLESS|M1_HUMANOID|M1_POIS|M1_REGEN,
	M2_UNDEAD|M2_HOSTILE|M2_MAGIC, M3_WANTSBOOK|M3_INFRAVISION, HI_LORD);

/*
 * Mummies
 */
    Monsters.AddMonster("kobold mummy", S_MUMMY,
	Monsters.LVL(3, 8, 6, 20, -2), (G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(400, 50, 0, MS_SILENT, MZ_SMALL), MR_COLD|MR_SLEEP|MR_POISON, 0,
	M1_BREATHLESS|M1_MINDLESS|M1_HUMANOID|M1_POIS,
	M2_UNDEAD|M2_HOSTILE, M3_INFRAVISION, CLR_BROWN);

    Monsters.AddMonster("gnome mummy", S_MUMMY,
	Monsters.LVL(4, 10, 6, 20, -3), (G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(650, 50, 0, MS_SILENT, MZ_SMALL), MR_COLD|MR_SLEEP|MR_POISON, 0,
	M1_BREATHLESS|M1_MINDLESS|M1_HUMANOID|M1_POIS,
	M2_UNDEAD|M2_HOSTILE|M2_GNOME, M3_INFRAVISION, CLR_RED);

    Monsters.AddMonster("orc mummy", S_MUMMY,
	Monsters.LVL(5, 10, 5, 20, -4), (G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(850, 75, 0, MS_SILENT, MZ_HUMAN), MR_COLD|MR_SLEEP|MR_POISON, 0,
	M1_BREATHLESS|M1_MINDLESS|M1_HUMANOID|M1_POIS,
	M2_UNDEAD|M2_HOSTILE|M2_ORC|M2_GREEDY|M2_JEWELS, M3_INFRAVISION,
	CLR_GRAY);

    Monsters.AddMonster("dwarf mummy", S_MUMMY,
	Monsters.LVL(5, 10, 5, 20, -4), (G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(900, 150, 0, MS_SILENT, MZ_HUMAN), MR_COLD|MR_SLEEP|MR_POISON, 0,
	M1_BREATHLESS|M1_MINDLESS|M1_HUMANOID|M1_POIS,
	M2_UNDEAD|M2_HOSTILE|M2_DWARF|M2_GREEDY|M2_JEWELS, M3_INFRAVISION,
	CLR_RED);

    Monsters.AddMonster("elf mummy", S_MUMMY,
	Monsters.LVL(6, 12, 4, 30, -5), (G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 2, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_ELF, 175, 0, MS_SILENT, MZ_HUMAN),
	MR_COLD|MR_SLEEP|MR_POISON, 0,
	M1_BREATHLESS|M1_MINDLESS|M1_HUMANOID|M1_POIS,
	M2_UNDEAD|M2_HOSTILE|M2_ELF, M3_INFRAVISION, CLR_GREEN);

    Monsters.AddMonster("human mummy", S_MUMMY,
	Monsters.LVL(6, 12, 4, 30, -5), (G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 2, 4), Monsters.ATTK(AT_CLAW, AD_PHYS, 2, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 200, 0, MS_SILENT, MZ_HUMAN),
	MR_COLD|MR_SLEEP|MR_POISON, 0,
	M1_BREATHLESS|M1_MINDLESS|M1_HUMANOID|M1_POIS,
	M2_UNDEAD|M2_HOSTILE, M3_INFRAVISION, CLR_GRAY);

    Monsters.AddMonster("ettin mummy", S_MUMMY,
	Monsters.LVL(7, 12, 4, 30, -6), (G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 2, 6), Monsters.ATTK(AT_CLAW, AD_PHYS, 2, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1700, 250, 0, MS_SILENT, MZ_HUGE),
	MR_COLD|MR_SLEEP|MR_POISON, 0,
	M1_BREATHLESS|M1_MINDLESS|M1_HUMANOID|M1_POIS,
	M2_UNDEAD|M2_HOSTILE|M2_STRONG, M3_INFRAVISION, CLR_BLUE);

    Monsters.AddMonster("giant mummy", S_MUMMY,
	Monsters.LVL(8, 14, 3, 30, -7), (G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 3, 4), Monsters.ATTK(AT_CLAW, AD_PHYS, 3, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(2050, 375, 0, MS_SILENT, MZ_HUGE),
	MR_COLD|MR_SLEEP|MR_POISON, 0,
	M1_BREATHLESS|M1_MINDLESS|M1_HUMANOID|M1_POIS,
	M2_UNDEAD|M2_HOSTILE|M2_GIANT|M2_STRONG|M2_JEWELS, M3_INFRAVISION,
	CLR_CYAN);

/*
 * Nagas
 */
    Monsters.AddMonster("red naga hatchling", S_NAGA,
	Monsters.LVL(3, 10, 6, 0, 0), G_GENO,
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(500, 100, 0, MS_MUMBLE, MZ_LARGE),
	MR_FIRE|MR_POISON, MR_FIRE|MR_POISON,
	M1_NOLIMBS|M1_SLITHY|M1_THICK_HIDE|M1_NOTAKE, M2_STRONG,
	M3_INFRAVISIBLE, CLR_RED);

    Monsters.AddMonster("black naga hatchling", S_NAGA,
	Monsters.LVL(3, 10, 6, 0, 0), G_GENO,
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(500, 100, 0, MS_MUMBLE, MZ_LARGE),
	MR_POISON|MR_ACID|MR_STONE, MR_POISON|MR_STONE,
	M1_NOLIMBS|M1_SLITHY|M1_THICK_HIDE|M1_ACID|M1_NOTAKE,
	M2_STRONG, 0, CLR_BLACK);

    Monsters.AddMonster("golden naga hatchling", S_NAGA,
	Monsters.LVL(3, 10, 6, 0, 0), G_GENO,
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(500, 100, 0, MS_MUMBLE, MZ_LARGE), MR_POISON, MR_POISON,
	M1_NOLIMBS|M1_SLITHY|M1_THICK_HIDE|M1_NOTAKE, M2_STRONG, 0, HI_GOLD);

    Monsters.AddMonster("guardian naga hatchling", S_NAGA,
	Monsters.LVL(3, 10, 6, 0, 0), G_GENO,
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(500, 100, 0, MS_MUMBLE, MZ_LARGE), MR_POISON, MR_POISON,
	M1_NOLIMBS|M1_SLITHY|M1_THICK_HIDE|M1_NOTAKE, M2_STRONG, 0, CLR_GREEN);

    Monsters.AddMonster("red naga", S_NAGA,
	Monsters.LVL(6, 12, 4, 0, -4), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 2, 4), Monsters.ATTK(AT_BREA, AD_FIRE, 2, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(2600, 400, 0, MS_MUMBLE, MZ_HUGE),
	MR_FIRE|MR_POISON, MR_FIRE|MR_POISON,
	M1_NOLIMBS|M1_SLITHY|M1_THICK_HIDE|M1_OVIPAROUS|M1_NOTAKE,
	M2_STRONG, M3_INFRAVISIBLE, CLR_RED);

    Monsters.AddMonster("black naga", S_NAGA,
	Monsters.LVL(8, 14, 2, 10, 4), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 2, 6), Monsters.ATTK(AT_SPIT, AD_ACID, 0, 0),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(2600, 400, 0, MS_MUMBLE, MZ_HUGE),
	MR_POISON|MR_ACID|MR_STONE, MR_POISON|MR_STONE,
	M1_NOLIMBS|M1_SLITHY|M1_THICK_HIDE|M1_OVIPAROUS|M1_ACID|M1_NOTAKE,
	M2_STRONG, 0, CLR_BLACK);

    Monsters.AddMonster("golden naga", S_NAGA,
	Monsters.LVL(10, 14, 2, 70, 5), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 2, 6), Monsters.ATTK(AT_MAGC, AD_SPEL, 4, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(2600, 400, 0, MS_MUMBLE, MZ_HUGE), MR_POISON, MR_POISON,
	M1_NOLIMBS|M1_SLITHY|M1_THICK_HIDE|M1_OVIPAROUS|M1_NOTAKE,
	M2_STRONG, 0, HI_GOLD);

    Monsters.AddMonster("guardian naga", S_NAGA,
	Monsters.LVL(12, 16, 0, 50, 7), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PLYS, 1, 6), Monsters.ATTK(AT_SPIT, AD_DRST, 1, 6),
	  Monsters.ATTK(AT_HUGS, AD_PHYS, 2, 4), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(2600, 400, 0, MS_MUMBLE, MZ_HUGE), MR_POISON, MR_POISON,
	M1_NOLIMBS|M1_SLITHY|M1_THICK_HIDE|M1_OVIPAROUS|M1_POIS|M1_NOTAKE,
	M2_STRONG, 0, CLR_GREEN);

/*
 * Ogres
 */
    Monsters.AddMonster("ogre", S_OGRE,
	Monsters.LVL(5, 10, 5, 0, -3), (G_SGROUP|G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 5),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1600, 500, 0, MS_GRUNT, MZ_LARGE), 0, 0, M1_HUMANOID|M1_CARNIVORE,
	M2_STRONG|M2_GREEDY|M2_JEWELS|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_BROWN);

    Monsters.AddMonster("ogre lord", S_OGRE,
	Monsters.LVL(7, 12, 3, 30, -5), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1700, 700, 0, MS_GRUNT, MZ_LARGE), 0, 0, M1_HUMANOID|M1_CARNIVORE,
	M2_STRONG|M2_LORD|M2_MALE|M2_GREEDY|M2_JEWELS|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_RED);

    Monsters.AddMonster("ogre king", S_OGRE,
	Monsters.LVL(9, 14, 4, 60, -7), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 3, 5),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1700, 750, 0, MS_GRUNT, MZ_LARGE), 0, 0, M1_HUMANOID|M1_CARNIVORE,
	M2_STRONG|M2_PRINCE|M2_MALE|M2_GREEDY|M2_JEWELS|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, HI_LORD);

/*
 * Puddings
 */
    Monsters.AddMonster("gray ooze", S_PUDDING,
	Monsters.LVL(3, 1, 8, 0, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_RUST, 2, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(500, 250, 0, MS_SILENT, MZ_MEDIUM),
	MR_FIRE|MR_COLD|MR_POISON|MR_ACID|MR_STONE, MR_FIRE|MR_COLD|MR_POISON,
	M1_BREATHLESS|M1_AMORPHOUS|M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|
	  M1_MINDLESS|M1_OMNIVORE|M1_ACID,
	M2_HOSTILE|M2_NEUTER, 0, CLR_GRAY);

    Monsters.AddMonster("brown pudding", S_PUDDING,
	Monsters.LVL(5, 3, 8, 0, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_DCAY, 0, 0),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(500, 250, 0, MS_SILENT, MZ_MEDIUM),
	MR_COLD|MR_ELEC|MR_POISON|MR_ACID|MR_STONE, MR_COLD|MR_ELEC|MR_POISON,
	M1_BREATHLESS|M1_AMORPHOUS|M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|
	  M1_MINDLESS|M1_OMNIVORE|M1_ACID,
	M2_HOSTILE|M2_NEUTER, 0, CLR_BROWN);

    Monsters.AddMonster("black pudding", S_PUDDING,
	Monsters.LVL(10, 6, 6, 0, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_RUST, 3, 8), Monsters.ATTK(AT_NONE, AD_RUST, 0, 0),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(900, 250, 0, MS_SILENT, MZ_LARGE),
	MR_COLD|MR_ELEC|MR_POISON|MR_ACID|MR_STONE, MR_COLD|MR_ELEC|MR_POISON,
	M1_BREATHLESS|M1_AMORPHOUS|M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|
	  M1_MINDLESS|M1_OMNIVORE|M1_ACID,
	M2_HOSTILE|M2_NEUTER, 0, CLR_BLACK);

    Monsters.AddMonster("green slime", S_PUDDING,
	Monsters.LVL(6, 6, 6, 0, 0), (G_HELL|G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_TUCH, AD_SLIM, 1, 4), Monsters.ATTK(AT_NONE, AD_SLIM, 0, 0),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(400, 150, 0, MS_SILENT, MZ_LARGE),
	MR_COLD|MR_ELEC|MR_POISON|MR_ACID|MR_STONE, 0,
	M1_BREATHLESS|M1_AMORPHOUS|M1_NOEYES|M1_NOLIMBS|M1_NOHEAD|
	  M1_MINDLESS|M1_OMNIVORE|M1_ACID|M1_POIS,
	M2_HOSTILE|M2_NEUTER, 0, CLR_GREEN);

/*
 * Quantum mechanics
 */
    Monsters.AddMonster("quantum mechanic", S_QUANTMECH,
	Monsters.LVL(7, 12, 3, 10, 0), (G_GENO|3),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_TLPT, 1, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 20, 0, MS_HUMANOID, MZ_HUMAN), MR_POISON, 0,
	M1_HUMANOID|M1_OMNIVORE|M1_POIS|M1_TPORT, M2_HOSTILE, M3_INFRAVISIBLE,
	CLR_CYAN);

/*
 * Rust monster or disenchanter
 */
    Monsters.AddMonster("rust monster", S_RUSTMONST,
	Monsters.LVL(5, 18, 2, 0, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_TUCH, AD_RUST, 0, 0), Monsters.ATTK(AT_TUCH, AD_RUST, 0, 0),
	  Monsters.ATTK(AT_NONE, AD_RUST, 0, 0), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1000, 250, 0, MS_SILENT, MZ_MEDIUM), 0, 0,
	M1_SWIM|M1_ANIMAL|M1_NOHANDS|M1_METALLIVORE, M2_HOSTILE,
	M3_INFRAVISIBLE, CLR_BROWN);

    Monsters.AddMonster("disenchanter", S_RUSTMONST,
	Monsters.LVL(12, 12, -10, 0, -3), (G_HELL|G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_ENCH, 4, 4), Monsters.ATTK(AT_NONE, AD_ENCH, 0, 0),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(750, 200, 0, MS_GROWL, MZ_LARGE), 0, 0,
	M1_ANIMAL|M1_CARNIVORE, M2_HOSTILE,
	M3_INFRAVISIBLE, CLR_BLUE);

/*
 * Snakes
 */
    Monsters.AddMonster("garter snake", S_SNAKE,
	Monsters.LVL(1, 8, 8, 0, 0), (G_LGROUP|G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 2),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(50, 60, 0, MS_HISS, MZ_TINY), 0, 0,
	M1_SWIM|M1_CONCEAL|M1_NOLIMBS|M1_ANIMAL|M1_SLITHY|M1_OVIPAROUS|
	  M1_CARNIVORE|M1_NOTAKE,
	0, 0, CLR_GREEN);

    Monsters.AddMonster("snake", S_SNAKE,
	Monsters.LVL(4, 15, 3, 0, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_DRST, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(100, 80, 0, MS_HISS, MZ_SMALL), MR_POISON, MR_POISON,
	M1_SWIM|M1_CONCEAL|M1_NOLIMBS|M1_ANIMAL|M1_SLITHY|M1_POIS|
	  M1_OVIPAROUS|M1_CARNIVORE|M1_NOTAKE,
	M2_HOSTILE, 0, CLR_BROWN);

    Monsters.AddMonster("water moccasin", S_SNAKE,
	Monsters.LVL(4, 15, 3, 0, 0), (G_GENO|G_NOGEN|G_LGROUP),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_DRST, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(150, 80, 0, MS_HISS, MZ_SMALL), MR_POISON, MR_POISON,
	M1_SWIM|M1_CONCEAL|M1_NOLIMBS|M1_ANIMAL|M1_SLITHY|M1_POIS|
	  M1_CARNIVORE|M1_OVIPAROUS|M1_NOTAKE,
	M2_HOSTILE, 0, CLR_RED);

    Monsters.AddMonster("pit viper", S_SNAKE,
	Monsters.LVL(6, 15, 2, 0, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_DRST, 1, 4), Monsters.ATTK(AT_BITE, AD_DRST, 1, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(100, 60, 0, MS_HISS, MZ_MEDIUM),
	MR_POISON, MR_POISON,
	M1_SWIM|M1_CONCEAL|M1_NOLIMBS|M1_ANIMAL|M1_SLITHY|M1_POIS|
	  M1_CARNIVORE|M1_OVIPAROUS|M1_NOTAKE,
	M2_HOSTILE, M3_INFRAVISION, CLR_BLUE);

    Monsters.AddMonster("python", S_SNAKE,
	Monsters.LVL(6, 3, 5, 0, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 4), Monsters.ATTK(AT_TUCH, AD_PHYS, 0, 0),
	  Monsters.ATTK(AT_HUGS, AD_WRAP, 1, 4), Monsters.ATTK(AT_HUGS, AD_PHYS, 2, 4),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(250, 100, 0, MS_HISS, MZ_LARGE), 0, 0,
	M1_SWIM|M1_NOLIMBS|M1_ANIMAL|M1_SLITHY|M1_CARNIVORE|M1_OVIPAROUS|M1_NOTAKE,
	M2_HOSTILE|M2_STRONG, 0, CLR_MAGENTA);

    Monsters.AddMonster("cobra", S_SNAKE,
	Monsters.LVL(6, 18, 2, 0, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_DRST, 2, 4), Monsters.ATTK(AT_SPIT, AD_BLND, 0, 0),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(250, 100, 0, MS_HISS, MZ_MEDIUM),
	MR_POISON, MR_POISON,
	M1_SWIM|M1_CONCEAL|M1_NOLIMBS|M1_ANIMAL|M1_SLITHY|M1_POIS|
	  M1_CARNIVORE|M1_OVIPAROUS|M1_NOTAKE,
	M2_HOSTILE, 0, CLR_BLUE);

/*
 * Trolls
 */
    Monsters.AddMonster("troll", S_TROLL,
	Monsters.LVL(7, 12, 4, 0, -3), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 4, 2), Monsters.ATTK(AT_WEAP, AD_PHYS, 4, 2),
	  Monsters.ATTK(AT_BITE, AD_PHYS, 2, 6), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(800, 350, 0, MS_GRUNT, MZ_LARGE), 0, 0,
	M1_HUMANOID|M1_REGEN|M1_CARNIVORE,
	M2_STRONG|M2_STALK|M2_HOSTILE, M3_INFRAVISIBLE|M3_INFRAVISION,
	CLR_BROWN);

    Monsters.AddMonster("ice troll", S_TROLL,
	Monsters.LVL(9, 10, 2, 20, -3), (G_NOHELL|G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_COLD, 2, 6), Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 6),
	  Monsters.ATTK(AT_BITE, AD_PHYS, 2, 6), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1000, 300, 0, MS_GRUNT, MZ_LARGE), MR_COLD, MR_COLD,
	M1_HUMANOID|M1_REGEN|M1_CARNIVORE,
	M2_STRONG|M2_STALK|M2_HOSTILE, M3_INFRAVISIBLE|M3_INFRAVISION,
	CLR_WHITE);

    Monsters.AddMonster("rock troll", S_TROLL,
	Monsters.LVL(9, 12, 0, 0, -3), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 2, 8), Monsters.ATTK(AT_WEAP, AD_PHYS, 3, 6),
	  Monsters.ATTK(AT_BITE, AD_PHYS, 2, 6), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1200, 300, 0, MS_GRUNT, MZ_LARGE), 0, 0,
	M1_HUMANOID|M1_REGEN|M1_CARNIVORE,
	M2_STRONG|M2_STALK|M2_HOSTILE|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_CYAN);

    Monsters.AddMonster("water troll", S_TROLL,
	Monsters.LVL(11, 14, 4, 40, -3), (G_NOGEN|G_GENO),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 2, 8), Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 8),
	  Monsters.ATTK(AT_BITE, AD_PHYS, 2, 6), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1200, 350, 0, MS_GRUNT, MZ_LARGE), 0, 0,
	M1_HUMANOID|M1_REGEN|M1_CARNIVORE|M1_SWIM,
	M2_STRONG|M2_STALK|M2_HOSTILE, M3_INFRAVISIBLE|M3_INFRAVISION,
	CLR_BLUE);

    Monsters.AddMonster("Olog-hai", S_TROLL,
	Monsters.LVL(13, 12, -4, 0, -7), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 2, 8), Monsters.ATTK(AT_WEAP, AD_PHYS, 3, 6),
	  Monsters.ATTK(AT_BITE, AD_PHYS, 2, 6), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1500, 400, 0, MS_GRUNT, MZ_LARGE), 0, 0,
	M1_HUMANOID|M1_REGEN|M1_CARNIVORE,
	M2_STRONG|M2_STALK|M2_HOSTILE|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, HI_LORD);

/*
 * Umber hulk
 */
    Monsters.AddMonster("umber hulk", S_UMBER,
	Monsters.LVL(9, 6, 2, 25, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 3, 4), Monsters.ATTK(AT_CLAW, AD_PHYS, 3, 4),
	  Monsters.ATTK(AT_BITE, AD_PHYS, 2, 5), Monsters.ATTK(AT_GAZE, AD_CONF, 0, 0),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(1200, 500, 0, MS_SILENT, MZ_LARGE), 0, 0,
	M1_TUNNEL|M1_CARNIVORE, M2_STRONG, M3_INFRAVISIBLE, CLR_BROWN);

/*
 * Vampires
 */
    Monsters.AddMonster("vampire", S_VAMPIRE,
	Monsters.LVL(10, 12, 1, 25, -8), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 6), Monsters.ATTK(AT_BITE, AD_DRLI, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_VAMPIRE, MZ_HUMAN), MR_SLEEP|MR_POISON, 0,
	M1_FLY|M1_BREATHLESS|M1_HUMANOID|M1_POIS|M1_REGEN,
	M2_UNDEAD|M2_STALK|M2_HOSTILE|M2_STRONG|M2_NASTY, M3_INFRAVISIBLE,
	CLR_RED);

    Monsters.AddMonster("vampire lord", S_VAMPIRE,
	Monsters.LVL(12, 14, 0, 50, -9), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 8), Monsters.ATTK(AT_BITE, AD_DRLI, 1, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_VAMPIRE, MZ_HUMAN), MR_SLEEP|MR_POISON, 0,
	M1_FLY|M1_BREATHLESS|M1_HUMANOID|M1_POIS|M1_REGEN,
	M2_UNDEAD|M2_STALK|M2_HOSTILE|M2_STRONG|M2_NASTY|M2_LORD|M2_MALE,
	M3_INFRAVISIBLE, CLR_BLUE);

#if 0	/* DEFERRED */
    Monsters.AddMonster("vampire mage", S_VAMPIRE,
	Monsters.LVL(20, 14, -4, 50, -9), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_DRLI, 2, 8), Monsters.ATTK(AT_BITE, AD_DRLI, 1, 8),
	  Monsters.ATTK(AT_MAGC, AD_SPEL, 2, 6), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_VAMPIRE, MZ_HUMAN), MR_SLEEP|MR_POISON, 0,
	M1_FLY|M1_BREATHLESS|M1_HUMANOID|M1_POIS|M1_REGEN,
	M2_UNDEAD|M2_STALK|M2_HOSTILE|M2_STRONG|M2_NASTY|M2_LORD|M2_MALE|
	M2_MAGIC, M3_INFRAVISIBLE, HI_ZAP);

#endif
    Monsters.AddMonster("Vlad the Impaler", S_VAMPIRE,
	Monsters.LVL(14, 18, -3, 80, -10), (G_NOGEN|G_NOCORPSE|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 10), Monsters.ATTK(AT_BITE, AD_DRLI, 1, 10),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_VAMPIRE, MZ_HUMAN), MR_SLEEP|MR_POISON, 0,
	M1_FLY|M1_BREATHLESS|M1_HUMANOID|M1_POIS|M1_REGEN,
	M2_NOPOLY|M2_UNDEAD|M2_STALK|M2_HOSTILE|M2_PNAME|M2_STRONG|
	  M2_NASTY|M2_PRINCE|M2_MALE,
	M3_WAITFORU|M3_WANTSBOOK|M3_INFRAVISIBLE, HI_LORD);

/*
 * Wraiths
 */
    Monsters.AddMonster("barrow wight", S_WRAITH,
	Monsters.LVL(3, 12, 5, 5, -3), (G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4), Monsters.ATTK(AT_MAGC, AD_SPEL, 0, 0),
	  Monsters.ATTK(AT_WEAP, AD_DRLI, 0, 0), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1200, 0, 0, MS_SPELL, MZ_HUMAN), MR_COLD|MR_SLEEP|MR_POISON, 0,
	M1_BREATHLESS|M1_HUMANOID,
	M2_UNDEAD|M2_STALK|M2_HOSTILE|M2_COLLECT, 0, CLR_GRAY);

    Monsters.AddMonster("wraith", S_WRAITH,
	Monsters.LVL(6, 12, 4, 15, -6), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_TUCH, AD_DRLI, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(0, 0, 0, MS_SILENT, MZ_HUMAN),
	MR_COLD|MR_SLEEP|MR_POISON|MR_STONE, 0,
	M1_BREATHLESS|M1_FLY|M1_HUMANOID|M1_UNSOLID,
	M2_UNDEAD|M2_STALK|M2_HOSTILE, 0, CLR_BLACK);

    Monsters.AddMonster("Nazgul", S_WRAITH,
	Monsters.LVL(13, 12, 0, 25, -17), (G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_DRLI, 1, 4), Monsters.ATTK(AT_BREA, AD_SLEE, 2,25),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 0, 0, MS_SPELL, MZ_HUMAN),
	MR_COLD|MR_SLEEP|MR_POISON, 0, M1_BREATHLESS|M1_HUMANOID,
	M2_UNDEAD|M2_STALK|M2_STRONG|M2_HOSTILE|M2_MALE|M2_COLLECT,
	0, HI_LORD);

/*
 * Xorn
 */
    Monsters.AddMonster("xorn", S_XORN,
	Monsters.LVL(8, 9,-2, 20, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 3), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 3),
	  Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 3), Monsters.ATTK(AT_BITE, AD_PHYS, 4, 6),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(1200, 700, 0, MS_SILENT, MZ_MEDIUM),
	MR_FIRE|MR_COLD|MR_STONE, MR_STONE,
	M1_BREATHLESS|M1_WALLWALK|M1_THICK_HIDE|M1_METALLIVORE,
	M2_HOSTILE|M2_STRONG, 0, CLR_BROWN);

/*
 * Yeti, apes and other large beasts
 */
    Monsters.AddMonster("monkey", S_YETI,
	Monsters.LVL(2, 12, 6, 0, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_SITM, 0, 0), Monsters.ATTK(AT_BITE, AD_PHYS, 1, 3),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(100, 50, 0, MS_GROWL, MZ_SMALL), 0, 0,
	M1_ANIMAL|M1_HUMANOID|M1_CARNIVORE, 0, M3_INFRAVISIBLE, CLR_GRAY);

    Monsters.AddMonster("ape", S_YETI,
	Monsters.LVL(4, 12, 6, 0, 0), (G_GENO|G_SGROUP|2),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 3), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 3),
	  Monsters.ATTK(AT_BITE, AD_PHYS, 1, 6), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1100, 500, 0, MS_GROWL, MZ_LARGE), 0, 0,
	M1_ANIMAL|M1_HUMANOID|M1_CARNIVORE, M2_STRONG, M3_INFRAVISIBLE,
	CLR_BROWN);

    Monsters.AddMonster("owlbear", S_YETI,
	Monsters.LVL(5, 12, 5, 0, 0), (G_GENO|3),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 6), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 6),
	  Monsters.ATTK(AT_HUGS, AD_PHYS, 2, 8), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1700, 700, 0, MS_ROAR, MZ_LARGE), 0, 0,
	M1_ANIMAL|M1_HUMANOID|M1_CARNIVORE,
	M2_HOSTILE|M2_STRONG|M2_NASTY, M3_INFRAVISIBLE, CLR_BROWN);

    Monsters.AddMonster("yeti", S_YETI,
	Monsters.LVL(5, 15, 6, 0, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 6), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 6),
	  Monsters.ATTK(AT_BITE, AD_PHYS, 1, 4), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1600, 700, 0, MS_GROWL, MZ_LARGE), MR_COLD, MR_COLD,
	M1_ANIMAL|M1_HUMANOID|M1_CARNIVORE, M2_HOSTILE|M2_STRONG,
	M3_INFRAVISIBLE, CLR_WHITE);

    Monsters.AddMonster("carnivorous ape", S_YETI,
	Monsters.LVL(6, 12, 6, 0, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4),
	  Monsters.ATTK(AT_HUGS, AD_PHYS, 1, 8), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1250, 550, 0, MS_GROWL, MZ_LARGE), 0, 0,
	M1_ANIMAL|M1_HUMANOID|M1_CARNIVORE, M2_HOSTILE|M2_STRONG,
	M3_INFRAVISIBLE, CLR_BLACK);

    Monsters.AddMonster("sasquatch", S_YETI,
	Monsters.LVL(7, 15, 6, 0, 2), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 6), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 6),
	  Monsters.ATTK(AT_KICK, AD_PHYS, 1, 8), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1550, 750, 0, MS_GROWL, MZ_LARGE), 0, 0,
	M1_ANIMAL|M1_HUMANOID|M1_SEE_INVIS|M1_OMNIVORE, M2_STRONG,
	M3_INFRAVISIBLE, CLR_GRAY);

/*
 * Zombies
 */
    Monsters.AddMonster("kobold zombie", S_ZOMBIE,
	Monsters.LVL(0, 6, 10, 0, -2), (G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(400, 50, 0, MS_SILENT, MZ_SMALL), MR_COLD|MR_SLEEP|MR_POISON, 0,
	M1_BREATHLESS|M1_MINDLESS|M1_HUMANOID|M1_POIS,
	M2_UNDEAD|M2_STALK|M2_HOSTILE, M3_INFRAVISION, CLR_BROWN);

    Monsters.AddMonster("gnome zombie", S_ZOMBIE,
	Monsters.LVL(1, 6, 10, 0, -2), (G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 5),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(650, 50, 0, MS_SILENT, MZ_SMALL), MR_COLD|MR_SLEEP|MR_POISON, 0,
	M1_BREATHLESS|M1_MINDLESS|M1_HUMANOID|M1_POIS,
	M2_UNDEAD|M2_STALK|M2_HOSTILE|M2_GNOME, M3_INFRAVISION, CLR_BROWN);

    Monsters.AddMonster("orc zombie", S_ZOMBIE,
	Monsters.LVL(2, 6, 9, 0, -3), (G_GENO|G_SGROUP|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(850, 75, 0, MS_SILENT, MZ_HUMAN), MR_COLD|MR_SLEEP|MR_POISON, 0,
	M1_BREATHLESS|M1_MINDLESS|M1_HUMANOID|M1_POIS,
	M2_UNDEAD|M2_STALK|M2_HOSTILE|M2_ORC, M3_INFRAVISION, CLR_GRAY);

    Monsters.AddMonster("dwarf zombie", S_ZOMBIE,
	Monsters.LVL(2, 6, 9, 0, -3), (G_GENO|G_SGROUP|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(900, 150, 0, MS_SILENT, MZ_HUMAN), MR_COLD|MR_SLEEP|MR_POISON, 0,
	M1_BREATHLESS|M1_MINDLESS|M1_HUMANOID|M1_POIS,
	M2_UNDEAD|M2_STALK|M2_HOSTILE|M2_DWARF, M3_INFRAVISION, CLR_RED);

    Monsters.AddMonster("elf zombie", S_ZOMBIE,
	Monsters.LVL(3, 6, 9, 0, -3), (G_GENO|G_SGROUP|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 7),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_ELF, 175, 0, MS_SILENT, MZ_HUMAN),
	MR_COLD|MR_SLEEP|MR_POISON, 0,
	M1_BREATHLESS|M1_MINDLESS|M1_HUMANOID,
	M2_UNDEAD|M2_STALK|M2_HOSTILE|M2_ELF, M3_INFRAVISION, CLR_GREEN);

    Monsters.AddMonster("human zombie", S_ZOMBIE,
	Monsters.LVL(4, 6, 8, 0, -3), (G_GENO|G_SGROUP|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 200, 0, MS_SILENT, MZ_HUMAN),
	MR_COLD|MR_SLEEP|MR_POISON, 0,
	M1_BREATHLESS|M1_MINDLESS|M1_HUMANOID,
	M2_UNDEAD|M2_STALK|M2_HOSTILE, M3_INFRAVISION, HI_DOMESTIC);

    Monsters.AddMonster("ettin zombie", S_ZOMBIE,
	Monsters.LVL(6, 8, 6, 0, -4), (G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1,10), Monsters.ATTK(AT_CLAW, AD_PHYS, 1,10),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1700, 250, 0, MS_SILENT, MZ_HUGE),
	MR_COLD|MR_SLEEP|MR_POISON, 0,
	M1_BREATHLESS|M1_MINDLESS|M1_HUMANOID,
	M2_UNDEAD|M2_STALK|M2_HOSTILE|M2_STRONG, M3_INFRAVISION, CLR_BLUE);

    Monsters.AddMonster("giant zombie", S_ZOMBIE,
	Monsters.LVL(8, 8, 6, 0, -4), (G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 2, 8), Monsters.ATTK(AT_CLAW, AD_PHYS, 2, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(2050, 375, 0, MS_SILENT, MZ_HUGE),
	MR_COLD|MR_SLEEP|MR_POISON, 0,
	M1_BREATHLESS|M1_MINDLESS|M1_HUMANOID,
	M2_UNDEAD|M2_STALK|M2_HOSTILE|M2_GIANT|M2_STRONG, M3_INFRAVISION,
	CLR_CYAN);

    Monsters.AddMonster("ghoul", S_ZOMBIE,
	Monsters.LVL(3, 6, 10, 0, -2), (G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PLYS, 1, 2), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 3),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(400, 50, 0, MS_SILENT, MZ_SMALL),
	MR_COLD|MR_SLEEP|MR_POISON, 0,
	M1_BREATHLESS|M1_MINDLESS|M1_HUMANOID|M1_POIS,
	M2_UNDEAD|M2_WANDER|M2_HOSTILE, M3_INFRAVISION, CLR_BLACK);

    Monsters.AddMonster("skeleton", S_ZOMBIE,
	Monsters.LVL(12, 8, 4, 0, 0), (G_NOCORPSE|G_NOGEN),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 6), Monsters.ATTK(AT_TUCH, AD_SLOW, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(300, 5, 0, MS_BONES, MZ_HUMAN),
	MR_COLD|MR_SLEEP|MR_POISON|MR_STONE, 0,
	M1_BREATHLESS|M1_MINDLESS|M1_HUMANOID|M1_THICK_HIDE,
	M2_UNDEAD|M2_WANDER|M2_HOSTILE|M2_STRONG|M2_COLLECT|M2_NASTY,
	M3_INFRAVISION, CLR_WHITE);

/*
 * golems
 */
    Monsters.AddMonster("straw golem", S_GOLEM,
	Monsters.LVL(3, 12, 10, 0, 0), (G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 2), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 2),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(400, 0, 0, MS_SILENT, MZ_LARGE), MR_SLEEP|MR_POISON, 0,
	M1_BREATHLESS|M1_MINDLESS|M1_HUMANOID,
	M2_HOSTILE|M2_NEUTER, 0, CLR_YELLOW);

    Monsters.AddMonster("paper golem", S_GOLEM,
	Monsters.LVL(3, 12, 10, 0, 0), (G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 3),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(400, 0, 0, MS_SILENT, MZ_LARGE), MR_SLEEP|MR_POISON, 0,
	M1_BREATHLESS|M1_MINDLESS|M1_HUMANOID,
	M2_HOSTILE|M2_NEUTER, 0, HI_PAPER);

    Monsters.AddMonster("rope golem", S_GOLEM,
	Monsters.LVL(4, 9, 8, 0, 0), (G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4),
	  Monsters.ATTK(AT_HUGS, AD_PHYS, 6, 1), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(450, 0, 0, MS_SILENT, MZ_LARGE), MR_SLEEP|MR_POISON, 0,
	M1_BREATHLESS|M1_MINDLESS|M1_HUMANOID,
	M2_HOSTILE|M2_NEUTER, 0, CLR_BROWN);

    Monsters.AddMonster("gold golem", S_GOLEM,
	Monsters.LVL(5, 9, 6, 0, 0), (G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 2, 3), Monsters.ATTK(AT_CLAW, AD_PHYS, 2, 3),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(450, 0, 0, MS_SILENT, MZ_LARGE), MR_SLEEP|MR_POISON, 0,
	M1_BREATHLESS|M1_MINDLESS|M1_HUMANOID|M1_THICK_HIDE,
	M2_HOSTILE|M2_NEUTER, 0, HI_GOLD);

    Monsters.AddMonster("leather golem", S_GOLEM,
	Monsters.LVL(6, 6, 6, 0, 0), (G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 6), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(800, 0, 0, MS_SILENT, MZ_LARGE), MR_SLEEP|MR_POISON, 0,
	M1_BREATHLESS|M1_MINDLESS|M1_HUMANOID,
	M2_HOSTILE|M2_NEUTER, 0, HI_LEATHER);

    Monsters.AddMonster("wood golem", S_GOLEM,
	Monsters.LVL(7, 3, 4, 0, 0), (G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 3, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(900, 0, 0, MS_SILENT, MZ_LARGE), MR_SLEEP|MR_POISON, 0,
	M1_BREATHLESS|M1_MINDLESS|M1_HUMANOID|M1_THICK_HIDE,
	M2_HOSTILE|M2_NEUTER, 0, HI_WOOD);

    Monsters.AddMonster("flesh golem", S_GOLEM,
	Monsters.LVL(9, 8, 9, 30, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 2, 8), Monsters.ATTK(AT_CLAW, AD_PHYS, 2, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1400, 600, 0, MS_SILENT, MZ_LARGE),
	MR_FIRE|MR_COLD|MR_ELEC|MR_SLEEP|MR_POISON,
	MR_FIRE|MR_COLD|MR_ELEC|MR_SLEEP|MR_POISON,
	M1_BREATHLESS|M1_MINDLESS|M1_HUMANOID,
	M2_HOSTILE|M2_STRONG, 0, CLR_RED);

    Monsters.AddMonster("clay golem", S_GOLEM,
	Monsters.LVL(11, 7, 7, 40, 0), (G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 3,10),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1550, 0, 0, MS_SILENT, MZ_LARGE), MR_SLEEP|MR_POISON, 0,
	M1_BREATHLESS|M1_MINDLESS|M1_HUMANOID|M1_THICK_HIDE,
	M2_HOSTILE|M2_STRONG, 0, CLR_BROWN);

    Monsters.AddMonster("stone golem", S_GOLEM,
	Monsters.LVL(14, 6, 5, 50, 0), (G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 3, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1900, 0, 0, MS_SILENT, MZ_LARGE), MR_SLEEP|MR_POISON|MR_STONE, 0,
	M1_BREATHLESS|M1_MINDLESS|M1_HUMANOID|M1_THICK_HIDE,
	M2_HOSTILE|M2_STRONG, 0, CLR_GRAY);

    Monsters.AddMonster("glass golem", S_GOLEM,
	Monsters.LVL(16, 6, 1, 50, 0), (G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 2, 8), Monsters.ATTK(AT_CLAW, AD_PHYS, 2, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1800, 0, 0, MS_SILENT, MZ_LARGE), MR_SLEEP|MR_POISON, 0,
	M1_BREATHLESS|M1_MINDLESS|M1_HUMANOID|M1_THICK_HIDE,
	M2_HOSTILE|M2_STRONG, 0, CLR_CYAN);

    Monsters.AddMonster("iron golem", S_GOLEM,
	Monsters.LVL(18, 6, 3, 60, 0), (G_GENO|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 4,10), Monsters.ATTK(AT_BREA, AD_DRST, 4, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(2000, 0, 0, MS_SILENT, MZ_LARGE),
	MR_FIRE|MR_COLD|MR_ELEC|MR_SLEEP|MR_POISON, 0,
	M1_BREATHLESS|M1_MINDLESS|M1_HUMANOID|M1_THICK_HIDE|M1_POIS,
	M2_HOSTILE|M2_STRONG|M2_COLLECT, 0, HI_METAL);

/*
 * humans, including elves and were-critters
 */
    Monsters.AddMonster("human", S_HUMAN,
	Monsters.LVL(0, 12, 10, 0, 0), G_NOGEN,		/* for corpses */
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_HUMANOID, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_STRONG|M2_COLLECT,
	M3_INFRAVISIBLE, HI_DOMESTIC);

    Monsters.AddMonster("wererat", S_HUMAN,
	Monsters.LVL(2, 12, 10, 10, -7), (1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_WERE, MZ_HUMAN), MR_POISON, 0,
	M1_HUMANOID|M1_POIS|M1_REGEN|M1_OMNIVORE,
	M2_NOPOLY|M2_WERE|M2_HOSTILE|M2_HUMAN|M2_COLLECT, M3_INFRAVISIBLE,
	CLR_BROWN);

    Monsters.AddMonster("werejackal", S_HUMAN,
	Monsters.LVL(2, 12, 10, 10, -7), (1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_WERE, MZ_HUMAN), MR_POISON, 0,
	M1_HUMANOID|M1_POIS|M1_REGEN|M1_OMNIVORE,
	M2_NOPOLY|M2_WERE|M2_HOSTILE|M2_HUMAN|M2_COLLECT, M3_INFRAVISIBLE,
	CLR_RED);

    Monsters.AddMonster("werewolf", S_HUMAN,
	Monsters.LVL(5, 12, 10, 20, -7), (1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_WERE, MZ_HUMAN), MR_POISON, 0,
	M1_HUMANOID|M1_POIS|M1_REGEN|M1_OMNIVORE,
	M2_NOPOLY|M2_WERE|M2_HOSTILE|M2_HUMAN|M2_COLLECT,
	M3_INFRAVISIBLE, CLR_ORANGE);

    Monsters.AddMonster("elf", S_HUMAN,
	Monsters.LVL(10, 12, 10, 2, -3), G_NOGEN,		/* for corpses */
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_ELF, 350, 0, MS_HUMANOID, MZ_HUMAN), MR_SLEEP, MR_SLEEP,
	M1_HUMANOID|M1_OMNIVORE|M1_SEE_INVIS,
	M2_NOPOLY|M2_ELF|M2_STRONG|M2_COLLECT, M3_INFRAVISION|M3_INFRAVISIBLE,
	HI_DOMESTIC);

    Monsters.AddMonster("Woodland-elf", S_HUMAN,
	Monsters.LVL(4, 12, 10, 10, -5), (G_GENO|G_SGROUP|2),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_ELF, 350, 0, MS_HUMANOID, MZ_HUMAN), MR_SLEEP, MR_SLEEP,
	M1_HUMANOID|M1_OMNIVORE|M1_SEE_INVIS,
	M2_ELF|M2_COLLECT, M3_INFRAVISIBLE|M3_INFRAVISION, CLR_GREEN);

    Monsters.AddMonster("Green-elf", S_HUMAN,
	Monsters.LVL(5, 12, 10, 10, -6), (G_GENO|G_SGROUP|2),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_ELF, 350, 0, MS_HUMANOID, MZ_HUMAN), MR_SLEEP, MR_SLEEP,
	M1_HUMANOID|M1_OMNIVORE|M1_SEE_INVIS,
	M2_ELF|M2_COLLECT, M3_INFRAVISIBLE|M3_INFRAVISION, CLR_BRIGHT_GREEN);

    Monsters.AddMonster("Grey-elf", S_HUMAN,
	Monsters.LVL(6, 12, 10, 10, -7), (G_GENO|G_SGROUP|2),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_ELF, 350, 0, MS_HUMANOID, MZ_HUMAN), MR_SLEEP, MR_SLEEP,
	M1_HUMANOID|M1_OMNIVORE|M1_SEE_INVIS,
	M2_ELF|M2_COLLECT, M3_INFRAVISIBLE|M3_INFRAVISION, CLR_GRAY);

    Monsters.AddMonster("elf-lord", S_HUMAN,
	Monsters.LVL(8, 12, 10, 20, -9), (G_GENO|G_SGROUP|2),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4), Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_ELF, 350, 0, MS_HUMANOID, MZ_HUMAN), MR_SLEEP, MR_SLEEP,
	M1_HUMANOID|M1_OMNIVORE|M1_SEE_INVIS,
	M2_ELF|M2_STRONG|M2_LORD|M2_MALE|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_BRIGHT_BLUE);

    Monsters.AddMonster("Elvenking", S_HUMAN,
	Monsters.LVL(9, 12, 10, 25, -10), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4), Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_ELF, 350, 0, MS_HUMANOID, MZ_HUMAN), MR_SLEEP, MR_SLEEP,
	M1_HUMANOID|M1_OMNIVORE|M1_SEE_INVIS,
	M2_ELF|M2_STRONG|M2_PRINCE|M2_MALE|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, HI_LORD);

    Monsters.AddMonster("doppelganger", S_HUMAN,
	Monsters.LVL(9, 10, 5, 20, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 12),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_IMITATE, MZ_HUMAN), MR_SLEEP, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_HOSTILE|M2_STRONG|M2_COLLECT,
	M3_INFRAVISIBLE, HI_DOMESTIC);

    Monsters.AddMonster("nurse", S_HUMAN,
	Monsters.LVL(11, 6, 0, 0, 0), (G_GENO|3),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_HEAL, 2, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_NURSE, MZ_HUMAN), MR_POISON, MR_POISON,
	M1_HUMANOID|M1_OMNIVORE, M2_NOPOLY|M2_HUMAN|M2_HOSTILE,
	M3_INFRAVISIBLE, HI_DOMESTIC);

    Monsters.AddMonster("shopkeeper", S_HUMAN,
	Monsters.LVL(12, 18, 0, 50, 0), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 4, 4), Monsters.ATTK(AT_WEAP, AD_PHYS, 4, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
   //FIXME
	//Monsters.SIZ(WT_HUMAN, 400, sizeof(struct eshk), MS_SELL, MZ_HUMAN), 0, 0,
   Monsters.SIZ(WT_HUMAN, 400, 1, MS_SELL, MZ_HUMAN), 0, 0,

	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PEACEFUL|M2_STRONG|M2_COLLECT|M2_MAGIC,
	M3_INFRAVISIBLE, HI_DOMESTIC);

    Monsters.AddMonster("guard", S_HUMAN,
	Monsters.LVL(12, 12, 10, 40, 10), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 4,10),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
   //FIXME
	//Monsters.SIZ(WT_HUMAN, 400, sizeof(struct egd), MS_GUARD, MZ_HUMAN), 0, 0,
   Monsters.SIZ(WT_HUMAN, 400, 1, MS_GUARD, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_MERC|M2_PEACEFUL|M2_STRONG|M2_COLLECT,
	M3_INFRAVISIBLE, CLR_BLUE);

    Monsters.AddMonster("prisoner", S_HUMAN,
	Monsters.LVL(12, 12, 10, 0, 0), G_NOGEN,          /* for special levels */
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_DJINNI, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PEACEFUL|M2_STRONG|M2_COLLECT,
	M3_INFRAVISIBLE|M3_CLOSE, HI_DOMESTIC);

    Monsters.AddMonster("Oracle", S_HUMAN,
	Monsters.LVL(12, 0, 0, 50, 0), (G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_NONE, AD_MAGM, 0, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_ORACLE, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PEACEFUL|M2_FEMALE, M3_INFRAVISIBLE, HI_ZAP);

    Monsters.AddMonster("aligned priest", S_HUMAN,
	Monsters.LVL(12, 12, 10, 50, 0), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 4,10), Monsters.ATTK(AT_KICK, AD_PHYS, 1, 4),
	  Monsters.ATTK(AT_MAGC, AD_CLRC, 0, 0), NO_ATTK, NO_ATTK, NO_ATTK),
   //FIXME
	//Monsters.SIZ(WT_HUMAN, 400, sizeof(struct epri), MS_PRIEST, MZ_HUMAN),
   Monsters.SIZ(WT_HUMAN, 400, 1, MS_PRIEST, MZ_HUMAN),
	MR_ELEC, 0, M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_LORD|M2_PEACEFUL|M2_COLLECT, M3_INFRAVISIBLE,
	CLR_WHITE);

    Monsters.AddMonster("high priest", S_HUMAN,
	Monsters.LVL(25, 15, 7, 70, 0), (G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 4,10), Monsters.ATTK(AT_KICK, AD_PHYS, 2, 8),
	  Monsters.ATTK(AT_MAGC, AD_CLRC, 2, 8), Monsters.ATTK(AT_MAGC, AD_CLRC, 2, 8),
	  NO_ATTK, NO_ATTK),
   //FIXME
	//Monsters.SIZ(WT_HUMAN, 400, sizeof(struct epri), MS_PRIEST, MZ_HUMAN),
   Monsters.SIZ(WT_HUMAN, 400, 1, MS_PRIEST, MZ_HUMAN),
	MR_FIRE|MR_ELEC|MR_SLEEP|MR_POISON, 0,
	M1_HUMANOID|M1_SEE_INVIS|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_MINION|M2_PRINCE|M2_NASTY|M2_COLLECT|M2_MAGIC,
	M3_INFRAVISIBLE, CLR_WHITE);

    Monsters.AddMonster("soldier", S_HUMAN,
	Monsters.LVL(6, 4, 10, 0, -2), (G_SGROUP|G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_SOLDIER, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_MERC|M2_STALK|M2_HOSTILE|M2_STRONG|M2_COLLECT,
	M3_INFRAVISIBLE, CLR_GRAY);

    Monsters.AddMonster("sergeant", S_HUMAN,
	Monsters.LVL(8, 4, 10, 5, -3), (G_SGROUP|G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_SOLDIER, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_MERC|M2_STALK|M2_HOSTILE|M2_STRONG|M2_COLLECT,
	M3_INFRAVISIBLE, CLR_RED);

    Monsters.AddMonster("lieutenant", S_HUMAN,
	Monsters.LVL(10, 4, 10, 15, -4), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 3, 4), Monsters.ATTK(AT_WEAP, AD_PHYS, 3, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_SOLDIER, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_MERC|M2_STALK|M2_HOSTILE|M2_STRONG|M2_COLLECT,
	M3_INFRAVISIBLE, CLR_GREEN);

    Monsters.AddMonster("captain", S_HUMAN,
	Monsters.LVL(12, 4, 10, 15, -5), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 4, 4), Monsters.ATTK(AT_WEAP, AD_PHYS, 4, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_SOLDIER, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_MERC|M2_STALK|M2_HOSTILE|M2_STRONG|M2_COLLECT,
	M3_INFRAVISIBLE, CLR_BLUE);

	/* Keep these separate - some of the mkroom code assumes that
	 * all the soldiers are contiguous.
	 */
    Monsters.AddMonster("watchman", S_HUMAN,
	Monsters.LVL(6, 4, 10, 0, -2), (G_SGROUP|G_NOGEN|G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_SOLDIER, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_MERC|M2_STALK|M2_PEACEFUL|M2_STRONG|M2_COLLECT,
	M3_INFRAVISIBLE, CLR_GRAY);

    Monsters.AddMonster("watch captain", S_HUMAN,
	Monsters.LVL(10, 4, 10, 15, -4), (G_NOGEN|G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 3, 4), Monsters.ATTK(AT_WEAP, AD_PHYS, 3, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_SOLDIER, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_MERC|M2_STALK|M2_PEACEFUL|M2_STRONG|M2_COLLECT,
	M3_INFRAVISIBLE, CLR_GREEN);

	/* Unique humans not tied to quests.
	 */
    Monsters.AddMonster("Medusa", S_HUMAN,
	Monsters.LVL(20, 12, 2, 50, -15), (G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 8), Monsters.ATTK(AT_GAZE, AD_STON, 0, 0),
	  Monsters.ATTK(AT_BITE, AD_DRST, 1, 6), Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_HISS, MZ_LARGE),
	MR_POISON|MR_STONE, MR_POISON|MR_STONE,
	M1_FLY|M1_SWIM|M1_AMPHIBIOUS|M1_HUMANOID|M1_POIS|M1_OMNIVORE,
	M2_NOPOLY|M2_HOSTILE|M2_STRONG|M2_PNAME|M2_FEMALE,
	M3_WAITFORU|M3_INFRAVISIBLE, CLR_BRIGHT_GREEN);

    Monsters.AddMonster("Wizard of Yendor", S_HUMAN,
	Monsters.LVL(30, 12, -8, 100, A_NONE), (G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_SAMU, 2,12), Monsters.ATTK(AT_MAGC, AD_SPEL, 0, 0),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_CUSS, MZ_HUMAN),
	MR_FIRE|MR_POISON, MR_FIRE|MR_POISON,
	M1_FLY|M1_BREATHLESS|M1_HUMANOID|M1_REGEN|M1_SEE_INVIS|M1_TPORT|
	  M1_TPORT_CNTRL|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_HOSTILE|M2_STRONG|M2_NASTY|
	  M2_PRINCE|M2_MALE|M2_MAGIC,
	M3_COVETOUS|M3_WAITFORU|M3_INFRAVISIBLE, HI_LORD);

    Monsters.AddMonster("Croesus", S_HUMAN,
	Monsters.LVL(20, 15, 0, 40, 15), (G_UNIQ|G_NOGEN),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 4,10),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_GUARD, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_SEE_INVIS|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_STALK|M2_HOSTILE|M2_STRONG|M2_NASTY|M2_PNAME|
	  M2_PRINCE|M2_MALE|M2_GREEDY|M2_JEWELS|M2_COLLECT|M2_MAGIC,
	M3_INFRAVISIBLE, HI_LORD);

//#ifdef CHARON
    Monsters.AddMonster("Charon", S_HUMAN,
	Monsters.LVL(76, 18, -5, 120, 0), (G_HELL|G_NOCORPSE|G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 8), Monsters.ATTK(AT_TUCH, AD_PLYS, 1, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_FERRY, MZ_HUMAN),
	MR_FIRE|MR_COLD|MR_POISON|MR_STONE, 0,
	M1_BREATHLESS|M1_SEE_INVIS|M1_HUMANOID,
	M2_NOPOLY|M2_HUMAN|M2_PEACEFUL|M2_PNAME|M2_MALE|M2_GREEDY|M2_COLLECT,
	M3_INFRAVISIBLE, CLR_WHITE);

//#endif
/*
 * ghosts
 */
    Monsters.AddMonster("ghost", S_GHOST,
	Monsters.LVL(10, 3, -5, 50, -5), (G_NOCORPSE|G_NOGEN),
	Monsters.A(Monsters.ATTK(AT_TUCH, AD_PHYS, 1, 1),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 0, 0, MS_SILENT, MZ_HUMAN),
	MR_COLD|MR_DISINT|MR_SLEEP|MR_POISON|MR_STONE, 0,
	M1_FLY|M1_BREATHLESS|M1_WALLWALK|M1_HUMANOID|M1_UNSOLID,
	M2_NOPOLY|M2_UNDEAD|M2_STALK|M2_HOSTILE, M3_INFRAVISION, CLR_GRAY);

    Monsters.AddMonster("shade", S_GHOST,
	Monsters.LVL(12, 10, 10, 0, 0), (G_NOCORPSE|G_NOGEN),
	Monsters.A(Monsters.ATTK(AT_TUCH, AD_PLYS, 2, 6), Monsters.ATTK(AT_TUCH, AD_SLOW, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 0, 0, MS_WAIL, MZ_HUMAN),
	MR_COLD|MR_DISINT|MR_SLEEP|MR_POISON|MR_STONE, 0,
	M1_FLY|M1_BREATHLESS|M1_WALLWALK|M1_HUMANOID|M1_UNSOLID|M1_SEE_INVIS,
	M2_NOPOLY|M2_UNDEAD|M2_WANDER|M2_STALK|M2_HOSTILE|M2_NASTY,
	M3_INFRAVISION, CLR_BLACK);

/*
 * (major) demons
 */
    Monsters.AddMonster("water demon", S_DEMON,
	Monsters.LVL(8, 12,-4, 30, -7), (G_NOCORPSE|G_NOGEN),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 3), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 3),
	  Monsters.ATTK(AT_BITE, AD_PHYS, 1, 3), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_DJINNI, MZ_HUMAN), MR_FIRE|MR_POISON, 0,
	M1_HUMANOID|M1_POIS|M1_SWIM,
	M2_NOPOLY|M2_DEMON|M2_STALK|M2_HOSTILE|M2_NASTY|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_BLUE);

	/* standard demons & devils
	 */
    Monsters.AddMonster("horned devil", S_DEMON,
	Monsters.LVL(6, 9, -5, 50, 11), (G_HELL|G_NOCORPSE|2),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 4), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4),
	  Monsters.ATTK(AT_BITE, AD_PHYS, 2, 3), Monsters.ATTK(AT_STNG, AD_PHYS, 1, 3),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_SILENT, MZ_HUMAN), MR_FIRE|MR_POISON, 0,
	M1_POIS|M1_THICK_HIDE,
	M2_DEMON|M2_STALK|M2_HOSTILE|M2_NASTY, M3_INFRAVISIBLE|M3_INFRAVISION,
	CLR_BROWN);

#ifdef SEDUCE
# define SEDUCTION_ATTACKS \
	Monsters.A(Monsters.ATTK(AT_BITE, AD_SSEX, 0, 0), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 3), \
	  Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 3), NO_ATTK, NO_ATTK, NO_ATTK)
#else
# define SEDUCTION_ATTACKS \
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 3), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 3), \
	  Monsters.ATTK(AT_BITE, AD_DRLI, 2, 6), NO_ATTK, NO_ATTK, NO_ATTK)
#endif
    Monsters.AddMonster("succubus", S_DEMON,
	Monsters.LVL(6, 12, 0, 70, -9), (G_NOCORPSE|1),
	SEDUCTION_ATTACKS,
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_SEDUCE, MZ_HUMAN), MR_FIRE|MR_POISON, 0,
	M1_HUMANOID|M1_FLY|M1_POIS,
	M2_DEMON|M2_STALK|M2_HOSTILE|M2_NASTY|M2_FEMALE,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_GRAY);

    Monsters.AddMonster("incubus", S_DEMON,
	Monsters.LVL(6, 12, 0, 70, -9), (G_NOCORPSE|1),
	SEDUCTION_ATTACKS,
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_SEDUCE, MZ_HUMAN), MR_FIRE|MR_POISON, 0,
	M1_HUMANOID|M1_FLY|M1_POIS,
	M2_DEMON|M2_STALK|M2_HOSTILE|M2_NASTY|M2_MALE,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_GRAY);

#undef SEDUCTION_ATTACKS
    /* Used by AD&D for a type of demon, originally one of the Furies */
    /* and spelled this way */
    Monsters.AddMonster("erinys", S_DEMON,
	Monsters.LVL(7, 12, 2, 30, 10), (G_HELL|G_NOCORPSE|G_SGROUP|2),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_DRST, 2, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_SILENT, MZ_HUMAN), MR_FIRE|MR_POISON, 0,
	M1_HUMANOID|M1_POIS,
	M2_DEMON|M2_STALK|M2_HOSTILE|M2_STRONG|M2_NASTY|M2_FEMALE|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_RED);

    Monsters.AddMonster("barbed devil", S_DEMON,
	Monsters.LVL(8, 12, 0, 35, 8), (G_HELL|G_NOCORPSE|G_SGROUP|2),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 2, 4), Monsters.ATTK(AT_CLAW, AD_PHYS, 2, 4),
	  Monsters.ATTK(AT_STNG, AD_PHYS, 3, 4), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_SILENT, MZ_HUMAN), MR_FIRE|MR_POISON, 0,
	M1_POIS|M1_THICK_HIDE, M2_DEMON|M2_STALK|M2_HOSTILE|M2_NASTY,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_RED);

    Monsters.AddMonster("marilith", S_DEMON,
	Monsters.LVL(7, 12, -6, 80, -12), (G_HELL|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4), Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4),
	  Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4), Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4),
	  Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4), Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4)),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_CUSS, MZ_LARGE), MR_FIRE|MR_POISON, 0,
	M1_HUMANOID|M1_SLITHY|M1_SEE_INVIS|M1_POIS,
	M2_DEMON|M2_STALK|M2_HOSTILE|M2_NASTY|M2_FEMALE|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_RED);

    Monsters.AddMonster("vrock", S_DEMON,
	Monsters.LVL(8, 12, 0, 50, -9), (G_HELL|G_NOCORPSE|G_SGROUP|2),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4),
	  Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 8), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 8),
	  Monsters.ATTK(AT_BITE, AD_PHYS, 1, 6), NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_SILENT, MZ_LARGE), MR_FIRE|MR_POISON, 0,
	M1_POIS, M2_DEMON|M2_STALK|M2_HOSTILE|M2_NASTY,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_RED);

    Monsters.AddMonster("hezrou", S_DEMON,
	Monsters.LVL(9, 6, -2, 55, -10), (G_HELL|G_NOCORPSE|G_SGROUP|2),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 3), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 3),
	  Monsters.ATTK(AT_BITE, AD_PHYS, 4, 4), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_SILENT, MZ_LARGE), MR_FIRE|MR_POISON, 0,
	M1_HUMANOID|M1_POIS, M2_DEMON|M2_STALK|M2_HOSTILE|M2_NASTY,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_RED);

    Monsters.AddMonster("bone devil", S_DEMON,
	Monsters.LVL(9, 15, -1, 40, -9), (G_HELL|G_NOCORPSE|G_SGROUP|2),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 3, 4), Monsters.ATTK(AT_STNG, AD_DRST, 2, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_SILENT, MZ_LARGE), MR_FIRE|MR_POISON, 0,
	M1_POIS, M2_DEMON|M2_STALK|M2_HOSTILE|M2_NASTY|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_GRAY);

    Monsters.AddMonster("ice devil", S_DEMON,
	Monsters.LVL(11, 6, -4, 55, -12), (G_HELL|G_NOCORPSE|2),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4),
	  Monsters.ATTK(AT_BITE, AD_PHYS, 2, 4), Monsters.ATTK(AT_STNG, AD_COLD, 3, 4),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_SILENT, MZ_LARGE),
	MR_FIRE|MR_COLD|MR_POISON, 0, M1_SEE_INVIS|M1_POIS,
	M2_DEMON|M2_STALK|M2_HOSTILE|M2_NASTY, M3_INFRAVISIBLE|M3_INFRAVISION,
	CLR_WHITE);

    Monsters.AddMonster("nalfeshnee", S_DEMON,
	Monsters.LVL(11, 9, -1, 65, -11), (G_HELL|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4), Monsters.ATTK(AT_CLAW, AD_PHYS, 1, 4),
	  Monsters.ATTK(AT_BITE, AD_PHYS, 2, 4), Monsters.ATTK(AT_MAGC, AD_SPEL, 0, 0),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_SPELL, MZ_LARGE), MR_FIRE|MR_POISON, 0,
	M1_HUMANOID|M1_POIS, M2_DEMON|M2_STALK|M2_HOSTILE|M2_NASTY,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_RED);

    Monsters.AddMonster("pit fiend", S_DEMON,
	Monsters.LVL(13, 6, -3, 65, -13), (G_HELL|G_NOCORPSE|2),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 4, 2), Monsters.ATTK(AT_WEAP, AD_PHYS, 4, 2),
	  Monsters.ATTK(AT_HUGS, AD_PHYS, 2, 4), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_GROWL, MZ_LARGE), MR_FIRE|MR_POISON, 0,
	M1_SEE_INVIS|M1_POIS,
	M2_DEMON|M2_STALK|M2_HOSTILE|M2_NASTY|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_RED);

    Monsters.AddMonster("balrog", S_DEMON,
	Monsters.LVL(16, 5, -2, 75, -14), (G_HELL|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 8, 4), Monsters.ATTK(AT_WEAP, AD_PHYS, 4, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_SILENT, MZ_LARGE), MR_FIRE|MR_POISON, 0,
	M1_FLY|M1_SEE_INVIS|M1_POIS,
	M2_DEMON|M2_STALK|M2_HOSTILE|M2_STRONG|M2_NASTY|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_RED);

	/* Named demon lords & princes plus Arch-Devils.
	 * (their order matters; see minion.c)
	 */
    Monsters.AddMonster("Juiblex", S_DEMON,
	Monsters.LVL(50, 3, -7, 65, -15), (G_HELL|G_NOCORPSE|G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_ENGL, AD_DISE, 4,10), Monsters.ATTK(AT_SPIT, AD_ACID, 3, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1500, 0, 0, MS_GURGLE, MZ_LARGE),
	MR_FIRE|MR_POISON|MR_ACID|MR_STONE, 0,
	M1_AMPHIBIOUS|M1_AMORPHOUS|M1_NOHEAD|M1_FLY|M1_SEE_INVIS|M1_ACID|
	  M1_POIS,
	M2_NOPOLY|M2_DEMON|M2_STALK|M2_HOSTILE|M2_PNAME|M2_NASTY|M2_LORD|
	  M2_MALE,
	M3_WAITFORU|M3_WANTSAMUL|M3_INFRAVISION, CLR_BRIGHT_GREEN);

    Monsters.AddMonster("Yeenoghu", S_DEMON,
	Monsters.LVL(56, 18, -5, 80, -15), (G_HELL|G_NOCORPSE|G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 3, 6), Monsters.ATTK(AT_WEAP, AD_CONF, 2, 8),
	  Monsters.ATTK(AT_WEAP, AD_PLYS, 1, 6), Monsters.ATTK(AT_MAGC, AD_MAGM, 2, 6),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(900, 500, 0, MS_ORC, MZ_LARGE), MR_FIRE|MR_POISON, 0,
	M1_FLY|M1_SEE_INVIS|M1_POIS,
	M2_NOPOLY|M2_DEMON|M2_STALK|M2_HOSTILE|M2_PNAME|M2_NASTY|M2_LORD|
	  M2_MALE|M2_COLLECT,
	M3_WANTSAMUL|M3_INFRAVISIBLE|M3_INFRAVISION, HI_LORD);

    Monsters.AddMonster("Orcus", S_DEMON,
	Monsters.LVL(66, 9, -6, 85, -20), (G_HELL|G_NOCORPSE|G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_MAGC, AD_SPEL, 8, 6), Monsters.ATTK(AT_WEAP, AD_PHYS, 3, 6),
	  Monsters.ATTK(AT_CLAW, AD_PHYS, 3, 4), Monsters.ATTK(AT_CLAW, AD_PHYS, 3, 4),
	  Monsters.ATTK(AT_STNG, AD_DRST, 2, 4), NO_ATTK),
	Monsters.SIZ(1500, 500, 0, MS_ORC, MZ_HUGE), MR_FIRE|MR_POISON, 0,
	M1_FLY|M1_SEE_INVIS|M1_POIS,
	M2_NOPOLY|M2_DEMON|M2_STALK|M2_HOSTILE|M2_PNAME|M2_NASTY|M2_PRINCE|
	  M2_MALE|M2_COLLECT,
	M3_WAITFORU|M3_WANTSBOOK|M3_WANTSAMUL|M3_INFRAVISIBLE|M3_INFRAVISION,
	HI_LORD);

    Monsters.AddMonster("Geryon", S_DEMON,
	Monsters.LVL(72, 3, -3, 75, 15), (G_HELL|G_NOCORPSE|G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 3, 6), Monsters.ATTK(AT_CLAW, AD_PHYS, 3, 6),
	  Monsters.ATTK(AT_STNG, AD_DRST, 2, 4), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1500, 500, 0, MS_BRIBE, MZ_HUGE), MR_FIRE|MR_POISON, 0,
	M1_FLY|M1_SEE_INVIS|M1_POIS|M1_SLITHY,
	M2_NOPOLY|M2_DEMON|M2_STALK|M2_HOSTILE|M2_PNAME|M2_NASTY|
	  M2_PRINCE|M2_MALE,
	M3_WANTSAMUL|M3_INFRAVISIBLE|M3_INFRAVISION, HI_LORD);

    Monsters.AddMonster("Dispater", S_DEMON,
	Monsters.LVL(78, 15, -2, 80, 15), (G_HELL|G_NOCORPSE|G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 4, 6), Monsters.ATTK(AT_MAGC, AD_SPEL, 6, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1500, 500, 0, MS_BRIBE, MZ_HUMAN), MR_FIRE|MR_POISON, 0,
	M1_FLY|M1_SEE_INVIS|M1_POIS|M1_HUMANOID,
	M2_NOPOLY|M2_DEMON|M2_STALK|M2_HOSTILE|M2_PNAME|M2_NASTY|
	  M2_PRINCE|M2_MALE|M2_COLLECT,
	M3_WANTSAMUL|M3_INFRAVISIBLE|M3_INFRAVISION, HI_LORD);

    Monsters.AddMonster("Baalzebub", S_DEMON,
	Monsters.LVL(89, 9, -5, 85, 20), (G_HELL|G_NOCORPSE|G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_DRST, 2, 6), Monsters.ATTK(AT_GAZE, AD_STUN, 2, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1500, 500, 0, MS_BRIBE, MZ_LARGE), MR_FIRE|MR_POISON, 0,
	M1_FLY|M1_SEE_INVIS|M1_POIS,
	M2_NOPOLY|M2_DEMON|M2_STALK|M2_HOSTILE|M2_PNAME|M2_NASTY|
	  M2_PRINCE|M2_MALE,
	M3_WANTSAMUL|M3_WAITFORU|M3_INFRAVISIBLE|M3_INFRAVISION, HI_LORD);

    Monsters.AddMonster("Asmodeus", S_DEMON,
	Monsters.LVL(105, 12, -7, 90, 20), (G_HELL|G_NOCORPSE|G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 4, 4), Monsters.ATTK(AT_MAGC, AD_COLD, 6, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1500, 500, 0, MS_BRIBE, MZ_HUGE), MR_FIRE|MR_COLD|MR_POISON, 0,
	M1_FLY|M1_SEE_INVIS|M1_HUMANOID|M1_POIS,
	M2_NOPOLY|M2_DEMON|M2_STALK|M2_HOSTILE|M2_PNAME|M2_STRONG|
	  M2_NASTY|M2_PRINCE|M2_MALE,
	M3_WANTSAMUL|M3_WAITFORU|M3_INFRAVISIBLE|M3_INFRAVISION, HI_LORD);

    Monsters.AddMonster("Demogorgon", S_DEMON,
	Monsters.LVL(106, 15, -8, 95, -20), (G_HELL|G_NOCORPSE|G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_MAGC, AD_SPEL, 8, 6), Monsters.ATTK(AT_STNG, AD_DRLI, 1, 4),
	  Monsters.ATTK(AT_CLAW, AD_DISE, 1, 6), Monsters.ATTK(AT_CLAW, AD_DISE, 1, 6),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(1500, 500, 0, MS_GROWL, MZ_HUGE), MR_FIRE|MR_POISON, 0,
	M1_FLY|M1_SEE_INVIS|M1_NOHANDS|M1_POIS,
	M2_NOPOLY|M2_DEMON|M2_STALK|M2_HOSTILE|M2_PNAME|M2_NASTY|
	  M2_PRINCE|M2_MALE,
	M3_WANTSAMUL|M3_INFRAVISIBLE|M3_INFRAVISION, HI_LORD);

	/* Riders -- the Four Horsemen of the Apocalypse ("War" == player)
	 */
    Monsters.AddMonster("Death", S_DEMON,
	Monsters.LVL(30, 12, -5, 100, 0), (G_UNIQ|G_NOGEN),
	Monsters.A(Monsters.ATTK(AT_TUCH, AD_DETH, 8, 8), Monsters.ATTK(AT_TUCH, AD_DETH, 8, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 1, 0, MS_RIDER, MZ_HUMAN),
	MR_FIRE|MR_COLD|MR_ELEC|MR_SLEEP|MR_POISON|MR_STONE, 0,
	M1_FLY|M1_HUMANOID|M1_REGEN|M1_SEE_INVIS|M1_TPORT_CNTRL,
	M2_NOPOLY|M2_STALK|M2_HOSTILE|M2_PNAME|M2_STRONG|M2_NASTY,
	M3_INFRAVISIBLE|M3_INFRAVISION, HI_LORD);

    Monsters.AddMonster("Pestilence", S_DEMON,
	Monsters.LVL(30, 12, -5, 100, 0), (G_UNIQ|G_NOGEN),
	Monsters.A(Monsters.ATTK(AT_TUCH, AD_PEST, 8, 8), Monsters.ATTK(AT_TUCH, AD_PEST, 8, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 1, 0, MS_RIDER, MZ_HUMAN),
	MR_FIRE|MR_COLD|MR_ELEC|MR_SLEEP|MR_POISON|MR_STONE, 0,
	M1_FLY|M1_HUMANOID|M1_REGEN|M1_SEE_INVIS|M1_TPORT_CNTRL,
	M2_NOPOLY|M2_STALK|M2_HOSTILE|M2_PNAME|M2_STRONG|M2_NASTY,
	M3_INFRAVISIBLE|M3_INFRAVISION, HI_LORD);

    Monsters.AddMonster("Famine", S_DEMON,
	Monsters.LVL(30, 12, -5, 100, 0), (G_UNIQ|G_NOGEN),
	Monsters.A(Monsters.ATTK(AT_TUCH, AD_FAMN, 8, 8), Monsters.ATTK(AT_TUCH, AD_FAMN, 8, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 1, 0, MS_RIDER, MZ_HUMAN),
	MR_FIRE|MR_COLD|MR_ELEC|MR_SLEEP|MR_POISON|MR_STONE, 0,
	M1_FLY|M1_HUMANOID|M1_REGEN|M1_SEE_INVIS|M1_TPORT_CNTRL,
	M2_NOPOLY|M2_STALK|M2_HOSTILE|M2_PNAME|M2_STRONG|M2_NASTY,
	M3_INFRAVISIBLE|M3_INFRAVISION, HI_LORD);

	/* other demons
	 */
#ifdef MAIL
    Monsters.AddMonster("mail daemon", S_DEMON,
	Monsters.LVL(56, 24, 10, 127, 0), (G_NOGEN|G_NOCORPSE),
	Monsters.A(NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(600, 300, 0, MS_SILENT, MZ_HUMAN),
	MR_FIRE|MR_COLD|MR_ELEC|MR_SLEEP|MR_POISON|MR_STONE, 0,
	M1_FLY|M1_SWIM|M1_BREATHLESS|M1_SEE_INVIS|M1_HUMANOID|M1_POIS,
	M2_NOPOLY|M2_STALK|M2_PEACEFUL, M3_INFRAVISIBLE|M3_INFRAVISION,
	CLR_BRIGHT_BLUE);

#endif
    Monsters.AddMonster("djinni", S_DEMON,
	Monsters.LVL(7, 12, 4, 30, 0), (G_NOGEN|G_NOCORPSE),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1500, 400, 0, MS_DJINNI, MZ_HUMAN), MR_POISON|MR_STONE, 0,
	M1_HUMANOID|M1_FLY|M1_POIS,
	M2_NOPOLY|M2_STALK|M2_COLLECT, M3_INFRAVISIBLE, CLR_YELLOW);

    Monsters.AddMonster("sandestin", S_DEMON,
	Monsters.LVL(13, 12, 4, 60, -5), (G_HELL|G_NOCORPSE|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 6), Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1500, 400, 0, MS_CUSS, MZ_HUMAN), MR_STONE, 0,
	M1_HUMANOID, M2_NOPOLY|M2_STALK|M2_STRONG|M2_COLLECT,
	M3_INFRAVISIBLE|M3_INFRAVISION, CLR_GRAY);

/*
 * sea monsters
 */
    Monsters.AddMonster("jellyfish", S_EEL,
	Monsters.LVL(3, 3, 6, 0, 0), (G_GENO|G_NOGEN),
	Monsters.A(Monsters.ATTK(AT_STNG, AD_DRST, 3, 3), NO_ATTK,
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(80, 20, 0, MS_SILENT, MZ_SMALL), MR_POISON, MR_POISON,
	M1_SWIM|M1_AMPHIBIOUS|M1_SLITHY|M1_NOLIMBS|M1_NOTAKE|M1_POIS,
	M2_HOSTILE, 0, CLR_BLUE);

    Monsters.AddMonster("piranha", S_EEL,
	Monsters.LVL(5, 12, 4, 0, 0), (G_GENO|G_NOGEN|G_SGROUP),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 2, 6), NO_ATTK,
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(60, 30, 0, MS_SILENT, MZ_SMALL), 0, 0,
	M1_SWIM|M1_AMPHIBIOUS|M1_ANIMAL|M1_SLITHY|M1_NOLIMBS|
	  M1_CARNIVORE|M1_OVIPAROUS|M1_NOTAKE,
	M2_HOSTILE, 0, CLR_RED);

    Monsters.AddMonster("shark", S_EEL,
	Monsters.LVL(7, 12, 2, 0, 0), (G_GENO|G_NOGEN),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 5, 6), NO_ATTK,
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(500, 350, 0, MS_SILENT, MZ_LARGE), 0, 0,
	M1_SWIM|M1_AMPHIBIOUS|M1_ANIMAL|M1_SLITHY|M1_NOLIMBS|
	  M1_CARNIVORE|M1_OVIPAROUS|M1_NOTAKE,
	M2_HOSTILE, 0, CLR_GRAY);

    Monsters.AddMonster("giant eel", S_EEL,
	Monsters.LVL(5, 9, -1, 0, 0), (G_GENO|G_NOGEN),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 3, 6), Monsters.ATTK(AT_TUCH, AD_WRAP, 0, 0),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(200, 250, 0, MS_SILENT, MZ_HUGE), 0, 0,
	M1_SWIM|M1_AMPHIBIOUS|M1_ANIMAL|M1_SLITHY|M1_NOLIMBS|
	  M1_CARNIVORE|M1_OVIPAROUS|M1_NOTAKE,
	M2_HOSTILE, M3_INFRAVISIBLE, CLR_CYAN);

    Monsters.AddMonster("electric eel", S_EEL,
	Monsters.LVL(7, 10, -3, 0, 0), (G_GENO|G_NOGEN),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_ELEC, 4, 6), Monsters.ATTK(AT_TUCH, AD_WRAP, 0, 0),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(200, 250, 0, MS_SILENT, MZ_HUGE), MR_ELEC, MR_ELEC,
	M1_SWIM|M1_AMPHIBIOUS|M1_ANIMAL|M1_SLITHY|M1_NOLIMBS|
	  M1_CARNIVORE|M1_OVIPAROUS|M1_NOTAKE,
	M2_HOSTILE, M3_INFRAVISIBLE, CLR_BRIGHT_BLUE);

    Monsters.AddMonster("kraken", S_EEL,
	Monsters.LVL(20, 3, 6, 0, -3), (G_GENO|G_NOGEN),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 2, 4), Monsters.ATTK(AT_CLAW, AD_PHYS, 2, 4),
	  Monsters.ATTK(AT_HUGS, AD_WRAP, 2, 6), Monsters.ATTK(AT_BITE, AD_PHYS, 5, 4),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(1800, 1000, 0, MS_SILENT, MZ_HUGE), 0, 0,
	M1_SWIM|M1_AMPHIBIOUS|M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE,
	M2_NOPOLY|M2_HOSTILE|M2_STRONG, M3_INFRAVISIBLE, CLR_RED);

/*
 * lizards, &c
 */
    Monsters.AddMonster("newt", S_LIZARD,
	Monsters.LVL(0, 6, 8, 0, 0), (G_GENO|5),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 2),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(10, 20, 0, MS_SILENT, MZ_TINY), 0, 0,
	M1_SWIM|M1_AMPHIBIOUS|M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE,
	M2_HOSTILE, 0, CLR_YELLOW);

    Monsters.AddMonster("gecko", S_LIZARD,
	Monsters.LVL(1, 6, 8, 0, 0), (G_GENO|5),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 3),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(10, 20, 0, MS_SQEEK, MZ_TINY), 0, 0,
	M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE, M2_HOSTILE, 0, CLR_GREEN);

    Monsters.AddMonster("iguana", S_LIZARD,
	Monsters.LVL(2, 6, 7, 0, 0), (G_GENO|5),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(30, 30, 0, MS_SILENT, MZ_TINY), 0, 0,
	M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE, M2_HOSTILE, 0, CLR_BROWN);

    Monsters.AddMonster("baby crocodile", S_LIZARD,
	Monsters.LVL(3, 6, 7, 0, 0), G_GENO,
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(200, 200, 0, MS_SILENT, MZ_MEDIUM), 0, 0,
	M1_SWIM|M1_AMPHIBIOUS|M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE,
	M2_HOSTILE, 0, CLR_BROWN);

    Monsters.AddMonster("lizard", S_LIZARD,
	Monsters.LVL(5, 6, 6, 10, 0), (G_GENO|5),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(10, 40, 0, MS_SILENT, MZ_TINY), MR_STONE, MR_STONE,
	M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE, M2_HOSTILE, 0, CLR_GREEN);

    Monsters.AddMonster("chameleon", S_LIZARD,
	Monsters.LVL(6, 5, 6, 10, 0), (G_GENO|2),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 4, 2),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(100, 100, 0, MS_SILENT, MZ_TINY), 0, 0,
	M1_ANIMAL|M1_NOHANDS|M1_CARNIVORE, M2_NOPOLY|M2_HOSTILE, 0, CLR_BROWN);

    Monsters.AddMonster("crocodile", S_LIZARD,
	Monsters.LVL(6, 9, 5, 0, 0), (G_GENO|1),
	Monsters.A(Monsters.ATTK(AT_BITE, AD_PHYS, 4, 2), Monsters.ATTK(AT_CLAW, AD_PHYS, 1,12),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_SILENT, MZ_LARGE), 0, 0,
	M1_SWIM|M1_AMPHIBIOUS|M1_ANIMAL|M1_THICK_HIDE|M1_NOHANDS|
	  M1_OVIPAROUS|M1_CARNIVORE,
	M2_STRONG|M2_HOSTILE, 0, CLR_BROWN);

    Monsters.AddMonster("salamander", S_LIZARD,
	Monsters.LVL(8, 12, -1, 0, -9), (G_HELL|1),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 8), Monsters.ATTK(AT_TUCH, AD_FIRE, 1, 6),
	  Monsters.ATTK(AT_HUGS, AD_PHYS, 2, 6), Monsters.ATTK(AT_HUGS, AD_FIRE, 3, 6),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(1500, 400, 0, MS_MUMBLE, MZ_HUMAN), MR_SLEEP|MR_FIRE, MR_FIRE,
	M1_HUMANOID|M1_SLITHY|M1_THICK_HIDE|M1_POIS,
	M2_STALK|M2_HOSTILE|M2_COLLECT|M2_MAGIC, M3_INFRAVISIBLE, CLR_ORANGE);


/*
 * dummy monster needed for visual interface
 */
	/* (marking it unique prevents figurines)
	 */
    Monsters.AddMonster("long worm tail", S_WORM_TAIL,
	Monsters.LVL(0, 0, 0, 0, 0), (G_NOGEN|G_NOCORPSE|G_UNIQ),
	Monsters.A(NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(0, 0, 0, 0, 0), 0, 0, 0L, M2_NOPOLY, 0, CLR_BROWN);


	/* Note:
	 * Worm tail must be between the normal monsters and the special
	 * quest & pseudo-character ones because an optimization in the
	 * random monster selection code assumes everything beyond here
	 * has the G_NOGEN and M2_NOPOLY attributes.
	 */

/*
 * character classes
 */
    Monsters.AddMonster("archeologist", S_HUMAN,
	Monsters.LVL(10, 10, 10, 1, 3), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_HUMANOID, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_TUNNEL|M1_NEEDPICK|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_STRONG|M2_COLLECT, M3_INFRAVISIBLE, HI_DOMESTIC);

    Monsters.AddMonster("barbarian", S_HUMAN,
	Monsters.LVL(10, 10, 10, 1, 0), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_HUMANOID, MZ_HUMAN), MR_POISON, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_STRONG|M2_COLLECT, M3_INFRAVISIBLE, HI_DOMESTIC);

    Monsters.AddMonster("caveman", S_HUMAN,
	Monsters.LVL(10, 10, 10, 0, 1), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_HUMANOID, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_STRONG|M2_MALE|M2_COLLECT, M3_INFRAVISIBLE,
	HI_DOMESTIC);

    Monsters.AddMonster("cavewoman", S_HUMAN,
	Monsters.LVL(10, 10, 10, 0, 1), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_HUMANOID, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_STRONG|M2_FEMALE|M2_COLLECT, M3_INFRAVISIBLE,
	HI_DOMESTIC);

    Monsters.AddMonster("healer", S_HUMAN,
	Monsters.LVL(10, 10, 10, 1, 0), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_HUMANOID, MZ_HUMAN), MR_POISON, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_STRONG|M2_COLLECT, M3_INFRAVISIBLE, HI_DOMESTIC);

    Monsters.AddMonster("knight", S_HUMAN,
	Monsters.LVL(10, 10, 10, 1, 3), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_HUMANOID, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_STRONG|M2_COLLECT, M3_INFRAVISIBLE, HI_DOMESTIC);

    Monsters.AddMonster("monk", S_HUMAN,
	Monsters.LVL(10, 10, 10, 2, 0), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_KICK, AD_PHYS, 1, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_HUMANOID, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_STRONG|M2_COLLECT|M2_MALE,
	M3_INFRAVISIBLE, HI_DOMESTIC);

    Monsters.AddMonster("priest", S_HUMAN,
	Monsters.LVL(10, 10, 10, 2, 0), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_HUMANOID, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_STRONG|M2_MALE|M2_COLLECT, M3_INFRAVISIBLE,
	HI_DOMESTIC);

    Monsters.AddMonster("priestess", S_HUMAN,
	Monsters.LVL(10, 10, 10, 2, 0), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_HUMANOID, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_STRONG|M2_FEMALE|M2_COLLECT, M3_INFRAVISIBLE,
	HI_DOMESTIC);

    Monsters.AddMonster("ranger", S_HUMAN,
	Monsters.LVL(10, 12, 10, 2, -3), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_HUMANOID, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_STRONG|M2_COLLECT, M3_INFRAVISIBLE,
	HI_DOMESTIC);

    Monsters.AddMonster("rogue", S_HUMAN,
	Monsters.LVL(10, 10, 10, 1, -3), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_HUMANOID, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_STRONG|M2_GREEDY|M2_JEWELS|M2_COLLECT,
	M3_INFRAVISIBLE, HI_DOMESTIC);

    Monsters.AddMonster("samurai", S_HUMAN,
	Monsters.LVL(10, 10, 10, 1, 3), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_HUMANOID, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_STRONG|M2_COLLECT, M3_INFRAVISIBLE, HI_DOMESTIC);

//#ifdef TOURIST
    Monsters.AddMonster("tourist", S_HUMAN,
	Monsters.LVL(10, 10, 10, 1, 0), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_HUMANOID, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_STRONG|M2_COLLECT, M3_INFRAVISIBLE, HI_DOMESTIC);

//#endif
    Monsters.AddMonster("valkyrie", S_HUMAN,
	Monsters.LVL(10, 10, 10, 1, -1), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_HUMANOID, MZ_HUMAN), MR_COLD, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_STRONG|M2_FEMALE|M2_COLLECT, M3_INFRAVISIBLE,
	HI_DOMESTIC);

    Monsters.AddMonster("wizard", S_HUMAN,
	Monsters.LVL(10, 10, 10, 3, 0), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_HUMANOID, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_STRONG|M2_COLLECT|M2_MAGIC, M3_INFRAVISIBLE,
	HI_DOMESTIC);

/*
 * quest leaders
 */
    Monsters.AddMonster("Lord Carnarvon", S_HUMAN,
	Monsters.LVL(20, 12, 0, 30, 20), (G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_LEADER, MZ_HUMAN), 0, 0,
	M1_TUNNEL|M1_NEEDPICK|M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PNAME|M2_PEACEFUL|M2_STRONG|M2_MALE|
	  M2_COLLECT|M2_MAGIC,
	M3_CLOSE|M3_INFRAVISIBLE, HI_LORD);

    Monsters.AddMonster("Pelias", S_HUMAN,
	Monsters.LVL(20, 12, 0, 30, 0), (G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_LEADER, MZ_HUMAN), MR_POISON, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PNAME|M2_PEACEFUL|M2_STRONG|M2_MALE|
	  M2_COLLECT|M2_MAGIC,
	M3_CLOSE|M3_INFRAVISIBLE, HI_LORD);

    Monsters.AddMonster("Shaman Karnov", S_HUMAN,
	Monsters.LVL(20, 12, 0, 30, 20), (G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_LEADER, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PNAME|M2_PEACEFUL|M2_STRONG|M2_MALE|
	  M2_COLLECT|M2_MAGIC,
	M3_CLOSE|M3_INFRAVISIBLE, HI_LORD);

#if 0	/* OBSOLETE */
	/* Two for elves - one of each sex.
	 */
    Monsters.AddMonster("Earendil", S_HUMAN,
	Monsters.LVL(20, 15, 0, 50, -20), (G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_ELF, 350, 0, MS_LEADER, MZ_HUMAN), MR_SLEEP, MR_SLEEP,
	M1_HUMANOID|M1_SEE_INVIS|M1_OMNIVORE,
	M2_NOPOLY|M2_ELF|M2_HUMAN|M2_PNAME|M2_PEACEFUL|M2_STRONG|
	  M2_MALE|M2_COLLECT|M2_MAGIC,
	M3_CLOSE|M3_INFRAVISION|M3_INFRAVISIBLE, HI_LORD);

    Monsters.AddMonster("Elwing", S_HUMAN,
	Monsters.LVL(20, 15, 0, 50, -20), (G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_ELF, 350, 0, MS_LEADER, MZ_HUMAN), MR_SLEEP, MR_SLEEP,
	M1_HUMANOID|M1_SEE_INVIS|M1_OMNIVORE,
	M2_NOPOLY|M2_ELF|M2_HUMAN|M2_PNAME|M2_PEACEFUL|M2_STRONG|
	  M2_FEMALE|M2_COLLECT|M2_MAGIC,
	M3_CLOSE|M3_INFRAVISION|M3_INFRAVISIBLE, HI_LORD);

#endif
    Monsters.AddMonster("Hippocrates", S_HUMAN,
	Monsters.LVL(20, 12, 0, 40, 0), (G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_LEADER, MZ_HUMAN), MR_POISON, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PNAME|M2_PEACEFUL|M2_STRONG|M2_MALE|
	  M2_COLLECT|M2_MAGIC,
	M3_CLOSE|M3_INFRAVISIBLE, HI_LORD);

    Monsters.AddMonster("King Arthur", S_HUMAN,
	Monsters.LVL(20, 12, 0, 40, 20), (G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_LEADER, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PNAME|M2_PEACEFUL|M2_STRONG|M2_MALE|
	  M2_COLLECT|M2_MAGIC,
	M3_CLOSE|M3_INFRAVISIBLE, HI_LORD);

    Monsters.AddMonster("Grand Master", S_HUMAN,
	Monsters.LVL(25, 15, 0, 70, 0), (G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 4, 10), Monsters.ATTK(AT_KICK, AD_PHYS, 2, 8),
	  Monsters.ATTK(AT_MAGC, AD_CLRC, 2, 8), Monsters.ATTK(AT_MAGC, AD_CLRC, 2, 8),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_LEADER, MZ_HUMAN),
	MR_FIRE|MR_ELEC|MR_SLEEP|MR_POISON, 0,
	M1_HUMANOID|M1_SEE_INVIS|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PEACEFUL|M2_STRONG|M2_NASTY|M2_MAGIC,
	M3_CLOSE|M3_INFRAVISIBLE, CLR_BLACK);

    Monsters.AddMonster("Arch Priest", S_HUMAN,
	Monsters.LVL(25, 15, 7, 70, 0), (G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 4,10), Monsters.ATTK(AT_KICK, AD_PHYS, 2, 8),
	  Monsters.ATTK(AT_MAGC, AD_CLRC, 2, 8), Monsters.ATTK(AT_MAGC, AD_CLRC, 2, 8),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_LEADER, MZ_HUMAN),
	MR_FIRE|MR_ELEC|MR_SLEEP|MR_POISON, 0,
	M1_HUMANOID|M1_SEE_INVIS|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PEACEFUL|M2_STRONG|M2_COLLECT|M2_MAGIC,
	M3_CLOSE|M3_INFRAVISIBLE, CLR_WHITE);

    Monsters.AddMonster("Orion", S_HUMAN,
	Monsters.LVL(20, 12, 0, 30, 0), (G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_LEADER, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE|M1_SEE_INVIS|M1_SWIM|M1_AMPHIBIOUS,
	M2_NOPOLY|M2_HUMAN|M2_PNAME|M2_PEACEFUL|M2_STRONG|M2_MALE|
	  M2_COLLECT|M2_MAGIC,
	M3_CLOSE|M3_INFRAVISION|M3_INFRAVISIBLE, HI_LORD);

	/* Note: Master of Thieves is also the Tourist's nemesis.
	 */
    Monsters.AddMonster("Master of Thieves", S_HUMAN,
	Monsters.LVL(20, 15, 0, 30, -20), (G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 6), Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 6),
	  Monsters.ATTK(AT_CLAW, AD_SAMU, 2, 4), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_LEADER, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PEACEFUL|M2_STRONG|M2_MALE|M2_GREEDY|
	  M2_JEWELS|M2_COLLECT|M2_MAGIC,
	M3_CLOSE|M3_INFRAVISIBLE, HI_LORD);

    Monsters.AddMonster("Lord Sato", S_HUMAN,
	Monsters.LVL(20, 15, 0, 30, 20), (G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_LEADER, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PNAME|M2_PEACEFUL|M2_STRONG|M2_MALE|
	  M2_COLLECT|M2_MAGIC,
	M3_CLOSE|M3_INFRAVISIBLE, HI_LORD);

//#ifdef TOURIST
    Monsters.AddMonster("Twoflower", S_HUMAN,
	Monsters.LVL(20, 10, 10, 20, 0), (G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_LEADER, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PNAME|M2_PEACEFUL|M2_STRONG|M2_MALE|
	  M2_COLLECT|M2_MAGIC,
	M3_CLOSE|M3_INFRAVISIBLE, HI_DOMESTIC);

//#endif
    Monsters.AddMonster("Norn", S_HUMAN,
	Monsters.LVL(20, 15, 0, 80, 0), (G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_LEADER, MZ_HUMAN), MR_COLD, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PEACEFUL|M2_STRONG|M2_FEMALE|
	  M2_COLLECT|M2_MAGIC,
	M3_CLOSE|M3_INFRAVISIBLE, HI_LORD);

    Monsters.AddMonster("Wizard of Balance", S_HUMAN,
	Monsters.LVL(20, 12, 0, 60, 0), (G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_LEADER, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PEACEFUL|M2_STRONG|M2_COLLECT|M2_MAGIC,
	M3_CLOSE|M3_INFRAVISIBLE, HI_LORD);

/*
 * quest nemeses
 */
    Monsters.AddMonster("Minion of Huhetotl", S_DEMON,
	Monsters.LVL(16, 10, -2, 75, -14), (G_NOCORPSE|G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 8, 4), Monsters.ATTK(AT_WEAP, AD_PHYS, 4, 6),
	  Monsters.ATTK(AT_MAGC, AD_SPEL, 0, 0), Monsters.ATTK(AT_CLAW, AD_SAMU, 2, 6),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_NEMESIS, MZ_LARGE), MR_FIRE|MR_POISON, 0,
	M1_FLY|M1_SEE_INVIS|M1_POIS,
	M2_NOPOLY|M2_DEMON|M2_STALK|M2_HOSTILE|M2_STRONG|M2_NASTY|M2_COLLECT,
	M3_WANTSARTI|M3_WAITFORU|M3_INFRAVISION|M3_INFRAVISIBLE, CLR_RED);

    Monsters.AddMonster("Thoth Amon", S_HUMAN,
	Monsters.LVL(16, 10, 0, 10, -14), (G_NOGEN|G_UNIQ|G_NOCORPSE),
	Monsters.A(Monsters.ATTK(AT_MAGC, AD_SPEL, 0, 0), Monsters.ATTK(AT_MAGC, AD_SPEL, 0, 0),
	  Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6), Monsters.ATTK(AT_CLAW, AD_SAMU, 1, 4),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_NEMESIS, MZ_HUMAN), MR_POISON, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PNAME|M2_STRONG|M2_MALE|M2_STALK|M2_HOSTILE|
	  M2_NASTY|M2_COLLECT|M2_MAGIC,
	M3_WANTSARTI|M3_WAITFORU|M3_INFRAVISIBLE, HI_LORD);

	/* Multi-headed, possessing the breath attacks of all the other dragons
	 * (selected at random when attacking).
	 */
    Monsters.AddMonster("Chromatic Dragon", S_DRAGON,
	Monsters.LVL(16, 10, 0, 30, -14), (G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_BREA, AD_RBRE, 6, 8), Monsters.ATTK(AT_MAGC, AD_SPEL, 0, 0),
	  Monsters.ATTK(AT_CLAW, AD_SAMU, 2, 8), Monsters.ATTK(AT_BITE, AD_PHYS, 4, 8),
	  Monsters.ATTK(AT_BITE, AD_PHYS, 4, 8), Monsters.ATTK(AT_STNG, AD_PHYS, 1, 6)),
	Monsters.SIZ(WT_DRAGON, 1700, 0, MS_NEMESIS, MZ_GIGANTIC),
	MR_FIRE|MR_COLD|MR_SLEEP|MR_DISINT|MR_ELEC|MR_POISON|MR_ACID|MR_STONE,
	MR_FIRE|MR_COLD|MR_SLEEP|MR_DISINT|MR_ELEC|MR_POISON|MR_STONE,
	M1_THICK_HIDE|M1_NOHANDS|M1_CARNIVORE|M1_SEE_INVIS|M1_POIS,
	M2_NOPOLY|M2_HOSTILE|M2_FEMALE|M2_STALK|M2_STRONG|M2_NASTY|
	  M2_GREEDY|M2_JEWELS|M2_MAGIC,
	M3_WANTSARTI|M3_WAITFORU|M3_INFRAVISIBLE, HI_LORD);

#if 0	/* OBSOLETE */
    Monsters.AddMonster("Goblin King", S_ORC,
	Monsters.LVL(15, 10, 10, 0, -15), (G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 6), Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 6),
	  Monsters.ATTK(AT_CLAW, AD_SAMU, 1, 6), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(750, 350, 0, MS_NEMESIS, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_ORC|M2_HOSTILE|M2_STRONG|M2_STALK|M2_NASTY|M2_MALE|
	  M2_GREEDY|M2_JEWELS|M2_COLLECT|M2_MAGIC,
	M3_WANTSARTI|M3_WAITFORU|M3_INFRAVISION|M3_INFRAVISIBLE, HI_LORD);

#endif
    Monsters.AddMonster("Cyclops", S_GIANT,
	Monsters.LVL(18, 10, 0, 0, -15), (G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 4, 8), Monsters.ATTK(AT_WEAP, AD_PHYS, 4, 8),
	  Monsters.ATTK(AT_CLAW, AD_SAMU, 2, 6), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(1900, 700, 0, MS_NEMESIS, MZ_HUGE), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_GIANT|M2_STRONG|M2_ROCKTHROW|M2_STALK|M2_HOSTILE|
	  M2_NASTY|M2_MALE|M2_JEWELS|M2_COLLECT,
	M3_WANTSARTI|M3_WAITFORU|M3_INFRAVISION|M3_INFRAVISIBLE, CLR_GRAY);

    Monsters.AddMonster("Ixoth", S_DRAGON,
	Monsters.LVL(15, 9, -1, 20, -14), (G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_BREA, AD_FIRE, 8, 6), Monsters.ATTK(AT_BITE, AD_PHYS, 4, 8),
	  Monsters.ATTK(AT_MAGC, AD_SPEL, 0, 0), Monsters.ATTK(AT_CLAW, AD_PHYS, 2, 4),
	  Monsters.ATTK(AT_CLAW, AD_SAMU, 2, 4), NO_ATTK ),
	Monsters.SIZ(WT_DRAGON, 1600, 0, MS_NEMESIS, MZ_GIGANTIC), MR_FIRE, MR_FIRE,
	M1_FLY|M1_THICK_HIDE|M1_NOHANDS|M1_CARNIVORE|M1_SEE_INVIS,
	M2_NOPOLY|M2_PNAME|M2_HOSTILE|M2_STRONG|M2_NASTY|M2_STALK|
	  M2_GREEDY|M2_JEWELS|M2_MAGIC,
	M3_WANTSARTI|M3_WAITFORU|M3_INFRAVISIBLE, CLR_RED);

    Monsters.AddMonster("Master Kaen", S_HUMAN,
	Monsters.LVL(25, 10, -10, 10, -20), (G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 16, 2), Monsters.ATTK(AT_CLAW, AD_PHYS, 16, 2),
	  Monsters.ATTK(AT_MAGC, AD_SPEL, 0, 0), Monsters.ATTK(AT_CLAW, AD_SAMU, 1, 4),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_NEMESIS, MZ_HUMAN), MR_POISON, MR_POISON,
	M1_HUMANOID|M1_HERBIVORE|M1_SEE_INVIS,
	M2_NOPOLY|M2_HUMAN|M2_PNAME|M2_HOSTILE|M2_STRONG|M2_NASTY|
	  M2_STALK|M2_COLLECT|M2_MAGIC,
	M3_WANTSARTI|M3_WAITFORU|M3_INFRAVISIBLE, HI_LORD);

    Monsters.AddMonster("Nalzok", S_DEMON,
	Monsters.LVL(16, 10, -2, 85, -127), (G_NOGEN|G_UNIQ|G_NOCORPSE),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 8, 4), Monsters.ATTK(AT_WEAP, AD_PHYS, 4, 6),
	  Monsters.ATTK(AT_MAGC, AD_SPEL, 0, 0), Monsters.ATTK(AT_CLAW, AD_SAMU, 2, 6),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_NEMESIS, MZ_LARGE), MR_FIRE|MR_POISON, 0,
	M1_FLY|M1_SEE_INVIS|M1_POIS,
	M2_NOPOLY|M2_DEMON|M2_PNAME|M2_HOSTILE|M2_STRONG|M2_STALK|
	  M2_NASTY|M2_COLLECT,
	M3_WANTSARTI|M3_WAITFORU|M3_INFRAVISION|M3_INFRAVISIBLE, CLR_RED);

    Monsters.AddMonster("Scorpius", S_SPIDER,
	Monsters.LVL(15, 10, 10, 0, -15), (G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 2, 6), Monsters.ATTK(AT_CLAW, AD_SAMU, 2, 6),
	  Monsters.ATTK(AT_STNG, AD_DISE, 1, 4), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(750, 350, 0, MS_NEMESIS, MZ_HUMAN), MR_POISON, MR_POISON,
	M1_ANIMAL|M1_NOHANDS|M1_OVIPAROUS|M1_POIS|M1_CARNIVORE,
	M2_NOPOLY|M2_PNAME|M2_HOSTILE|M2_STRONG|M2_STALK|M2_NASTY|
	  M2_COLLECT|M2_MAGIC,
	M3_WANTSARTI|M3_WAITFORU, HI_LORD);

    Monsters.AddMonster("Master Assassin", S_HUMAN,
	Monsters.LVL(15, 15, 0, 30, 18), (G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_DRST, 2, 6), Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 8),
	  Monsters.ATTK(AT_CLAW, AD_SAMU, 2, 6), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_NEMESIS, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_STRONG|M2_HOSTILE|M2_STALK|M2_NASTY|
	  M2_COLLECT|M2_MAGIC,
	M3_WANTSARTI|M3_WAITFORU|M3_INFRAVISIBLE, HI_LORD);

	/* A renegade daimyo who led a 13 year civil war against the shogun
	 * of his time.
	 */
    Monsters.AddMonster("Ashikaga Takauji", S_HUMAN,
	Monsters.LVL(15, 15, 0, 40, -13), (G_NOGEN|G_UNIQ|G_NOCORPSE),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 6), Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 6),
	  Monsters.ATTK(AT_CLAW, AD_SAMU, 2, 6), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_NEMESIS, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PNAME|M2_HOSTILE|M2_STRONG|M2_STALK|
	  M2_NASTY|M2_MALE|M2_COLLECT|M2_MAGIC,
	M3_WANTSARTI|M3_WAITFORU|M3_INFRAVISIBLE, HI_LORD);

#ifdef TOURIST
	/*
	 * Note: the Master of Thieves was defined above.
	 */
#endif
    Monsters.AddMonster("Lord Surtur", S_GIANT,
	Monsters.LVL(15, 12, 2, 50, 12), (G_NOGEN|G_UNIQ),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2,10), Monsters.ATTK(AT_WEAP, AD_PHYS, 2,10),
	  Monsters.ATTK(AT_CLAW, AD_SAMU, 2, 6), NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(2250, 850, 0, MS_NEMESIS, MZ_HUGE), MR_FIRE, MR_FIRE,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_GIANT|M2_MALE|M2_PNAME|M2_HOSTILE|M2_STALK|
	  M2_STRONG|M2_NASTY|M2_ROCKTHROW|M2_JEWELS|M2_COLLECT,
	M3_WANTSARTI|M3_WAITFORU|M3_INFRAVISION|M3_INFRAVISIBLE, HI_LORD);

    Monsters.AddMonster("Dark One", S_HUMAN,
	Monsters.LVL(15, 10, 0, 80, -10), (G_NOGEN|G_UNIQ|G_NOCORPSE),
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6), Monsters.ATTK(AT_MAGC, AD_SPEL, 0, 0),
	  Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6), Monsters.ATTK(AT_CLAW, AD_SAMU, 1, 4),
	  NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_NEMESIS, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_STRONG|M2_HOSTILE|M2_STALK|M2_NASTY|
	  M2_COLLECT|M2_MAGIC,
	M3_WANTSARTI|M3_WAITFORU|M3_INFRAVISIBLE, CLR_BLACK);

/*
 * quest "guardians"
 */
    Monsters.AddMonster("student", S_HUMAN,
	Monsters.LVL(5, 10, 10, 10, 3), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_GUARDIAN, MZ_HUMAN), 0, 0,
	M1_TUNNEL|M1_NEEDPICK|M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PEACEFUL|M2_STRONG|M2_COLLECT, M3_INFRAVISIBLE,
	HI_DOMESTIC);

    Monsters.AddMonster("chieftain", S_HUMAN,
	Monsters.LVL(5, 10, 10, 10, 0), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_GUARDIAN, MZ_HUMAN), MR_POISON, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PEACEFUL|M2_STRONG|M2_COLLECT, M3_INFRAVISIBLE,
	HI_DOMESTIC);

    Monsters.AddMonster("neanderthal", S_HUMAN,
	Monsters.LVL(5, 10, 10, 10, 1), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_GUARDIAN, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PEACEFUL|M2_STRONG|M2_COLLECT, M3_INFRAVISIBLE,
	HI_DOMESTIC);

#if 0	/* OBSOLETE */
    Monsters.AddMonster("High-elf", S_HUMAN,
	Monsters.LVL(5, 12, 10, 10, -7), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 2, 4), Monsters.ATTK(AT_MAGC, AD_CLRC, 0, 0),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_ELF, 350, 0, MS_GUARDIAN, MZ_HUMAN), MR_SLEEP, MR_SLEEP,
	M1_HUMANOID|M1_SEE_INVIS|M1_OMNIVORE,
	M2_NOPOLY|M2_ELF|M2_PEACEFUL|M2_COLLECT,
	M3_INFRAVISION|M3_INFRAVISIBLE, HI_DOMESTIC);

#endif
    Monsters.AddMonster("attendant", S_HUMAN,
	Monsters.LVL(5, 10, 10, 10, 3), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_GUARDIAN, MZ_HUMAN), MR_POISON, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PEACEFUL|M2_STRONG|M2_COLLECT, M3_INFRAVISIBLE,
	HI_DOMESTIC);

    Monsters.AddMonster("page", S_HUMAN,
	Monsters.LVL(5, 10, 10, 10, 3), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_GUARDIAN, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PEACEFUL|M2_STRONG|M2_COLLECT, M3_INFRAVISIBLE,
	HI_DOMESTIC);

    Monsters.AddMonster("abbot", S_HUMAN,
	Monsters.LVL(5, 10, 10, 20, 0), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_CLAW, AD_PHYS, 8, 2), Monsters.ATTK(AT_KICK, AD_STUN, 3, 2),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_GUARDIAN, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PEACEFUL|M2_STRONG|M2_COLLECT, M3_INFRAVISIBLE,
	HI_DOMESTIC);

    Monsters.AddMonster("acolyte", S_HUMAN,
	Monsters.LVL(5, 10, 10, 20, 0), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6), Monsters.ATTK(AT_MAGC, AD_CLRC, 0, 0),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_GUARDIAN, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PEACEFUL|M2_STRONG|M2_COLLECT, M3_INFRAVISIBLE,
	HI_DOMESTIC);

    Monsters.AddMonster("hunter", S_HUMAN,
	Monsters.LVL(5, 12, 10, 10, -7), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 4),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_GUARDIAN, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_SEE_INVIS|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PEACEFUL|M2_STRONG|M2_COLLECT,
	M3_INFRAVISION|M3_INFRAVISIBLE, HI_DOMESTIC);

    Monsters.AddMonster("thug", S_HUMAN,
	Monsters.LVL(5, 10, 10, 10, -3), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_GUARDIAN, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PEACEFUL|M2_STRONG|M2_GREEDY|M2_COLLECT,
	M3_INFRAVISIBLE, HI_DOMESTIC);

    Monsters.AddMonster("ninja", S_HUMAN,
	Monsters.LVL(5, 10, 10, 10, 3), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_HUMANOID, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_HOSTILE|M2_STRONG|M2_COLLECT, M3_INFRAVISIBLE,
	HI_DOMESTIC);

    Monsters.AddMonster("roshi", S_HUMAN,
	Monsters.LVL(5, 10, 10, 10, 3), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_GUARDIAN, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PEACEFUL|M2_STRONG|M2_COLLECT, M3_INFRAVISIBLE,
	HI_DOMESTIC);

//#ifdef TOURIST
    Monsters.AddMonster("guide", S_HUMAN,
	Monsters.LVL(5, 10, 10, 20, 0), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6), Monsters.ATTK(AT_MAGC, AD_SPEL, 0, 0),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_GUARDIAN, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PEACEFUL | M2_STRONG|M2_COLLECT|M2_MAGIC,
	M3_INFRAVISIBLE, HI_DOMESTIC);

//#endif
    Monsters.AddMonster("warrior", S_HUMAN,
	Monsters.LVL(5, 10, 10, 10, -1), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 8),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_GUARDIAN, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PEACEFUL|M2_STRONG|M2_COLLECT, M3_INFRAVISIBLE,
	HI_DOMESTIC);

    Monsters.AddMonster("apprentice", S_HUMAN,
	Monsters.LVL(5, 10, 10, 30, 0), G_NOGEN,
	Monsters.A(Monsters.ATTK(AT_WEAP, AD_PHYS, 1, 6), Monsters.ATTK(AT_MAGC, AD_SPEL, 0, 0),
	  NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(WT_HUMAN, 400, 0, MS_GUARDIAN, MZ_HUMAN), 0, 0,
	M1_HUMANOID|M1_OMNIVORE,
	M2_NOPOLY|M2_HUMAN|M2_PEACEFUL|M2_STRONG|M2_COLLECT|M2_MAGIC,
	M3_INFRAVISIBLE, HI_DOMESTIC);

/*
 * array terminator
 */
    Monsters.AddMonster("", 0,
	Monsters.LVL(0, 0, 0, 0, 0), (0),
	Monsters.A(NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK, NO_ATTK),
	Monsters.SIZ(0, 0, 0, 0, 0), 0, 0, 0L, 0L, 0, 0);
};

#ifdef MONSTER_TEST
int main(void)
{
    seedrand();

    initMonsters();

    return 0;
}
#endif
